namespace ImageResizing

 public class MainDisplay : inherits System.Web.UI.Page

  public sub Page_Load( sender as System.Object, e as System.EventArgs)

  try

    dim _ImgID as System.Int32 : _ImgID = System.Convert.ToInt32( Request.QueryString( "ImgID" ) )

    dim _height as System.Int32 : _height = System.Convert.ToInt32( Request.QueryString("height") )

    dim _width as System.Int32 : _width = System.Convert.ToInt32( Request.QueryString( "width" ) )

    dim Con as new System.Data.SqlClient.SqlConnection( "server=localhost;database=northwind;trusted_connection=true" )

    dim SqlCmd as System.String : SqlCmd = "SELECT * FROM Images WHERE ImageID = @ImageID"

    dim SqlCmdObj as new System.Data.SqlClient.SqlCommand( SqlCmd, Con )

    SqlCmdObj.Parameters.Add("@ImageID", System.Data.SqlDbType.Int).Value = _ImgID

    Con.Open()

    dim SqlReader as System.Data.SqlClient.SqlDataReader : SqlReader = SqlCmdObj.ExecuteReader()

    SqlReader.Read()

    System.Web.HttpContext.Current.Response.ContentType = "image/pjpeg"

    dim _image as System.Drawing.Image : _image = System.Drawing.Image.FromStream( new System.IO.MemoryStream( CType( SqlReader("Image"), System.Byte() ) ) )

    dim _newimage as System.Drawing.Image : _newimage = _image.GetThumbnailImage( _width, _height, nothing, new System.IntPtr())

    _newimage.Save( System.Web.HttpContext.Current.Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg )

   catch  Ex as System.Exception

    System.Web.HttpContext.Current.Trace.Write( Ex.Message.ToString() )

   end try

  end sub

 end class

end namespace