// created on 9/23/2001

namespace UploadSample {

 public class Main : System.Web.UI.Page {

  protected System.Web.UI.HtmlControls.HtmlInputFile UP_FILE;
  protected System.Web.UI.WebControls.TextBox txtDescription;
  protected System.Web.UI.WebControls.Label txtMessage;
  protected System.Int32 FileLength = 0;

  protected void Button_Submit(System.Object sender, System.EventArgs e) {
   System.Web.HttpPostedFile UpFile = UP_FILE.PostedFile;
   FileLength = UpFile.ContentLength;

   try {

    if (FileLength == 0) {

     txtMessage.Text = "<b>* You must pick a file to upload</b>";

    } else {

     System.Byte[] FileByteArray = new System.Byte[FileLength];
     System.IO.Stream StreamObject = UpFile.InputStream;
     StreamObject.Read(FileByteArray,0,FileLength);
     System.Data.OleDb.OleDbConnection Con = new System.Data.OleDb.OleDbConnection("Provider=SQLOLEDB;Data Source=localhost;" +
      "Integrated Security=SSPI;Initial Catalog=northwind");
     System.String SqlCmd = "INSERT INTO Images (Image, ContentType, ImageDescription, ByteSize) VALUES (?, ?, ?, ?)";
     System.Data.OleDb.OleDbCommand OleDbCmdObj = new System.Data.OleDb.OleDbCommand(SqlCmd, Con);
     OleDbCmdObj.Parameters.Add("@Image", System.Data.OleDb.OleDbType.Binary, FileLength).Value = FileByteArray;
     OleDbCmdObj.Parameters.Add("@ContentType", System.Data.OleDb.OleDbType.VarChar,50).Value = UpFile.ContentType;
     OleDbCmdObj.Parameters.Add("@ImageDescription", System.Data.OleDb.OleDbType.VarChar,100).Value = txtDescription.Text;
     OleDbCmdObj.Parameters.Add("@ByteSize", System.Data.OleDb.OleDbType.VarChar,100).Value = UpFile.ContentLength;
     Con.Open();
     OleDbCmdObj.ExecuteNonQuery();
     Con.Close();
     txtMessage.Text = "<p><b>* Your image has been uploaded</b>";

    }

   } catch (System.Exception ex) {

    txtMessage.Text = ex.Message.ToString();

   }
  }
 }
}

