using System;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;

namespace CaseSensitive
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			SqlConnection dbConn = new SqlConnection("server=localhost;uid=sa;pwd=;database=pubs");
			
			// Create a DataAdapter and fill the DataSet
			SqlDataAdapter da = new SqlDataAdapter("SELECT au_fname,au_lname FROM authors",dbConn);
			DataSet ds = new DataSet();
			da.Fill(ds);

			// How many records have found?
			Console.WriteLine("Total number of records found: " + ds.Tables[0].Rows.Count.ToString());

			// Apply a filter without case-sensitive
			Console.WriteLine("\n-=-= Apply a filter without case-sensitive constraint -=-=");
			DataRow[] r = ds.Tables[0].Select("au_fname like 's%'");
			Console.WriteLine("Total number of records found: " + r.Length.ToString());

			// Apply a filter with case-sensitive
			Console.WriteLine("\n-=-= Apply a filter without case-sensitive constraint -=-=");
			ds.CaseSensitive = true;
			r = ds.Tables[0].Select("au_fname like 's%'");
			Console.WriteLine("Total number of records found: " + r.Length.ToString());
		}
	}
}
