Module Module1
    
    Sub Main()
        Dim dbConn As New SqlClient.SqlConnection("server=localhost;uid=sa;pwd=;database=pubs")

        ' Create a DataAdapter and fill the DataSet
        Dim da As New SqlClient.SqlDataAdapter("SELECT au_fname,au_lname FROM authors", dbConn)
        Dim ds As New DataSet()
        da.Fill(ds)

        ' How many records have found?
        Console.WriteLine("Total number of records found: " & ds.Tables(0).Rows.Count.ToString())

        ' Apply a filter without case-sensitive
        Console.WriteLine("")
        Console.WriteLine("-=-= Apply a filter without case-sensitive constraint -=-=")
        Dim r() As DataRow = ds.Tables(0).Select("au_fname like 's%'")
        Console.WriteLine("Total number of records found: " + r.Length.ToString())

        ' Apply a filter with case-sensitive
        Console.WriteLine("")
        Console.WriteLine("-=-= Apply a filter without case-sensitive constraint -=-=")
        ds.CaseSensitive = True
        r = ds.Tables(0).Select("au_fname like 's%'")
        Console.WriteLine("Total number of records found: " + r.Length.ToString())
    End Sub

End Module
