Module Module1
    
    Sub Main()
        ' Open the connection
        Dim dbConn As New SqlClient.SqlConnection("server=localhost;uid=sa;pwd=;database=pubs")

        Try
            ' Create Authors DataTable
            Dim dtAuthors As New DataTable("Authors")

            ' Create a DataAdapter to fill the table
            Dim daAuthors As New SqlClient.SqlDataAdapter("SELECT au_id,au_fname,au_lname,phone,address,city,state,zip,contract FROM authors", dbConn)
            daAuthors.Fill(dtAuthors)

            ' Create a command builder to implement SQL insert command
            ' automatically
            Dim sqlCB As New SqlClient.SqlCommandBuilder(daAuthors)

            ' Create a new row
            Dim drNewAuthor As DataRow
            Dim objNewAuthor(9) As Object

            objNewAuthor(0) = "222-22-2222"
            objNewAuthor(1) = "Fabio Claudio"
            objNewAuthor(2) = "Ferracchiati"
            objNewAuthor(3) = ""
            objNewAuthor(4) = ""
            objNewAuthor(5) = ""
            objNewAuthor(6) = ""
            objNewAuthor(7) = "00100"
            objNewAuthor(8) = 1

            dtAuthors.BeginLoadData()
            drNewAuthor = dtAuthors.LoadDataRow(objNewAuthor, False)
            dtAuthors.EndLoadData()

            ' Update the database records
            daAuthors.Update(dtAuthors)

            ' Accept DataTable changes
            dtAuthors.AcceptChanges()

        Catch e As Exception
            Console.WriteLine(e.Message)

        End Try
    End Sub
    
End Module
