using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

namespace Chapter07.Exam
{
	public class DB
	{
		// ߰ǰų   DB ߰ ޼ҵ
		public void EnterContent(DateTime dtDate, string strNote)
		{
			string sql = "select * from tbDailyPlan where rtDate='"+ 
				dtDate.ToString().Substring(0,10) +"'";
			SqlConnection myConnection = 
				new SqlConnection(
				ConfigurationSettings.AppSettings["ConnectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);
				
			myConnection.Open();
			SqlDataReader rowExist = myCommand.ExecuteReader();
			// ¥  ̹ ϸ Update
			if (rowExist.Read()) 
			{
				sql = "UPDATE tbDailyPlan SET " + 
					"rtDate='" + dtDate.ToString().Substring(0,10) + "'," +
					"rtNote='" + strNote.Replace("'", "''") + "' " +
					"WHERE rtDate='" + dtDate.ToString().Substring(0,10) + "'";
			}
			else
			{	// ƴϸ Insert
				sql = "INSERT INTO tbDailyPlan " + 
					"(rtDate,rtNote) VALUES (" +
					"'" + dtDate.ToString().Substring(0,10) + "'," +
					"'" + strNote.Replace("'", "''") + "'" +
					")";
			}

			rowExist.Close();
			myCommand.CommandText = sql;
			myCommand.ExecuteNonQuery(); 
			myConnection.Close();
		}

		//ڷ Ѿ ¥  Ѵ.
		public SqlDataReader GetDateContent(DateTime dtDate)
		{
			string sql = "Select *  From tbDailyPlan " + 
							"where rtDate=@dtDate";
			SqlConnection myConnection = 
				new SqlConnection(
				ConfigurationSettings.AppSettings["ConnectionString"]);
			SqlCommand myCommand = new SqlCommand(sql, myConnection);

			SqlParameter parameterDate = 
				new SqlParameter("@dtDate", SqlDbType.DateTime);
			parameterDate.Value = dtDate;
			myCommand.Parameters.Add(parameterDate);

			myConnection.Open();
			SqlDataReader result = 
				myCommand.ExecuteReader(CommandBehavior.CloseConnection);
            
			return result;
		}

		//ڷ ѿ ¥     ´.
		public SqlDataReader ReadMonthList(DateTime dtDate)
		{
			DateTime startDate, endDate;

			string sqlList = "Select * From tbDailyPlan " + 
				"where rtDate>=@startDate and rtDate<=@endDate " + 
				"Order By rtDate";
			SqlConnection myConnection = 
				new SqlConnection(
				ConfigurationSettings.AppSettings["ConnectionString"]);
			SqlCommand myCommand = 
				new SqlCommand(sqlList, myConnection);

			startDate = GetStartDate(dtDate);
			endDate = GetEndDate(dtDate);

			SqlParameter parameterStartDate = 
				new SqlParameter("@startDate", SqlDbType.DateTime);
			parameterStartDate.Value = startDate;
			myCommand.Parameters.Add(parameterStartDate);

			SqlParameter parameterEndDate = 
				new SqlParameter("@endDate", SqlDbType.DateTime);
			parameterEndDate.Value = endDate;
			myCommand.Parameters.Add(parameterEndDate);

			myConnection.Open();
			SqlDataReader result = 
				myCommand.ExecuteReader(CommandBehavior.CloseConnection);

			return result;
		}

		private DateTime GetStartDate(DateTime dtDate)
		{
			
			if (dtDate.Month == 1) //1̸  12
				//޷¿ ޷ ǥõ ִ ִ 6̹Ƿ
				return new DateTime(dtDate.Year-1, 12, 
					DateTime.DaysInMonth(dtDate.Year-1,12)-5);
			else
				//⵵  6ش.
				return new DateTime(dtDate.Year, dtDate.Month-1, 
					DateTime.DaysInMonth(dtDate.Year,dtDate.Month-1)-5);
		}

		private DateTime GetEndDate(DateTime dtDate)
		{
			if (dtDate.Month == 12) //12̸  1
				//޷¿ ޷ ǥõ ִ ִ 6̹Ƿ
				return new DateTime(dtDate.Year+1, 1, 6);
			else
				//⵵  6 ش.
				return new DateTime(dtDate.Year, dtDate.Month+1, 6);
		}
	}
}
