namespace Chapter07.Exam
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Web.UI.WebControls;
	using System.Web.UI;

	public abstract class DailyPlan1 : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.Calendar Calendar1;

		private DateTime[] rtDate = new DateTime[43]; //31 + (6 * 2) = 43
		private string[] rtNote = new string[43];
		private string _MessageBoxID;
		private string _InputBoxID;
		InputNote _oIN = null;

		//ũƮ µ  ޼ ڽ ID
		public string MessageBoxID
		{
			get	{return _MessageBoxID;}
			set	{_MessageBoxID = value;}
		}

		// Էϴ  Ʈ ġ ̳ Ʈ ID
		public string InputBoxID
		{
			get	{return _InputBoxID;}
			set	{_InputBoxID = value;}
		}

		// Էϴ Ʈ Ȱȭ  Ÿ.
		public bool IsInput
		{
			get
			{
				object o = ViewState["IsInput"];
				//o   false ϵ
				return o == null ? false : (bool)o;
			}
			set	{ViewState["IsInput"] = value;}
		}

		//õ ڸ ܺη ˸ б Ƽ
		public DateTime SelectedDate
		{
			get	{return Calendar1.SelectedDate;}
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				//DBó    ʱȭ
				Calendar1.VisibleDate = DateTime.Today;
			}
			else
			{
				//Էâ  ̸ IsInput true̴
				//Էâ   true ̴
				if (IsInput)
				{
					//InputBoxID  ID Ʈ ã´.
					Control oCon = Page.FindControl(InputBoxID);
					//Ʈ ε־ ư ̺Ʈ ߻Ѵ.
					_oIN = (InputNote)LoadControl("InputNote.ascx");
					//InputNote Ʈѿ  Ʈ ϱ  
					_oIN.HostRef = this;
					_oIN.ID = "_DailyInput";
					oCon.Controls.Add(_oIN);
					IsInput = false;
				}
			}
		}

		//DB    迭 Ѵ.
		private void LoadMonthData(DateTime dtDate)
		{
			DB oDB = new DB();
			SqlDataReader drList = oDB.ReadMonthList(dtDate);
			int intIndex = 0;

			//迭 ʱȭ
			rtDate.Initialize();
			rtNote.Initialize();
			while (drList.Read())
			{
				rtDate[intIndex] = drList.GetDateTime(0);
				if (drList.IsDBNull(1)) rtNote[intIndex] = null;
				else rtNote[intIndex] = drList.GetString(1);
				intIndex++;
			}
		}

		private void Page_PreRender(object sender, System.EventArgs e)
		{
			//Load ƴ PreRender ͸ ´.
			LoadMonthData(Calendar1.VisibleDate);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
			this.Calendar1.DayRender += new System.Web.UI.WebControls.DayRenderEventHandler(this.Calendar1_DayRender);
			this.Calendar1.VisibleMonthChanged += new System.Web.UI.WebControls.MonthChangedEventHandler(this.Calendar1_VisibleMonthChanged);
			this.Calendar1.SelectionChanged += new System.EventHandler(this.Calendar1_SelectionChanged);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);
		}
		#endregion

		private void Calendar1_SelectionChanged(object sender, System.EventArgs e)
		{
			bool bIsLoaded;

			//Page_Load ̹ εǾ ߺε ʴ´.
			if (_oIN == null)
			{
				_oIN = (InputNote)LoadControl("InputNote.ascx");
				_oIN.ID = "_DailyInput";
				bIsLoaded = false;
			}
			else 
				bIsLoaded = true;

			DB oDB = new DB();
			SqlDataReader drContent = 
				oDB.GetDateContent(Calendar1.SelectedDate);
			if (drContent.Read())
				_oIN.txtNote.Text = drContent.GetString(1);
			else
				_oIN.txtNote.Text = "";
			
			_oIN.HostRef = this;
			_oIN.Visible = true;
			// ߰ Ʈ  ߰Ѵ.
			if (!bIsLoaded)
				this.Parent.FindControl(InputBoxID).Controls.Add(_oIN);
			IsInput = true;
		}

		//īٿ ¥ ׷  ̺Ʈ ߻Ѵ.
		private void Calendar1_DayRender(object sender, System.Web.UI.WebControls.DayRenderEventArgs e)
		{
			int intDay = e.Day.Date.Day;
			//rtDate 迭  ׷ ¥ ִ ˻
			int intIndex = Array.IndexOf(rtDate, e.Day.Date);
			string Note = "";
			// õ  ƴϸ 
			if (e.Day.IsOtherMonth) return;

			//׷ ¥  
			if (intIndex != -1)
			{
				if (rtNote[intIndex] != null)  
					Note = rtNote[intIndex].Replace("\n","<br>");
			}
			else
				Note = " ";

			//콺 ö  e.Day.Date.Day 
			//µǵ ũƮ Ѵ
			string strDiv = "<div width=\"100%\" " + 
				"onmouseover=\"javascript:makeCursorHand(this);" + 
				"showHide(" + e.Day.Date.Day.ToString() + ")\" " + 
				"onmouseout=\"javascript:showHide(0)\">";
			e.Cell.Controls.AddAt(0, new LiteralControl(strDiv));
			strDiv = "</div><div id=div_" + intDay.ToString() + 
				" style=\"display:none\">" + Note + "</div>";
			//  ũ ߰
			e.Cell.Controls.Add(new LiteralControl(strDiv));

			//    ٲش.
			if (Note != " ")
				e.Cell.BackColor = 
					System.Drawing.Color.Chartreuse;
		}

		private void Calendar1_VisibleMonthChanged(object sender, System.Web.UI.WebControls.MonthChangedEventArgs e)
		{
			// ٲ Է Ʈ Ȱȭ Ų.
			IsInput = false;
			if (_oIN != null)
				_oIN.Visible = false;
		}
	}
}
