using System;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI.WebControls;

using MemoDb;

namespace Chapter12.Ex07
{
	public class Chap12_Ex07 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button btnAdd;
		protected System.Web.UI.WebControls.TextBox txtContent;
		protected System.Web.UI.WebControls.DataGrid DataGrid1;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
				BindGrid();
		}

		protected void BindGrid()
		{
			MemoDB_nTx memoDb_ntx = new MemoDB_nTx();
			DataSet ds = memoDb_ntx.GetList();
			DataGrid1.DataSource = ds.Tables[0].DefaultView;
			DataGrid1.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
			this.DataGrid1.CancelCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_CancelCommand);
			this.DataGrid1.EditCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_EditCommand);
			this.DataGrid1.UpdateCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_UpdateCommand);
			this.DataGrid1.DeleteCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_DeleteCommand);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void DataGrid1_EditCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			DataGrid1.EditItemIndex = e.Item.ItemIndex;
			BindGrid();
		}

		private void DataGrid1_UpdateCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			int keyField = Convert.ToInt32(DataGrid1.DataKeys[e.Item.ItemIndex].ToString());
		
			MemoDB_Tx memoDb_tx = new MemoDB_Tx();
			memoDb_tx.UpdateMemo(keyField, ((TextBox)e.Item.Cells[1].Controls[0]).Text);

			DataGrid1.EditItemIndex = -1;
			BindGrid();
		}

		private void DataGrid1_CancelCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			DataGrid1.EditItemIndex = -1;
			BindGrid();
		}

		private void DataGrid1_DeleteCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			int keyField = Convert.ToInt32(DataGrid1.DataKeys[e.Item.ItemIndex].ToString());
		
			MemoDB_Tx memoDb_tx = new MemoDB_Tx();
			memoDb_tx.DeleteMemo(keyField);

			DataGrid1.EditItemIndex = -1;
			BindGrid();
		}

		private void btnAdd_Click(object sender, System.EventArgs e)
		{
			MemoDB_Tx memoDb_tx = new MemoDB_Tx();
			memoDb_tx.InsertMemo(txtContent.Text);
			txtContent.Text = "";

			DataGrid1.EditItemIndex = -1;
			BindGrid();
		}
	}
}
