using System;
using System.Web;

namespace HTTPModules.Ex02
{
	public class LogEvent : IHttpModule
	{
		public delegate void _endRequest(object sender, EventArgs e);
		public event _endRequest EndRequest;

		private HttpApplication _application;

		public void Init(System.Web.HttpApplication application)
		{
			application.BeginRequest += new System.EventHandler(beginRequest);
			application.EndRequest += new System.EventHandler(endRequest);
			_application = application;
		}

		public void beginRequest(object sender, EventArgs e)
		{
			_application.Response.Write("beginRequest : HTTP  ȿ<br>");
		}

		public void endRequest(object sender, EventArgs e)
		{
			if (EndRequest != null)
				EndRequest(this, e);
		}

		public void Dispose()
		{
		}
	}
}