using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter19.Ex12
{
	public class Chap19_Ex12 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.RadioButtonList RadioButtonList1;
		protected System.Web.UI.WebControls.DropDownList DropDownList1;
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
	
		//DataGrid1_ItemDataBound ޼ҵ忡
		//ʵ ̸    Ѵ.
		string[] fieldName = new string[] {"author","price","page","publishDate"};
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				//DataGrid Ʈѿ ø ÷ ´.
				TemplateColumn tc = (TemplateColumn)DataGrid1.Columns[1];
				//TemplateHorizontal.ascx  ø Ѵ.
				tc.ItemTemplate = Page.LoadTemplate("TemplateHorizontal.ascx");
				//TemplateHorizontalHeader.ascx ش ø Ѵ.
				tc.HeaderTemplate = Page.LoadTemplate("TemplateHorizontalHeader.ascx");
				DataGrid1.DataSource = GetData();
				DataGrid1.DataBind();
			}
		}

		private SqlDataReader GetData()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select * from tbDataPresentation2";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = null;

			dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		// ޼ҵ Button1_Click ޼ҵ忡 
		//DataGrid1 ItemDataBound ̺Ʈ ڵ鷯
		// ɶ ߻Ѵ.
		//LoadTemplate ޼ҵ带 ̿ ø  
		//εҶ  ʰ
		//DataGridTemplate Ŭ ̿ 
		//ø Ҷ ̿ȴ.
		private void DataGrid1_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			ListItemType itemType = e.Item.ItemType;
			if ((itemType == ListItemType.Item) || 
				(itemType == ListItemType.AlternatingItem)) 
			{
				//DropDownList1.SelectedItem.Value  
				//Ϸ ʵ ټ̴.
				for (int i=0; i<int.Parse(DropDownList1.SelectedItem.Value); i++)
				{
					//DataGridTemplate ü InstantiateIn
					//޼ҵ忡   ID 
					//"colValue" + i  Ʈ ´.
					Literal lc = (Literal)e.Item.Cells[1].FindControl("colValue" + i);
					DbDataRecord dataRecord = (DbDataRecord)e.Item.DataItem;
					//fieldName[i] شϴ ʵ  
					lc.Text = dataRecord[fieldName[i]].ToString();
				}
			}
		}

		private void Button1_Click(object sender, System.EventArgs e)
		{
			ITemplate templateItem = null;
			ITemplate templateHeader = null;

			switch (RadioButtonList1.SelectedItem.Value)
			{
				//  ø ε
				case "1":
					templateItem = Page.LoadTemplate("TemplateHorizontal.ascx");
					templateHeader = Page.LoadTemplate("TemplateHorizontalHeader.ascx");
					break;
				//  ø ε
				case "2":
					templateItem = Page.LoadTemplate("TemplateVertical.ascx");
					templateHeader = Page.LoadTemplate("TemplateVerticalHeader.ascx");
					break;
				//ø  
				case "3":
					// ø Ѵ.
					//DropDownList1.SelectedItem.Value 
					// ʵ ̴.
					templateItem = new DataGridTemplate(
						ListItemType.Item, DropDownList1.SelectedItem.Value);
					//ش ø Ѵ.
					templateHeader = new DataGridTemplate(
						ListItemType.Header, DropDownList1.SelectedItem.Value);
					//ItemDataBound ̺Ʈ ڵ鷯 
					this.DataGrid1.ItemDataBound += new DataGridItemEventHandler(
						this.DataGrid1_ItemDataBound);
					break;
			}

			//DataGrid Ʈѿ ø ÷ ´.
			TemplateColumn tc = (TemplateColumn)DataGrid1.Columns[1];
			// switch  εϰų  ø
			//۰ ش ø Ѵ.
			tc.ItemTemplate = templateItem;
			tc.HeaderTemplate = templateHeader;
			DataGrid1.DataSource = GetData();
			DataGrid1.DataBind();
		}
	}

	public class DataGridTemplate : ITemplate
	{
		//ø  - Item Ǵ Header
		ListItemType _templateType;
		// ʵ ټ
		int _columnCount;
		//µ ʵ  迭
		string[] colTitle = new string[] {" : "," : "," : "," : "};

		//
		public DataGridTemplate(ListItemType type, string count)
		{
			_templateType = type;
			_columnCount = int.Parse(count);
		}

		//container ø ÷ Ÿ
		//TableCell ü̴.
		public void InstantiateIn(System.Web.UI.Control container)
		{
			Literal lc = null;

			switch( _templateType )
			{
				case ListItemType.Header:
					lc = new Literal();
					lc.Text = "( ø) - ÷ :" + _columnCount + "";
					container.Controls.Add(lc);
					break;
				case ListItemType.Item:
					for (int i=0; i<_columnCount; i++)
					{
						//÷ 
						lc = new Literal();
						lc.Text = colTitle[i];
						container.Controls.Add(lc);

						// ü Text Ӽ ItemDataBound 
						//DataItem Ӽ ̿  ʵ 
						// ȴ.
						lc = new Literal();
						//FindControl ޼ҵ忡 ˻  ID
						lc.ID = "colValue" + i;
						container.Controls.Add(lc);

						// ÷ ƴϸ <br> ߰Ѵ.
						if(_columnCount-1 > i)
						{
							lc = new Literal();
							lc.Text = "<br>";
							container.Controls.Add(lc);
						}
					}
					break;
			}
		}
	}
}
