<%@ Page language="c#" Codebehind="MultiSelect.aspx.cs" AutoEventWireup="false" Inherits="Chapter19.MultiSelect" %>
<HTML>
	<HEAD>
		<title>MultiSelect</title>
	</HEAD>
	<body>
		<form id="MultiSelect" method="post" runat="server">
			<asp:datagrid id="DataGrid1" runat="server" AllowSorting="True" AutoGenerateColumns="False">
				<AlternatingItemStyle BackColor="#AEBEA2"></AlternatingItemStyle>
				<ItemStyle Font-Size="11pt"></ItemStyle>
				<HeaderStyle Font-Size="Small" Font-Bold="True" ForeColor="White" BackColor="Green"></HeaderStyle>
				<Columns>
					<asp:TemplateColumn HeaderText="">
						<HeaderTemplate>
							<asp:LinkButton id="lnkbtnCheckSelected" runat="server" CommandName="CheckSelected">##</asp:LinkButton>
						</HeaderTemplate>
						<ItemTemplate>
							<asp:CheckBox id="chkboxSelect" runat="server"></asp:CheckBox>
						</ItemTemplate>
					</asp:TemplateColumn>
					<asp:BoundColumn DataField="id" SortExpression="id" HeaderText="ID"></asp:BoundColumn>
					<asp:BoundColumn DataField="title" HeaderText=""></asp:BoundColumn>
					<asp:TemplateColumn SortExpression="price" HeaderText="">
						<HeaderTemplate>
							<b></b>
						</HeaderTemplate>
						<ItemTemplate>
							<B>:</B>
							<%# DataBinder.Eval(Container.DataItem, "author" ) %>
							<BR>
							<B>:</B>
							<%# DataBinder.Eval(Container.DataItem, "price", "{0:c}" ) %>
							<BR>
							<B>:</B>
							<%# DataBinder.Eval(Container.DataItem, "page") %>
							<BR>
							<B>:</B>
							<%# DataBinder.Eval(Container.DataItem, "publishDate", "{0:yyyy-MM-dd}" ) %>
							<BR>
							<B>:</B>
							<BR>
							<BLOCKQUOTE><%# DataBinder.Eval(Container.DataItem, "Description") %></BLOCKQUOTE>
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:datagrid>
		</form>
	</body>
</HTML>
