using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Validators
{
	/// <summary>
	/// SimpleRequiredFieldValidator   Դϴ.
	/// </summary>
	[DefaultProperty("Text"), 
		ToolboxData("<{0}:SimpleRequiredFieldValidator runat=server></{0}:SimpleRequiredFieldValidator>")]
	public class SimpleRequiredFieldValidator : System.Web.UI.WebControls.WebControl
	{
		private string text;
	
		[Bindable(true), 
			Category("Appearance"), 
			DefaultValue("")] 
		public string Text 
		{
			get
			{
				return text;
			}

			set
			{
				text = value;
			}
		}

		/// <summary> 
		///  Ʈ   Ű  մϴ.
		/// </summary>
		/// <param name="output">   HTML ۼ </param>
		protected override void Render(HtmlTextWriter output)
		{
			output.Write(Text);
		}
	}
}
