namespace PowerOfDotNet.Clubs
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		ClubCreate   Դϴ.
	/// </summary>
	public abstract class ClubCreate : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.DropDownList drpdnlstClass;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstPublicType;
		protected System.Web.UI.WebControls.TextBox txtClubName;
		protected System.Web.UI.WebControls.TextBox txtIntro;
		protected System.Web.UI.WebControls.Button btnCancel;
		protected System.Web.UI.WebControls.PlaceHolder placehdrInput;
		protected System.Web.UI.WebControls.PlaceHolder placehdrSuccessMessage;
		protected System.Web.UI.WebControls.Button btnToClubMain;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator3;
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;
		protected System.Web.UI.WebControls.Button btnSubmit;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
				SqlDataReader dr = db.GetClubsClass();
				drpdnlstClass.DataSource = dr;
				drpdnlstClass.DataTextField = "Name";
				drpdnlstClass.DataValueField = "ID";
				drpdnlstClass.DataBind();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnToClubMain.Click += new System.EventHandler(this.btnToClubMain_Click);
			this.btnSubmit.Click += new System.EventHandler(this.btnSubmit_Click);
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnSubmit_Click(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			int newClub = db.CreateNewClub(txtClubName.Text, Convert.ToInt32(drpdnlstClass.SelectedItem.Value), 
				(byte)rdobtnlstPublicType.SelectedIndex, Page.User.Identity.Name, txtIntro.Text);
			if (newClub == -1)
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" ̸ Ŭ ̹ մϴ.");
			else if (newClub == -2)
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("Ŭ  ߽ϴ.");
			else {
				placehdrInput.Visible = false;
				placehdrSuccessMessage.Visible = true;
			}
		}

		private void btnCancel_Click(object sender, System.EventArgs e)
		{
			Response.Redirect(GetLink("Ŭ"));
		}

		private void btnToClubMain_Click(object sender, System.EventArgs e)
		{
			Response.Redirect(GetLink("Ŭ"));
		}
	}
}
