using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace PowerOfDotNet.Clubs
{
	/// <summary>
	/// WaitingUserList   Դϴ.
	/// </summary>
	public class WaitingUserList : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid datgrdWaitingUsers;

		protected int _clubId;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			_clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);
			if (!IsPostBack) {
				
				PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
				SqlDataReader dr = db.GetClub(_clubId);
				dr.Read();
				string sysopId = dr["SysopID"].ToString();
				if (!(sysopId == Page.User.Identity.Name)) {
					MyWebLibs.Utilities.CommonMethods.PrintMsgAndClose("û ̿ ִ  Դϴ.");
					return;
				}
				BindData();
			}
		}

		private void BindData()
		{
			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			DataSet ds = db.GetWaitingUsers(_clubId);
			datgrdWaitingUsers.DataSource = ds.Tables[0].DefaultView;
			datgrdWaitingUsers.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.datgrdWaitingUsers.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdWaitingUsers_ItemCommand);
			this.datgrdWaitingUsers.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.datgrdWaitingUsers_PageIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void datgrdWaitingUsers_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			datgrdWaitingUsers.CurrentPageIndex = e.NewPageIndex;
			BindData();
		}

		private void datgrdWaitingUsers_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			string arg = e.CommandArgument.ToString();
			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			db.UserAgreement(_clubId, arg);

			DataSet ds = db.GetWaitingUsers(_clubId);
			datgrdWaitingUsers.DataSource = ds.Tables[0].DefaultView;
			datgrdWaitingUsers.DataBind();
		}
	}
}
