Imports System
Imports System.Data

Namespace MyDalApp

	Public Class UniversalDAL
	
		'Return a DataReader object that inherits from IDataReader
		Public Function GetData(con As IDbConnection, commandText As string) As IDataReader
		
			'Create a Command object that inherits from IDbCommand
			Dim cmd As IDbCommand = con.CreateCommand()
			'Set the CommandText to the value passed in
			cmd.CommandText = commandText
			'Open the connection
			Try
					con.Open()
			Catch
				'Connection is invalid or already open
			End Try
			'Return the results from ExecuteReader()
			return cmd.ExecuteReader()
		End Function
	End Class
End Namespace