<%@ Import namespace="PowerOfDotNet.Components" %>
<%@ Import Namespace="PowerOfDotNet" %>
<%@ Control CodeBehind="DesktopPortalBanner.ascx.cs" Language="c#" AutoEventWireup="false" Inherits="PowerOfDotNet.DesktopPortalBanner" %>
<%--

   The DesktopPortalBanner User Control is responsible for displaying the standard Portal
   banner at the top of each .aspx page.

   The DesktopPortalBanner uses the Portal Configuration System to obtain a list of the
   portal's sitename and tab settings. It then render's this content into the page.

--%>
<table class="HeadBg" cellSpacing="0" width="100%" border="0">
	<tr vAlign="top">
		<td class=SiteLink align=right 
    background="<%= Request.ApplicationPath %>/images/bars.gif" colSpan=3 
    ><asp:label id="WelcomeMessage" runat="server" forecolor="#eeeeee"></asp:label>&nbsp;
		</td>
	</tr>
	<tr>
		<td width="10" rowSpan="2">&nbsp;
		</td>
		<td height="40"><asp:label id="siteName" runat="server" EnableViewState="false" CssClass="SiteTitle"></asp:label></td>
		<td align="center" rowSpan="2"><a href="http://www.asp.net"></a>&nbsp;</td>
	</tr>
	<tr>
		<td><asp:datalist id="tabs" runat="server" EnableViewState="false" ItemStyle-BorderWidth="1" SelectedItemStyle-CssClass="TabBg"
				ItemStyle-Height="25" repeatdirection="horizontal" cssclass="OtherTabsBg">
				<ItemTemplate>
					&nbsp;<a href='/DesktopDefault.aspx?psup=tabindex=<%# Container.ItemIndex %>:tabid=<%# ((TabStripDetails) Container.DataItem).TabId %>:targetid=0' class="OtherTabs"><%# ((TabStripDetails) Container.DataItem).TabName %></a>&nbsp;
				</ItemTemplate>
				<SelectedItemTemplate>
					&nbsp;<span class="SelectedTab"><%# ((TabStripDetails) Container.DataItem).TabName %></span>&nbsp;
				</SelectedItemTemplate>
			</asp:datalist></td>
	</tr>
</table>
