/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.Home
{
	using System;
	using System.IO;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Text.RegularExpressions;
	using System.Collections;
	using System.Web.Security;
	using MyWebLibs.Utilities;

	/// <summary>
	///		Joining   Դϴ.
	/// </summary>
	public abstract class Joining : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.TextBox txtPassword;
		protected System.Web.UI.WebControls.TextBox txtPasswordConfirm;
		protected System.Web.UI.WebControls.TextBox txtEmail;
		protected System.Web.UI.WebControls.TextBox txtJoomin1;
		protected System.Web.UI.WebControls.TextBox txtJoomin2;
		protected System.Web.UI.WebControls.DropDownList drpdnlstYear;
		protected System.Web.UI.WebControls.DropDownList drpdnlstDay;
		protected System.Web.UI.WebControls.DropDownList drpdnlstMonth;
		protected System.Web.UI.WebControls.TextBox txtZip1;
		protected System.Web.UI.WebControls.TextBox txtZip2;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator3;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator4;
		protected System.Web.UI.WebControls.CompareValidator CompareValidator1;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidator2;
		protected System.Web.UI.WebControls.CustomValidator CustomValidator2;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator7;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator8;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator9;
		protected System.Web.UI.WebControls.TextBox txtPhone;
		protected System.Web.UI.WebControls.TextBox txtName;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnUserIDDupCheck;
		protected System.Web.UI.WebControls.Button btnSubmit;
		protected System.Web.UI.WebControls.TextBox txtUserID;
		protected System.Web.UI.WebControls.CompareValidator CompareValidatorUserID;
		protected System.Web.UI.WebControls.TextBox txtAddress1;
		protected System.Web.UI.WebControls.TextBox txtAddress2;
		protected System.Web.UI.WebControls.RequiredFieldValidator Requiredfieldvalidator5;

		private string joiningWebServiceBehaviorScript = @"
<script language=""javascript"">
	<!--
		var iCallID;
		var processedID, processedDong;
		var dongInputEntered = false;

		function _CallIDDupCheck(inputID)
		{{
			if (document.getElementById('{1}').value == """")
			{{
				alert(""˻ϱ ϴ ID Էϼ~~"");
				return;
			}}
			document.getElementById('marqeeIdCheckWaitMag').style.display = """";
			iCallID = joiningWebService.JoiningService.callService(_UserIDCheckResults, ""IDDuplicationCheck"", inputID);
			processedID = inputID;
		}}

		function _CallIZipAddrs(inputDong)
		{{
			//alert(inputDong);
			inputDong = inputDong + '';
			if (document.getElementById('txtInputDong').value == """")
			{{
				alert(""˻ϱ ϴ ,, ̸ Էϼ~~"");
				return;
			}}
			document.getElementById('searchedAddrsTR').style.display = """";
			document.getElementById('marqeeWaitMag').style.display = """";
			iCallID = joiningWebService.JoiningService.callService(_ZipAddrsResults, ""GetZipAddrs"", inputDong);
			processedDong = inputDong;
		}}

		function _UserIDCheckResults(result)
		{{
			if(result.error)
			{{
				var xfaultcode   = result.errorDetail.code;
				var xfaultstring = result.errorDetail.string;
				var xfaultsoap   = result.errorDetail.raw;
				alert(""! : "" + xfaultcode + ""  "" + xfaultstring);
			}}
			else
			{{
				document.getElementById('marqeeIdCheckWaitMag').style.display = ""none"";
				if (result.value)
				{{
					alert(""̹  ID Դϴ."");
					
					var comObj = document.getElementById('{0}');
					comObj.valuetocompare = processedID;

				}}
				else
				{{
					alert(""밡 IDԴϴ."");
					var comObj = document.getElementById('{0}');
					comObj.valuetocompare = """";
				}}
			}}
		}}

		function _ZipAddrsResults(result)
		{{
			if(result.error)
			{{
				var xfaultcode   = result.errorDetail.code;
				var xfaultstring = result.errorDetail.string;
				var xfaultsoap   = result.errorDetail.raw;
				alert(""! : "" + xfaultcode + ""  "" + xfaultstring);
			}}
			else
			{{
				//alert(result.value.length);

				var oSel = document.getElementById('selSearchedAddrs');
				//for (i=1; i<=oSel.options.length; i++)
				for (i=oSel.options.length; i>=1; i--)
				{{
					oSel.options[i] = null;
				}}

				if (result.value.length > 0)
				{{
					oSel.options[0] = new Option('------ּҸ ϼ------','');
					var aTemp;
					for (i=1; i<=result.value.length; i++)
					{{
						aTemp = result.value[i-1].split(""$"");
						oSel.options[i] = new Option(aTemp[1],aTemp[0]);
					}}
					oSel.disabled = false;
				}}
				else
				{{
					oSel.options[0] = new Option('------˻ ּҰ ϴ.------','');
					alert('˻ ּҰ ϴ.');
					oSel.disabled = true;
				}}

				oSel.style.display = """";
				document.getElementById('marqeeWaitMag').style.display = ""none"";
			}}
		}}

		function _joiningWebServiceInit()
		{{
			joiningWebService.useService(""./WebServices/Joining.asmx?WSDL"",""JoiningService"");
		}}

		function _selectSearchedAddrs()
		{{
			var oSel = document.getElementById('selSearchedAddrs');
			if (oSel.selectedIndex < 1) 
				return;
			var val = oSel.options[oSel.selectedIndex].value;
			var address = oSel.options[oSel.selectedIndex].text;
			var aZip = val.split(""-"");
			document.getElementById('{2}').value = address;
			document.getElementById('{3}').value = aZip[0];
			document.getElementById('{4}').value = aZip[1];
			document.getElementById('{5}').focus();
		}}
	//-->
</script>
";
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;
		protected System.Web.UI.WebControls.Image imgTitleImage;

		
		private string joiningJoominCheckScript = @"
<SCRIPT LANGUAGE=""JavaScript"">
<!--
var m_joomin1;
var m_joomin2;
var m_prevResult = false;

function _CheckJoominNum(num1, num2)    
{{
	//alert(num1 + "" "" + m_joomin1 + "" "" + num2 + "" "" + m_joomin2)
	//alert(m_prevResult)
	if (num1 == m_joomin1 && num2 == m_joomin2)
		return m_prevResult;

	m_joomin1 = num1;
	m_joomin2 = num2;
	//alert(num1 + "" "" + m_joomin1 + "" "" + num2 + "" "" + m_joomin2)
	var regExpr1 = /^[0-9]{{6}}$/;
	var regExpr2 = /^[0-9]{{7}}$/;

	// ο ̸ ˻
	if (!regExpr1.test(num1) || !regExpr2.test(num2)) 
		return false;

    var intYear = parseInt(num1.substring(0,2), 10);
    var intMonth = parseInt(num1.substring(2,4), 10);
    var intDay = parseInt(num1.substring(4,6), 10);

	// 
	if(num2.charAt(0) == ""3"" || num2.charAt(0) == ""4"")
		intYear += 2000
	else
		intYear += 1900
	
	if (intYear % 4 == 0)
		leapDay = 29;
	else
		leapDay = 28;
    
    if(intMonth < 0 || intMonth > 12)
        return false;

	//  ˻
    switch(intMonth)
	{{
        case 2 :
            if(intDay < 0 || intDay > leapDay)
			{{
                return false;
            }}
        case 4 :
            if(intDay < 0 || intDay > 30)
			{{
                return false;
            }}
        case 6 :
            if(intDay < 0 || intDay > 30)
			{{
                return false;
            }}
        case 9 :
            if(intDay < 0 || intDay > 30)
			{{
                return false;
            }}
        case 11 :
            if(intDay < 0 || intDay > 30)
			{{
                return false;
            }}
        default :
            if(intDay < 0 || intDay > 31)
			{{
                return false;
            }}
    }}
    
	var sum;
	sum = num1.charAt(0)*2
	sum += num1.charAt(1)*3
	sum += num1.charAt(2)*4  
	sum += num1.charAt(3)*5
	sum += num1.charAt(4)*6
	sum += num1.charAt(5)*7  
	sum += num2.charAt(0)*8
	sum += num2.charAt(1)*9
	sum += num2.charAt(2)*2  
	sum += num2.charAt(3)*3
	sum += num2.charAt(4)*4
	sum += num2.charAt(5)*5
	
	var checkSum = (11 - (sum % 11)) % 10;

	//alert(""ǰ "");
	return parseInt(num2.charAt(6)) == checkSum
}}

function _birthdayAutoSelect(joomin1)
{{
	var regExpr = /^[0-9]{{6}}$/;
	if (!regExpr.test(joomin1)) 
		return;

    var intYear = parseInt(joomin1.substring(0,2), 10);
    var intMonth = parseInt(joomin1.substring(2,4), 10);
    var intDay = parseInt(joomin1.substring(4,6), 10);
	if (!(intMonth > 0 && intMonth <= 12 && intDay > 0 && intDay <= 31))
		return;

	intYear += 1900

	document.getElementById('{2}').selectedIndex = intYear - 1900;
	document.getElementById('{3}').selectedIndex = intMonth - 1;
	document.getElementById('{4}').selectedIndex = intDay - 1;
}}

function _joiningCheckJoomin(source, args)
{{
	m_prevResult = _CheckJoominNum(document.getElementById('{0}').value, document.getElementById('{1}').value);
	args.IsValid = m_prevResult;
}}

//-->
</SCRIPT>
";

		private void Page_Load(object sender, System.EventArgs e)
		{
			MyWebLibs.Utilities.CommonMethods.RegisterOnloadFunction(Page, "_joiningWebServiceInit()");
			btnUserIDDupCheck.Attributes["onclick"] = "_CallIDDupCheck(document.getElementById('" + txtUserID.ClientID + "').value)";

			joiningWebServiceBehaviorScript = String.Format(joiningWebServiceBehaviorScript, new String[] { CompareValidatorUserID.ClientID, txtUserID.ClientID, txtAddress1.ClientID, txtZip1.ClientID, txtZip2.ClientID, txtAddress2.ClientID });
			Page.RegisterClientScriptBlock("_joiningWebServiceBehaviorScript", joiningWebServiceBehaviorScript);

			joiningJoominCheckScript = String.Format(joiningJoominCheckScript, new String[] { txtJoomin1.ClientID, txtJoomin2.ClientID, drpdnlstYear.ClientID, drpdnlstMonth.ClientID, drpdnlstDay.ClientID});
			Page.RegisterClientScriptBlock("_joiningJoominCheckScript", joiningJoominCheckScript);

			txtJoomin1.Attributes["onchange"] = "_birthdayAutoSelect(this.value)";

			if (!IsPostBack) {
				ArrayList asou = new ArrayList();
				for (int i=1900; i<=DateTime.Now.Year; i++ )
					asou.Add(i);
				drpdnlstYear.DataSource = asou;
				drpdnlstYear.DataBind();

				//ȸ  
				if (Request.IsAuthenticated) {
					UsersDB db = new UsersDB();
					SqlDataReader dr = db.GetSingleUser(Page.User.Identity.Name);
					dr.Read();

					txtEmail.Text = dr["Email"].ToString();
					txtName.Text = dr["Name"].ToString();
					txtPhone.Text = dr["Phone"].ToString();
					txtAddress1.Text = dr["Address1"].ToString();
					txtAddress2.Text = dr["Address2"].ToString();

					ViewState["password"] = dr["Password"].ToString();

					if (dr["Birthday"] != System.DBNull.Value) {
						DateTime dtBd = (DateTime)dr["Birthday"];
						string strBd = dtBd.ToString("yyyy-MM-dd");
						string[] aBirthday = strBd.Split(new char[] {'-'});
						//string[] aBirthday = ((DateTime)dr["Birthday"]).ToString("yyyy-MM-dd").Split(new char[] {'-'});
						drpdnlstYear.Items.FindByText(aBirthday[0]).Selected = true;
						drpdnlstMonth.Items.FindByText(int.Parse(aBirthday[1]).ToString()).Selected = true;
						drpdnlstDay.Items.FindByText(int.Parse(aBirthday[2]).ToString()).Selected = true;
					}

					ViewState["Joomin"] = dr["Joomin"].ToString();
					string[] aJoomin = dr["Joomin"].ToString().Split(new char[] {'-'});
					txtJoomin1.Text = aJoomin[0];
					txtJoomin2.Text = aJoomin[1];

					string[] aZipNumber = dr["ZipNumber"].ToString().Split(new char[] {'-'});
					dr.Close();
					txtZip1.Text = aZipNumber[0];
					txtZip2.Text = aZipNumber[1];

					txtUserID.Text = Page.User.Identity.Name;
					btnUserIDDupCheck.Visible = false;
					txtUserID.Enabled = false;
					RequiredFieldValidator3.Visible = false;
					RequiredFieldValidator4.Visible = false;
					imgTitleImage.ImageUrl = "/Home/images/UserInfoChange.gif";
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.CustomValidator2.ServerValidate += new System.Web.UI.WebControls.ServerValidateEventHandler(this.CustomValidator2_ServerValidate);
			this.btnSubmit.Click += new System.EventHandler(this.btnSubmit_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void CustomValidator2_ServerValidate(object source, System.Web.UI.WebControls.ServerValidateEventArgs args)
		{
			bool checkResult = CheckJoominNum(txtJoomin1.Text, txtJoomin2.Text);
			args.IsValid = checkResult;
		}

		private bool CheckJoominNum(string num1, string num2)    
		{
			Regex regExpr1 = new Regex("^[0-9]{6}$");
			Regex regExpr2 = new Regex("^[0-9]{7}$");

			Match m1 = regExpr1.Match(num1);
			Match m2 = regExpr2.Match(num2);

			// ο ̸ ˻
			if (!m1.Success || !m2.Success) 
				return false;

			int intYear = Convert.ToInt32(num1.Substring(0,2));
			int intMonth = Convert.ToInt32(num1.Substring(2,2));
			int intDay = Convert.ToInt32(num1.Substring(4,2));

			// 
			if(num2[0] == '3' || num2[0] == '4')
				intYear += 2000;
			else
				intYear += 1900;
	
			int leapDay;
			if (intYear % 4 == 0)
				leapDay = 29;
			else
				leapDay = 28;
    
			if(intMonth < 0 || intMonth > 12)
				return false;

			//  ˻
			switch (intMonth)
			{
				case 2 :
					if(intDay < 0 || intDay > leapDay)
					{
						return false;
					}
					break;
				case 4 :
					if(intDay < 0 || intDay > 30)
					{
						return false;
					}
					break;
				case 6 :
					if(intDay < 0 || intDay > 30)
					{
						return false;
					}
					break;
				case 9 :
					if(intDay < 0 || intDay > 30)
					{
						return false;
					}
					break;
				case 11 :
					if(intDay < 0 || intDay > 30)
					{
						return false;
					}
					break;
				default :
					if(intDay < 0 || intDay > 31)
					{
						return false;
					}
					break;
			}
    
			int sum;
			sum = (Convert.ToInt32(num1[0])-48) * 2;
			sum += (Convert.ToInt32(num1[1])-48) * 3;
			sum += (Convert.ToInt32(num1[2])-48) * 4;
			sum += (Convert.ToInt32(num1[3])-48) * 5;
			sum += (Convert.ToInt32(num1[4])-48) * 6;
			sum += (Convert.ToInt32(num1[5])-48) * 7;
			sum += (Convert.ToInt32(num2[0])-48) * 8;
			sum += (Convert.ToInt32(num2[1])-48) * 9;
			sum += (Convert.ToInt32(num2[2])-48) * 2;
			sum += (Convert.ToInt32(num2[3])-48) * 3;
			sum += (Convert.ToInt32(num2[4])-48) * 4;
			sum += (Convert.ToInt32(num2[5])-48) * 5;
			int checkSum = (11 - (sum % 11)) % 10;

			return Convert.ToInt32(num2[6]-48) == checkSum;
		}

		private void btnSubmit_Click(object sender, System.EventArgs e)
		{
			const string DirNameFront = "Users";

			if (Page.IsValid) {
				int result;
				string userDir;
				string joomin = txtJoomin1.Text + "-" + txtJoomin2.Text;
				string zip = txtZip1.Text.Trim() + "-" + txtZip2.Text.Trim();
				DateTime birthday = new DateTime(Convert.ToInt32(drpdnlstYear.SelectedItem.Value), 
					Convert.ToInt32(drpdnlstMonth.SelectedItem.Value), 
					Convert.ToInt32(drpdnlstDay.SelectedItem.Value));

				//ȸ 
				if (Request.IsAuthenticated) {
					string password;

					// ȣ  Է   ϰ
					//ƴϸ   ȣ Ѵ.
					if (txtPassword.Text.Trim() == String.Empty)
						password = ViewState["password"].ToString();
					else
						password = txtPassword.Text;

					//ֹ ȣ  
					string orgJoomin = ViewState["Joomin"].ToString();
					bool joominChanged = (orgJoomin != joomin);

					Components.JoiningDB db = new Components.JoiningDB();
					result = db.ModifyUserInfo(txtUserID.Text, 
						txtName.Text, txtEmail.Text, password, 
						joomin, birthday, zip, txtPhone.Text, 
						txtAddress1.Text, txtAddress2.Text, joominChanged);

					if (result == -2 )
						MyWebLibs.Utilities.CommonMethods.PrintMsgBack("̹ ϴ ֹιȣ Դϴ.");
					else if (result == -3 )
						MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ó   ȸ   ʾҽϴ.");
					else {
						userDir = Request.Cookies["usersInfo"]["UserDir"];
						userDir = this.MapPath("/User/UserDir/" + userDir + "/" + txtUserID.Text);
						Components.PortalUtil.MakeWelcomeImage(txtName.Text, userDir);
						Response.Redirect(GetLink(""));
					}
				}
				else {// ȸ 
					string dir = String.Empty;
					int dirCount = 1;
					string prevDirName = String.Empty;
					string userRootDir = this.MapPath("/User/UserDir");

					//  ͸  .
					while (true) {
						if (!Directory.Exists(userRootDir + "\\" + DirNameFront + dirCount))
							break;
						else
							prevDirName = DirNameFront + dirCount;

						dirCount++;
					}

					//˻ӵ  ͸ ټ 200 Ѵ.
					if (prevDirName != String.Empty && Directory.GetDirectories(userRootDir + "\\" + prevDirName).Length < 200)
						userDir = prevDirName;
					else {
						Directory.CreateDirectory(userRootDir + "\\" + DirNameFront + dirCount);
						userDir = DirNameFront + dirCount;
					}

					PowerOfDotNet.Components.JoiningDB db = new PowerOfDotNet.Components.JoiningDB();
					result = db.AddUser(txtUserID.Text,txtName.Text, txtEmail.Text,txtPassword.Text, 
						joomin,birthday,zip,txtPhone.Text,txtAddress1.Text,txtAddress2.Text, 
						userDir, userRootDir);

					if (result == -1 )
						MyWebLibs.Utilities.CommonMethods.PrintMsgBack("̹ ϴ IDԴϴ.");
					else if (result == -2 )
						MyWebLibs.Utilities.CommonMethods.PrintMsgBack("̹ ϴ ֹιȣ Դϴ.");
					else if (result == -3 )
						MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ó   ȸ   ʾҽϴ.");
					else {
						userDir = this.MapPath("/User/UserDir/" + userDir + "/" + txtUserID.Text);
						Components.PortalUtil.MakeWelcomeImage(txtName.Text, userDir);
						FormsAuthentication.SetAuthCookie(txtUserID.Text, false);
						Response.Redirect(GetLink(""));
					}
				}
			}
			else
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ԷϽ  ùٸ ʽϴ..");
		}
	}
}
