/*
 * 2004 2 20 
 * */

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace PowerOfDotNet.MyPage
{
	public class DailyPlanInput : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button btnSave;
		protected System.Web.UI.WebControls.Label lblDate;
		protected System.Web.UI.HtmlControls.HtmlTextArea txtNote;
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;
		protected System.Web.UI.WebControls.Button btnDelete;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!this.IsPostBack) {
				string date = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["date"], "");
				string identity = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["identity"], "");

				string[] aYearMonth = date.Split(new char[] {'-'});
				DateTime inputDate = new DateTime(Convert.ToInt32(aYearMonth[0]), 
					Convert.ToInt32(aYearMonth[1]), Convert.ToInt32(aYearMonth[2]));

				lblDate.Text = inputDate.ToString("yyyy MM dd ");
				this.ViewState["inputDate"] = inputDate;
				this.ViewState["identity"] = identity;

				string userId = Page.User.Identity.Name;
				PowerOfDotNet.Components.MyPageDB db = new PowerOfDotNet.Components.MyPageDB();
				SqlDataReader dr = db.GetDateContent(userId, inputDate);
				if (dr.Read()) {
					txtNote.Value = dr["rtNote"].ToString();
					btnDelete.Visible = true;
				}
				dr.Close();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnSave.Click += new System.EventHandler(this.btnSave_Click);
			this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnSave_Click(object sender, System.EventArgs e)
		{
			string userId = this.Page.User.Identity.Name;
			DateTime inputDate = Convert.ToDateTime(this.ViewState["inputDate"]);
			PowerOfDotNet.Components.MyPageDB db = new PowerOfDotNet.Components.MyPageDB();
			db.EnterContent(userId,inputDate, txtNote.Value);

			string dailyPlanInputScript = @"
<script language=javascript>
<!--
	openerIdentity = ""{0}"";
	dailyPlanNote =""{1}"";
	destObjKey = ""{2}"";
	SetOpener(true);
//-->
</script>
			";
			string valNote = inputDate.ToString("yyyy-MM-dd") + "<br><br>" + txtNote.Value;
			valNote = valNote.Replace((char)13, (char)32);
			valNote = valNote.Replace("\n", "<br>");
			dailyPlanInputScript = String.Format(dailyPlanInputScript, 
				this.ViewState["identity"].ToString(), valNote, 
				inputDate.ToString("MMdd"));
			this.Page.RegisterStartupScript("_dailyPlanInputScript" , dailyPlanInputScript);
		}

		private void btnDelete_Click(object sender, System.EventArgs e)
		{
			string userId = this.Page.User.Identity.Name;
			PowerOfDotNet.Components.MyPageDB db = new PowerOfDotNet.Components.MyPageDB();
			if (db.DeleteDate(userId, Convert.ToDateTime(this.ViewState["inputDate"])) == 1)
			{
				string dailyPlanInputScript = @"
<script language=javascript>
<!--
	openerIdentity = ""{0}"";
	destObjKey = ""{1}"";
	SetOpener(false);
//-->
</script>
			";
				DateTime inputDate = Convert.ToDateTime(this.ViewState["inputDate"]);
				dailyPlanInputScript = String.Format(dailyPlanInputScript, 
					this.ViewState["identity"].ToString(), inputDate.ToString("MMdd"));
				this.Page.RegisterStartupScript("_dailyPlanInputScript" , dailyPlanInputScript);
			}
		}
	}
}
