namespace PowerOfDotNet.WebMail
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Configuration;

	/// <summary>
	///		WebmailMain   Դϴ.
	/// </summary>
	public abstract class WebmailMain : PowerOfDotNet.PortalModuleControl
	{
		protected string _userName;
		protected string _userId;
		protected string _recivedNewMailCount;
		protected string _recivedEntireMailCount;
		protected string _sentNewMailCount;
		protected string _sentEntireMailCount;
		protected string _wastebasketNewMailCount;
		protected string _wastebasketEntireMailCount;
		protected int _userEntireSpace;
		protected int _userUsedSpace;
		protected int _userFreeSpace;
		protected string _spaceGraphHeight;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (Request.IsAuthenticated)
			{
				_userName = Request.Cookies["usersInfo"]["Name"].ToString();
				_userId = this.Page.User.Identity.Name;

				PowerOfDotNet.Components.WebmailDB dbWebmail = new PowerOfDotNet.Components.WebmailDB();
				_recivedNewMailCount = dbWebmail.GetUserNetYetReadMailCount(_userId, 0).ToString();
				_recivedEntireMailCount = dbWebmail.GetUserMailCount(_userId, 0).ToString();
				_sentNewMailCount = dbWebmail.GetUserNetYetReadMailCount(_userId, 1).ToString();
				_sentEntireMailCount = dbWebmail.GetUserMailCount(_userId, 1).ToString();
				_wastebasketNewMailCount = dbWebmail.GetUserNetYetReadMailCount(_userId, 2).ToString();
				_wastebasketEntireMailCount = dbWebmail.GetUserMailCount(_userId, 2).ToString();

				PowerOfDotNet.AdminDB dbAdmin = new PowerOfDotNet.AdminDB();
				try 
				{
					//_userEntireSpace = Convert.ToInt32(ConfigurationSettings.AppSettings["MailLimitSize"]) * 1024;
					_userEntireSpace = Convert.ToInt32(dbAdmin.GetGlobalSetting("MailLimitSize")) * 1024;
				}
				catch
				{
					_userEntireSpace = 20 * 1024;
				}
				_userUsedSpace = dbWebmail.GetUserMailTotalSize(_userId) / 1024;
				_userFreeSpace = _userEntireSpace - _userUsedSpace;
				//177 ׷ 
				//_spaceGraphHeight = ((_userUsedSpace/_userEntireSpace) * 177).ToString();
				_spaceGraphHeight = ((_userUsedSpace*100/_userEntireSpace) * 177 / 100).ToString();


				this.DataBind();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
