using System;
using System.Data;
using System.Data.SqlClient;

namespace HasChangesExample
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			// Create a connection object
			SqlConnection dbConn = new SqlConnection("server=localhost;uid=sa;pwd=;database=WroxDB");

			// Create a DataAdapter
			SqlDataAdapter da = new SqlDataAdapter("SELECT AuthorID, RTRIM(Author_FirstName) As Author_FirstName, RTRIM(Author_LastName) As Author_LastName FROM tabAuthors", dbConn);

			// Create a DataSet
			DataSet dsAuthors = new DataSet("DS");

			// Fill the DataSet
			da.Fill(dsAuthors);

			// Add a new record
			DataRow r = dsAuthors.Tables[0].NewRow();

			r["AuthorID"] = 6;
			r["Author_FirstName"] = "Mark";
			r["Author_LastName"] = "Seemann";

			dsAuthors.Tables[0].Rows.Add(r);

			// Print to video
			Console.WriteLine(dsAuthors.HasChanges().ToString());
		}
	}
}
