using System;
using System.Data;

namespace InferXmlSchemaExample
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			// Create a DataSet
			DataSet dsAuthors = new DataSet();

			// Infer the schema
			dsAuthors.InferXmlSchema("F:\\ADO.NET\\Chapter5\\Wrox.xml",null);

			// Print every table inferred
			foreach (DataTable t in dsAuthors.Tables)
				Console.WriteLine(t.TableName);
			
			Console.WriteLine("-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=");

			// Create a new DataSet
			DataSet dsAuthors2 = new DataSet();

			// Same XML document
			dsAuthors2.InferXmlSchema("F:\\ADO.NET\\Chapter5\\Wrox.xml",new String[] {"urn:schemas-wrox-com:wroxdata"});

			// Different results
			foreach (DataTable t in dsAuthors2.Tables)
				Console.WriteLine(t.TableName);

		}
	}
}
