using System;
using System.Data;
using System.Data.Common;
using System.Data.SqlClient;

namespace EqualsExample
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			SqlConnection dbConn = new SqlConnection("server=localhost;uid=sa;pwd=;database=pubs");

			// Create Authors DataTable
			DataTable dtAuthors = new DataTable("Authors");

			// Create a DataAdapter to fill the table
			SqlDataAdapter daAuthors = new SqlDataAdapter("SELECT au_id,au_fname,au_lname,contract FROM authors",dbConn);
			daAuthors.Fill(dtAuthors);

			// Fill two DataView with the same set of data
			DataView dvOne = new DataView(dtAuthors);
			DataView dvTwo = new DataView(dtAuthors);

			// Retrieve two DataRowView objects pointing to the same
			// row.
			DataRowView drvOne = dvOne[0];
			DataRowView drvTwo = dvTwo[0];

			// Print to video
			Console.WriteLine(drvOne.Equals(drvTwo).ToString());

		}
	}
}
