Module Module1
    
    Sub Main()
        ' Open the connection
        Dim dbConn As New SqlClient.SqlConnection("server=localhost;uid=sa;pwd=;database=pubs")

        Try
            ' Create Authors DataTable
            Dim dtAuthors As New DataTable("Authors")

            ' Create a DataAdapter to fill the table
            Dim daAuthors As New SqlClient.SqlDataAdapter("SELECT au_id,au_fname,au_lname,contract FROM authors", dbConn)
            daAuthors.Fill(dtAuthors)

            ' Create a command builder to implement SQL insert command
            ' automatically
            Dim sqlCB As New SqlClient.SqlCommandBuilder(daAuthors)

            ' Create a new row
            Dim drNewAuthor As DataRow

            ' It has the same table schema
            drNewAuthor = dtAuthors.NewRow()
            drNewAuthor("au_id") = "222-22-2222"
            drNewAuthor("au_fname") = "Fabio Claudio"
            drNewAuthor("au_lname") = "Ferracchiati"
            drNewAuthor("contract") = 1

            ' Add the new row to the collection contained
            ' in the DataTable
            dtAuthors.Rows.Add(drNewAuthor)

            ' Update the database records
            daAuthors.Update(dtAuthors)

            ' Accept DataTable changes
            dtAuthors.AcceptChanges()
        Catch e As Exception
            Console.WriteLine(e.Message)
        End Try

    End Sub
    
End Module
