Module Module1
    
    Sub Main()
        ' Open the connection
        Dim dbConn As New SqlClient.SqlConnection("server=localhost;uid=sa;pwd=;database=pubs")

        ' Create Authors DataTable
        Dim dtAuthors As New DataTable("Authors")

        ' Create a DataAdapter to fill the table
        Dim daAuthors As New SqlClient.SqlDataAdapter("SELECT au_id,au_fname,au_lname,contract FROM authors", dbConn)
        daAuthors.Fill(dtAuthors)

        AddHandler dtAuthors.ColumnChanged, New DataColumnChangeEventHandler(AddressOf OnColumnChanged)

        AddHandler dtAuthors.ColumnChanging, New DataColumnChangeEventHandler(AddressOf OnColumnChanging)

        ' Create a new row
        Dim drNewAuthor As DataRow

        ' It has the same table schema
        drNewAuthor = dtAuthors.NewRow()
        drNewAuthor("au_id") = "222-22-2222"
        drNewAuthor("au_fname") = "Fabio Claudio"
        drNewAuthor("au_lname") = "Ferracchiati"
        drNewAuthor("contract") = 1

    End Sub

    Private Sub OnColumnChanged(ByVal sender As Object, ByVal args As DataColumnChangeEventArgs)
        Console.WriteLine("Column " + args.Column.ToString() + " has changed")
    End Sub

    Private Sub OnColumnChanging(ByVal sender As Object, ByVal args As DataColumnChangeEventArgs)
        Console.WriteLine("Column " + args.Column.ToString() + " is changing")
    End Sub

End Module
