<%@ Page language="c#" Codebehind="OrderDetailDataGrid.aspx.cs" Inherits="DayOfDotNet.OrderDetailDataGrid" %>
<HTML>
	<body style="font: x-small Verdana, Arial, sans-serif;">
		<!-- Begin Web Form -->
		<form id="OrderDetailDataGrid" method="post" runat="server">
			<p>
				<a href="/ADayOfDotNet/">Parent Directory</a>
			</p>
			<!-- Begin DataGrid -->
			<asp:DataGrid id="OrderDataGrid" runat="server" AutoGenerateColumns="False" CellPadding="2" CellSpacing="0" Font-Names="Verdana, Arial, sans-serif" BorderColor="Black" BorderWidth="1" GridLines="Horizontal" OnItemDataBound="OrderDataGrid_OnItemDataBound">
				<HeaderStyle Font-Bold="True" Font-Size="small" Font-Name="Arial" BackColor="Maroon" ForeColor="White" />
				<ItemStyle Font-Size="x-small" />
				<AlternatingItemStyle BackColor="Tan" />
				<Columns>
					<asp:BoundColumn DataField="OrderID" HeaderText="ID" ItemStyle-VerticalAlign="Top" />
					<asp:TemplateColumn ItemStyle-VerticalAlign="Top" HeaderText="Order Info">
						<ItemTemplate>
							<table cellpadding="4" cellspacing="0">
								<tr>
									<td valign="top" style="font: x-small Verdana, Arial, san-serif;">
										<b>
											<%# DataBinder.Eval(Container.DataItem, "CustomerID") %>
										</b>
										<br>
										Order Date:
										<%# DataBinder.Eval(Container.DataItem, "OrderDate", "{0:d}") %>
										<br>
										Required Date:
										<%# DataBinder.Eval(Container.DataItem, "RequiredDate", "{0:d}" ) %>
										<br>
										Shipped Date:
										<%# DataBinder.Eval(Container.DataItem, "ShippedDate", "{0:d}") %>
										<br>
									</td>
									<td valign="top" style="font: x-small Verdana, Arial, san-serif;">
										<b>Shipping Information:</b>
										<br>
										<%# DataBinder.Eval(Container.DataItem, "ShipName" ) %>
										<br>
										<%# DataBinder.Eval(Container.DataItem, "ShipAddress" ) %>
										<br>
										<%# DataBinder.Eval(Container.DataItem, "ShipCity" ) %>
										,
										<%# DataBinder.Eval(Container.DataItem, "ShipRegion" ) %>
										<%# DataBinder.Eval(Container.DataItem, "ShipPostalCode" ) %>
									</td>
								</tr>
							</table>
							<%-- Embedded DataGrid will go here --%>
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:DataGrid>
			<!-- End DataGrid -->
		</form>
		<!-- End Web Form -->
	</body>
</HTML>
