IF EXISTS (SELECT name FROM master.dbo.sysdatabases WHERE name = N'PowerOfDotNet')
	DROP DATABASE [PowerOfDotNet]
GO

CREATE DATABASE [PowerOfDotNet]  ON (NAME = N'PowerOfDotNet', FILENAME = N'E:\Program Files\Microsoft SQL Server\MSSQL\data\PowerOfDotNet.mdf' , SIZE = 16, FILEGROWTH = 10%) LOG ON (NAME = N'PowerOfDotNet_log', FILENAME = N'E:\Program Files\Microsoft SQL Server\MSSQL\data\PowerOfDotNet_log.LDF' , SIZE = 38, FILEGROWTH = 10%)
 COLLATE Korean_Wansung_CI_AS
GO

exec sp_dboption N'PowerOfDotNet', N'autoclose', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'bulkcopy', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'trunc. log', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'torn page detection', N'true'
GO

exec sp_dboption N'PowerOfDotNet', N'read only', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'dbo use', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'single', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'autoshrink', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'ANSI null default', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'recursive triggers', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'ANSI nulls', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'concat null yields null', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'cursor close on commit', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'default to local cursor', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'quoted identifier', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'ANSI warnings', N'false'
GO

exec sp_dboption N'PowerOfDotNet', N'auto create statistics', N'true'
GO

exec sp_dboption N'PowerOfDotNet', N'auto update statistics', N'true'
GO

use [PowerOfDotNet]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_AvatarItems_AvatarCategory]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[AvatarItems] DROP CONSTRAINT FK_AvatarItems_AvatarCategory
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_AvatarPositionAction_AvatarPositionDef]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[AvatarPositionAction] DROP CONSTRAINT FK_AvatarPositionAction_AvatarPositionDef
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_PositionMaps_PositionDef]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[AvatarPositionMaps] DROP CONSTRAINT FK_PositionMaps_PositionDef
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_FragBoardSetting_BBSInfo]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[FragBoardSetting] DROP CONSTRAINT FK_FragBoardSetting_BBSInfo
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Clubs_ClubClass]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Clubs] DROP CONSTRAINT FK_Clubs_ClubClass
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_ClubFreeBoard01Files_ClubFreeBoard01]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[ClubFreeBoard01Files] DROP CONSTRAINT FK_ClubFreeBoard01Files_ClubFreeBoard01
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_ClubMainAnnouncement01Files_ClubMainAnnouncement01]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[ClubMainAnnouncement01Files] DROP CONSTRAINT FK_ClubMainAnnouncement01Files_ClubMainAnnouncement01
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Modules_ModuleDefinitions]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Modules] DROP CONSTRAINT FK_Modules_ModuleDefinitions
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Modules_Pages]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Modules] DROP CONSTRAINT FK_Modules_Pages
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Roles_Portals]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Roles] DROP CONSTRAINT FK_Roles_Portals
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Tabs_Portals]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Tabs] DROP CONSTRAINT FK_Tabs_Portals
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Shop_CategoryIndex_Shop_CategoryTop]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Shop_CategoryIndex] DROP CONSTRAINT FK_Shop_CategoryIndex_Shop_CategoryTop
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Shop_ProductOptDef_Shop_ProductOption]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Shop_ProductOptDef] DROP CONSTRAINT FK_Shop_ProductOptDef_Shop_ProductOption
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Shop_ProdOptList_Shop_ProductOption]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Shop_ProductOptList] DROP CONSTRAINT FK_Shop_ProdOptList_Shop_ProductOption
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_UserAvatar_Users]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[UserAvatar] DROP CONSTRAINT FK_UserAvatar_Users
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_UserRoles_Users]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[UserRoles] DROP CONSTRAINT FK_UserRoles_Users
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WebmailReceptionCheck_Users]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WebmailReceptionCheck] DROP CONSTRAINT FK_WebmailReceptionCheck_Users
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_WebmailAttachFiles_WebmailMailBox]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[WebmailAttachFiles] DROP CONSTRAINT FK_WebmailAttachFiles_WebmailMailBox
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_clubTable_10_01Files_clubTable_10_01]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[clubTable_10_01Files] DROP CONSTRAINT FK_clubTable_10_01Files_clubTable_10_01
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_AvatarExpression_AvatarItems]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[AvatarExpression] DROP CONSTRAINT FK_AvatarExpression_AvatarItems
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_AvatarItemsImages_AvatarItems]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[AvatarItemImages] DROP CONSTRAINT FK_AvatarItemsImages_AvatarItems
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_AvatarPositionMaps_AvatarItems]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[AvatarPositionMaps] DROP CONSTRAINT FK_AvatarPositionMaps_AvatarItems
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_UserAvatar_AvatarItems]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[UserAvatar] DROP CONSTRAINT FK_UserAvatar_AvatarItems
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_ClubsBoardInfo_Clubs]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[ClubsBoardInfo] DROP CONSTRAINT FK_ClubsBoardInfo_Clubs
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_ClubUsers_Clubs]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[ClubUsers] DROP CONSTRAINT FK_ClubUsers_Clubs
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_UserRoles_Roles]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[UserRoles] DROP CONSTRAINT FK_UserRoles_Roles
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Shop_Products_Shop_CategoryIndex]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Shop_Products] DROP CONSTRAINT FK_Shop_Products_Shop_CategoryIndex
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Modules_Tabs]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Modules] DROP CONSTRAINT FK_Modules_Tabs
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Announcements_Modules]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Announcements] DROP CONSTRAINT FK_Announcements_Modules
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Contacts_Modules]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Contacts] DROP CONSTRAINT FK_Contacts_Modules
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Discussion_Modules]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Discussion] DROP CONSTRAINT FK_Discussion_Modules
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Documents_Modules]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Documents] DROP CONSTRAINT FK_Documents_Modules
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Events_Modules]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Events] DROP CONSTRAINT FK_Events_Modules
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_FragBoardSetting_Modules]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[FragBoardSetting] DROP CONSTRAINT FK_FragBoardSetting_Modules
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_HtmlText_Modules]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[HtmlText] DROP CONSTRAINT FK_HtmlText_Modules
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Links_Modules]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Links] DROP CONSTRAINT FK_Links_Modules
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_ModuleSettings_Modules]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[ModuleSettings] DROP CONSTRAINT FK_ModuleSettings_Modules
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Shop_ProdOptList_Shop_Products]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Shop_ProductOptList] DROP CONSTRAINT FK_Shop_ProdOptList_Shop_Products
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_Shop_Reviews_Shop_Products]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[Shop_Reviews] DROP CONSTRAINT FK_Shop_Reviews_Shop_Products
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[CategoryAspDotNetChanged]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[CategoryAspDotNetChanged]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DownloadBoardTriger]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[DownloadBoardTriger]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Announcements]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Announcements]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Contacts]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Contacts]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Discussion]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Discussion]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Documents]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Documents]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Events]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Events]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FragBoardSetting]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[FragBoardSetting]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[HtmlText]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[HtmlText]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Links]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Links]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ModuleSettings]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ModuleSettings]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_ProductOptList]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_ProductOptList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_Reviews]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_Reviews]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[AvatarExpression]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[AvatarExpression]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[AvatarItemImages]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[AvatarItemImages]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[AvatarPositionMaps]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[AvatarPositionMaps]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ClubUsers]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ClubUsers]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ClubsBoardInfo]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ClubsBoardInfo]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Modules]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Modules]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_Products]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_Products]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[UserAvatar]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[UserAvatar]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[UserRoles]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[UserRoles]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[AvatarItems]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[AvatarItems]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[AvatarPositionAction]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[AvatarPositionAction]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ClubFreeBoard01Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ClubFreeBoard01Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ClubMainAnnouncement01Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ClubMainAnnouncement01Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Clubs]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Clubs]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Roles]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Roles]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_CategoryIndex]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_CategoryIndex]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_ProductOptDef]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_ProductOptDef]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Tabs]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Tabs]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[WebmailAttachFiles]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[WebmailAttachFiles]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[WebmailReceptionCheck]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[WebmailReceptionCheck]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_10_01Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_10_01Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[AddressBook]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[AddressBook]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[AvatarCategory]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[AvatarCategory]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[AvatarPositionDef]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[AvatarPositionDef]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[BBSInfo]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[BBSInfo]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[BoardFree01]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[BoardFree01]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[BoardFree01Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[BoardFree01Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[BoardLacture01]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[BoardLacture01]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[BoardLacture01Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[BoardLacture01Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[CategoryAspDotNet]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[CategoryAspDotNet]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ChangedTriger]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ChangedTriger]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ClubClass]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ClubClass]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ClubFreeBoard01]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ClubFreeBoard01]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ClubMainAnnouncement01]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ClubMainAnnouncement01]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DailyPlan]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[DailyPlan]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DownloadBoard]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[DownloadBoard]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DownloadBoardComment]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[DownloadBoardComment]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DownloadBoardVote]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[DownloadBoardVote]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FreeBoard01]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[FreeBoard01]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FreeBoard01Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[FreeBoard01Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[GlobalSettings]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[GlobalSettings]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MainAnnouncement]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[MainAnnouncement]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MainAnnouncementFiles]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[MainAnnouncementFiles]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ModuleDefinitions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ModuleDefinitions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Pages]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Pages]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Portals]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Portals]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[QABoard01]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[QABoard01]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[QABoard01Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[QABoard01Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[QABoard02]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[QABoard02]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[QABoard02Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[QABoard02Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_AltercastImageInfo]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_AltercastImageInfo]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_Brands]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_Brands]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_CategoryTop]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_CategoryTop]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_Orders]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_Orders]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_OrdersProd]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_OrdersProd]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_OrdersProdOpt]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_OrdersProdOpt]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_ProductOption]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_ProductOption]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_ShoppingCart]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_ShoppingCart]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Shop_ShoppingCartOption]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Shop_ShoppingCartOption]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[UserMessage]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[UserMessage]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Users]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Users]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[WebmailDirectory-bak]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[WebmailDirectory-bak]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[WebmailMailBox]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[WebmailMailBox]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[ZipTable]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[ZipTable]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_10_01]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_10_01]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_10_02]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_10_02]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_10_02Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_10_02Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_10_03]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_10_03]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_10_03Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_10_03Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_10_04]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_10_04]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_10_04Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_10_04Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_10_05]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_10_05]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_10_05Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_10_05Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_14_01]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_14_01]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_14_01Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_14_01Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_14_02]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_14_02]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_14_02Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_14_02Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_14_03]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_14_03]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_14_03Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_14_03Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_14_04]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_14_04]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_14_04Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_14_04Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_14_05]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_14_05]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_14_05Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_14_05Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_17_01]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_17_01]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_17_01Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_17_01Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_17_02]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_17_02]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_17_02Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_17_02Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_17_03]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_17_03]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_17_03Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_17_03Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_17_04]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_17_04]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_17_04Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_17_04Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_17_05]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_17_05]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_17_05Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_17_05Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_22_01]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_22_01]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_22_01Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_22_01Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_22_02]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_22_02]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_22_02Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_22_02Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_22_03]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_22_03]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_22_03Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_22_03Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_22_04]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_22_04]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_22_04Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_22_04Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_22_05]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_22_05]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_22_05Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_22_05Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_23_01]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_23_01]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_23_01Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_23_01Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_23_02]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_23_02]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_23_02Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_23_02Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_23_03]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_23_03]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_23_03Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_23_03Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_23_04]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_23_04]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_23_04Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_23_04Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_23_05]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_23_05]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_23_05Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_23_05Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_24_01]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_24_01]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_24_01Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_24_01Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_24_02]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_24_02]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_24_02Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_24_02Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_24_03]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_24_03]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_24_03Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_24_03Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_24_04]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_24_04]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_24_04Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_24_04Files]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_24_05]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_24_05]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[clubTable_24_05Files]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[clubTable_24_05Files]
GO

CREATE TABLE [dbo].[AddressBook] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[UserID] [char] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Name] [nvarchar] (20) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[FriendUserID] [char] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[Phone] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[AvatarCategory] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[Subject] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[AvatarPositionDef] (
	[PositionID] [int] NOT NULL ,
	[Description] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[ExclusiveCircumference] [bit] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[BBSInfo] (
	[BBSID] [int] IDENTITY (1, 1) NOT NULL ,
	[BBSSubject] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[BBSTable] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[BBSHtml] [ntext] COLLATE Korean_Wansung_CI_AS NULL ,
	[BBSDisplayType] [tinyint] NOT NULL ,
	[BBSImage] [varchar] (80) COLLATE Korean_Wansung_CI_AS NULL ,
	[BBSRoles] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[BBSImageHeadName] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[BBSCssClassHead] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[BBSMessage] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[BBSMsgContent] [ntext] COLLATE Korean_Wansung_CI_AS NULL ,
	[BBSMsgDisplay] [bit] NOT NULL ,
	[BBSType] [tinyint] NOT NULL ,
	[BBSPageNameList] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[BBSPageNameWrite] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[BBSPageNameEdit] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[BBSPageNameReply] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[BBSPageNameContent] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[BoardFree01] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[GroupID] [int] NOT NULL ,
	[Order] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [varchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [varchar] (20) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (10) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NULL ,
	[AvatarExpression] [tinyint] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[BoardFree01Files] (
	[bfID] [int] IDENTITY (1, 1) NOT NULL ,
	[bfPID] [bigint] NOT NULL ,
	[bfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[bfSize] [int] NULL ,
	[bfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[BoardLacture01] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[GroupID] [int] NOT NULL ,
	[Order] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[BoardLacture01Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [bigint] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[CategoryAspDotNet] (
	[anID] [int] NOT NULL ,
	[anCategory] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[ChangedTriger] (
	[ctTableName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[ctChangedTime] [datetime] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[ClubClass] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[Name] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[ClubCount] [int] NOT NULL ,
	[ImagePath] [varchar] (100) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[ClubFreeBoard01] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[GroupID] [int] NOT NULL ,
	[Order] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[ClubMainAnnouncement01] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[GroupID] [int] NOT NULL ,
	[Order] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NULL ,
	[AvatarExpression] [tinyint] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[DailyPlan] (
	[rtUserID] [char] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[rtDate] [smalldatetime] NOT NULL ,
	[rtNote] [nvarchar] (300) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[DownloadBoard] (
	[dnID] [int] IDENTITY (1, 1) NOT NULL ,
	[dnWriterID] [char] (10) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[dnWriterName] [char] (10) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[dnSubject] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[dnDescription] [text] COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[dnFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[dnDownloadCount] [int] NOT NULL ,
	[dnRating] [int] NOT NULL ,
	[dnVoteCount] [int] NOT NULL ,
	[dnCommentCount] [int] NOT NULL ,
	[dnRegDate] [smalldatetime] NOT NULL ,
	[dnTarget] [tinyint] NOT NULL ,
	[dnCategory] [tinyint] NOT NULL ,
	[dnLanguage] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[DownloadBoardComment] (
	[dncID] [int] IDENTITY (1, 1) NOT NULL ,
	[dncDnID] [int] NOT NULL ,
	[dncWriterID] [char] (10) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[dncComment] [varchar] (255) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[DownloadBoardVote] (
	[dnvID] [int] IDENTITY (1, 1) NOT NULL ,
	[dnvDnID] [int] NOT NULL ,
	[dnvWriterID] [char] (10) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[dnvRating] [tinyint] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[FreeBoard01] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[GroupID] [int] NOT NULL ,
	[Order] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NULL ,
	[AvatarExpression] [tinyint] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[FreeBoard01Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[GlobalSettings] (
	[SettingName] [char] (20) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[SettingValue] [varchar] (1000) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[MainAnnouncement] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[GroupID] [int] NOT NULL ,
	[Order] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[MainAnnouncementFiles] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [bigint] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[ModuleDefinitions] (
	[ModuleDefID] [int] IDENTITY (1, 1) NOT NULL ,
	[PortalID] [int] NOT NULL ,
	[FriendlyName] [nvarchar] (128) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[DesktopSrc] [nvarchar] (256) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[MobileSrc] [nvarchar] (256) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Pages] (
	[TabID] [int] NOT NULL ,
	[TargetID] [int] NOT NULL ,
	[PortalID] [int] NOT NULL ,
	[PageName] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[PageTemplate] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NULL ,
	[AuthorizedRoles] [nvarchar] (256) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Portals] (
	[PortalID] [int] IDENTITY (-1, 1) NOT NULL ,
	[PortalAlias] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[PortalName] [nvarchar] (128) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[AlwaysShowEditButton] [bit] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[QABoard01] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[GroupID] [int] NOT NULL ,
	[Order] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NULL ,
	[AvatarExpression] [tinyint] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[QABoard01Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[QABoard02] (
	[ID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[GroupID] [int] NOT NULL ,
	[Order] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NULL ,
	[AvatarExpression] [tinyint] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[QABoard02Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_AltercastImageInfo] (
	[kind] [char] (1) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[appendString] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[stringPlace] [int] NOT NULL ,
	[stringColor] [varchar] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[stringFont] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[stringSize] [int] NOT NULL ,
	[overImage] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[overCoordX] [int] NOT NULL ,
	[overCoordY] [int] NOT NULL ,
	[overRotate] [int] NOT NULL ,
	[overAlpha] [int] NOT NULL ,
	[overPercent] [int] NOT NULL ,
	[overStringPosX] [int] NOT NULL ,
	[overStringPosY] [int] NOT NULL ,
	[overStringHAuto] [bit] NOT NULL ,
	[overStringVAuto] [bit] NOT NULL ,
	[originalSize] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_Brands] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[Name] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_CategoryTop] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[SortOrder] [int] NULL ,
	[Name] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[ImageName] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[ImageNameMenu] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_Orders] (
	[ID] [bigint] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[Name] [varchar] (10) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Joomin] [char] (14) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Phone] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[ZipNumber] [varchar] (9) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Address] [varchar] (200) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[DeliveryName] [varchar] (10) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[DeliveryEmail] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[DeliveryPhone] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[DeliveryZipNumber] [varchar] (9) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[DeliveryAddress] [varchar] (200) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[DeliveryNote] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[WishDate] [smalldatetime] NULL ,
	[OrderDate] [datetime] NOT NULL ,
	[PaymenyMethod] [tinyint] NOT NULL ,
	[PayName] [varchar] (10) COLLATE Korean_Wansung_CI_AS NULL ,
	[Bank] [varchar] (70) COLLATE Korean_Wansung_CI_AS NULL ,
	[ExpectationDate] [smalldatetime] NULL ,
	[BaedalDate] [datetime] NULL ,
	[Process] [tinyint] NOT NULL ,
	[CardMessage] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Money] [bigint] NOT NULL ,
	[Accumulation] [bigint] NOT NULL ,
	[DeliveryCost] [bigint] NOT NULL ,
	[UsedAccum] [bigint] NOT NULL ,
	[Order_No] [varchar] (30) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_OrdersProd] (
	[ID] [int] NOT NULL ,
	[OrderID] [int] NOT NULL ,
	[ProdID] [int] NOT NULL ,
	[ProdName] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[ProdPrice] [money] NOT NULL ,
	[Quantity] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_OrdersProdOpt] (
	[OrdersProdID] [int] NOT NULL ,
	[OptionID] [int] NOT NULL ,
	[SelectedValue] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_ProductOption] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[Subject] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_ShoppingCart] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[CartID] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[Quantity] [int] NOT NULL ,
	[ProductID] [int] NOT NULL ,
	[DateCreated] [datetime] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_ShoppingCartOption] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[ShopCartID] [int] NOT NULL ,
	[OptionID] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[UserMessage] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[UserID] [char] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[SendUserID] [char] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[RecivedDate] [datetime] NOT NULL ,
	[Viewed] [bit] NOT NULL ,
	[Message] [text] COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[Users] (
	[UserID] [char] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Name] [nvarchar] (20) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Password] [nvarchar] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Joomin] [char] (14) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Birthday] [smalldatetime] NULL ,
	[Phone] [varchar] (20) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[ZipNumber] [varchar] (9) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Address1] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Address2] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserDirectory] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[ShopPoint] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WebmailDirectory-bak] (
	[UserID] [char] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[FriendAddr] [varchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Friendname] [varchar] (30) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WebmailMailBox] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[UserID] [char] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[MailBoxType] [tinyint] NOT NULL ,
	[Subject] [varchar] (200) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[TextBody] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[HtmlBody] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[To] [varchar] (2000) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[From] [varchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Cc] [varchar] (2000) COLLATE Korean_Wansung_CI_AS NULL ,
	[Bcc] [varchar] (2000) COLLATE Korean_Wansung_CI_AS NULL ,
	[FileAttach] [bit] NOT NULL ,
	[MailSize] [int] NOT NULL ,
	[Viewed] [bit] NOT NULL ,
	[SentOn] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[ZipTable] (
	[num] [int] NOT NULL ,
	[Zipcode] [nvarchar] (255) COLLATE Korean_Wansung_CI_AS NULL ,
	[S1] [nvarchar] (255) COLLATE Korean_Wansung_CI_AS NULL ,
	[S2] [nvarchar] (255) COLLATE Korean_Wansung_CI_AS NULL ,
	[S3] [nvarchar] (255) COLLATE Korean_Wansung_CI_AS NULL ,
	[S4] [nvarchar] (255) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_10_01] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_10_02] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_10_02Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_10_03] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_10_03Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_10_04] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_10_04Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_10_05] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_10_05Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_14_01] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_14_01Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_14_02] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_14_02Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_14_03] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_14_03Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_14_04] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_14_04Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_14_05] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_14_05Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_17_01] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_17_01Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_17_02] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_17_02Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_17_03] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_17_03Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_17_04] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_17_04Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_17_05] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_17_05Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_22_01] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_22_01Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_22_02] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_22_02Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_22_03] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_22_03Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_22_04] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_22_04Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_22_05] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_22_05Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_23_01] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_23_01Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_23_02] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_23_02Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_23_03] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_23_03Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_23_04] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_23_04Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_23_05] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_23_05Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_24_01] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_24_01Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_24_02] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_24_02Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_24_03] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_24_03Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_24_04] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_24_04Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_24_05] (
	[PID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[MID] [int] NOT NULL ,
	[LinkID] [int] NOT NULL ,
	[TreeID] [int] NOT NULL ,
	[Subject] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Writer] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Email] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Visited] [int] NOT NULL ,
	[Recom] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[UserIP] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Password] [varchar] (12) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [datetime] NOT NULL ,
	[Content] [text] COLLATE Korean_Wansung_CI_AS NULL ,
	[FileCount] [tinyint] NOT NULL ,
	[Format] [tinyint] NULL ,
	[UseAvatar] [bit] NOT NULL ,
	[AvatarExpression] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_24_05Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [int] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[AvatarItems] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[ItemName] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[PositionID] [int] NOT NULL ,
	[CategoryID] [int] NOT NULL ,
	[Cost] [money] NOT NULL ,
	[Sex] [tinyint] NOT NULL ,
	[ThumbnailImage] [varchar] (150) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[AvatarPositionAction] (
	[PositionID] [int] NOT NULL ,
	[OccurrenceTime] [varchar] (20) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[TargetCircumference] [bit] NOT NULL ,
	[Action] [varchar] (20) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[TargetPositionID] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[ClubFreeBoard01Files] (
	[blfID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [bigint] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[ClubMainAnnouncement01Files] (
	[blfID] [bigint] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [bigint] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[Clubs] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[Subject] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[ClassID] [int] NOT NULL ,
	[PublicType] [tinyint] NOT NULL ,
	[SysopID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[ViceSysopIDs] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[MemberCount] [int] NOT NULL ,
	[FrontTableName] [varchar] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[CreatedDate] [smalldatetime] NOT NULL ,
	[IntroHtml] [nvarchar] (500) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[MainHtml] [ntext] COLLATE Korean_Wansung_CI_AS NULL ,
	[SkinType] [tinyint] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[Roles] (
	[RoleID] [int] IDENTITY (0, 1) NOT NULL ,
	[PortalID] [int] NOT NULL ,
	[RoleName] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_CategoryIndex] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[TopID] [int] NOT NULL ,
	[SortOrder] [int] NULL ,
	[Name] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[ImageName] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[ImageNameMenu] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_ProductOptDef] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[OptionID] [int] NOT NULL ,
	[Text] [nvarchar] (150) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[SortOrder] [int] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Tabs] (
	[TabID] [int] IDENTITY (0, 1) NOT NULL ,
	[TabOrder] [int] NOT NULL ,
	[PortalID] [int] NOT NULL ,
	[TabName] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[MobileTabName] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[AuthorizedRoles] [nvarchar] (256) COLLATE Korean_Wansung_CI_AS NULL ,
	[ShowMobile] [bit] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WebmailAttachFiles] (
	[MailID] [int] NOT NULL ,
	[FileName] [varchar] (70) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[SavedFileName] [varchar] (70) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Size] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[WebmailReceptionCheck] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[UserID] [char] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Checked] [bit] NOT NULL ,
	[SentDate] [datetime] NOT NULL ,
	[CheckedDate] [datetime] NULL ,
	[Subject] [varchar] (200) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[To] [varchar] (2000) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[clubTable_10_01Files] (
	[blfID] [int] IDENTITY (1, 1) NOT NULL ,
	[blfPID] [bigint] NOT NULL ,
	[blfFileName] [char] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[blfSize] [int] NULL ,
	[blfContent] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[AvatarExpression] (
	[ID] [int] NOT NULL ,
	[Description] [nvarchar] (30) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[ItemID] [int] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[AvatarItemImages] (
	[ItemID] [int] NOT NULL ,
	[LayerNum] [int] NOT NULL ,
	[ImageName] [varchar] (150) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[AvatarPositionMaps] (
	[PositionID] [int] NOT NULL ,
	[AccessoryID] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[ClubUsers] (
	[ClubID] [int] NOT NULL ,
	[UserID] [varchar] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[EntryDate] [datetime] NOT NULL ,
	[LastVisitedDate] [datetime] NULL ,
	[VisitedCount] [int] NOT NULL ,
	[SelfIntroduction] [varchar] (300) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[OpenInformations] [varchar] (200) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Agreement] [bit] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[ClubsBoardInfo] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[ClubID] [int] NOT NULL ,
	[Subject] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[TableName] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Html] [ntext] COLLATE Korean_Wansung_CI_AS NULL ,
	[DisplayType] [tinyint] NOT NULL ,
	[Image] [varchar] (80) COLLATE Korean_Wansung_CI_AS NULL ,
	[ImageHeadName] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[CssClassHead] [varchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Type] [tinyint] NOT NULL ,
	[PageNameList] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[PageNameWrite] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[PageNameEdit] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[PageNameReply] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[PageNameContent] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[SortOrder] [int] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[Modules] (
	[ModuleID] [int] IDENTITY (0, 1) NOT NULL ,
	[PortalID] [int] NOT NULL ,
	[TabID] [int] NOT NULL ,
	[TargetID] [int] NOT NULL ,
	[ModuleDefID] [int] NOT NULL ,
	[ModuleOrder] [int] NOT NULL ,
	[PaneName] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[ModuleTitle] [nvarchar] (256) COLLATE Korean_Wansung_CI_AS NULL ,
	[AuthorizedEditRoles] [nvarchar] (256) COLLATE Korean_Wansung_CI_AS NULL ,
	[CacheTime] [int] NOT NULL ,
	[CacheMode] [tinyint] NOT NULL ,
	[CacheDependencyString] [varchar] (100) COLLATE Korean_Wansung_CI_AS NULL ,
	[ShowMobile] [bit] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_Products] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[IndexID] [int] NOT NULL ,
	[Name] [nvarchar] (40) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Description] [ntext] COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[Price] [money] NOT NULL ,
	[DiscountPercent] [int] NOT NULL ,
	[Recommendation] [tinyint] NOT NULL ,
	[Absence] [tinyint] NOT NULL ,
	[RegDate] [smalldatetime] NOT NULL ,
	[SaleCount] [int] NOT NULL ,
	[BrandID] [int] NULL ,
	[Weight] [int] NULL ,
	[Stone] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[BestImageGenerated] [bit] NOT NULL ,
	[SaleImageGenerated] [bit] NOT NULL ,
	[RecomImageGenerated] [bit] NOT NULL ,
	[BestImageTail] [char] (18) COLLATE Korean_Wansung_CI_AS NULL ,
	[SaleImageTail] [char] (18) COLLATE Korean_Wansung_CI_AS NULL ,
	[RecomImageTail] [char] (18) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[UserAvatar] (
	[UserID] [char] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[ItemID] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[UserRoles] (
	[UserID] [char] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[RoleID] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Announcements] (
	[ItemID] [int] IDENTITY (0, 1) NOT NULL ,
	[ModuleID] [int] NOT NULL ,
	[CreatedByUser] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NULL ,
	[CreatedDate] [datetime] NULL ,
	[Title] [nvarchar] (150) COLLATE Korean_Wansung_CI_AS NULL ,
	[MoreLink] [nvarchar] (150) COLLATE Korean_Wansung_CI_AS NULL ,
	[MobileMoreLink] [nvarchar] (150) COLLATE Korean_Wansung_CI_AS NULL ,
	[ExpireDate] [datetime] NULL ,
	[Description] [nvarchar] (2000) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Contacts] (
	[ItemID] [int] IDENTITY (0, 1) NOT NULL ,
	[ModuleID] [int] NOT NULL ,
	[CreatedByUser] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NULL ,
	[CreatedDate] [datetime] NULL ,
	[Name] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[Role] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NULL ,
	[Email] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NULL ,
	[Contact1] [nvarchar] (250) COLLATE Korean_Wansung_CI_AS NULL ,
	[Contact2] [nvarchar] (250) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Discussion] (
	[ItemID] [int] IDENTITY (0, 1) NOT NULL ,
	[ModuleID] [int] NOT NULL ,
	[Title] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NULL ,
	[CreatedDate] [datetime] NULL ,
	[Body] [nvarchar] (3000) COLLATE Korean_Wansung_CI_AS NULL ,
	[DisplayOrder] [nvarchar] (750) COLLATE Korean_Wansung_CI_AS NULL ,
	[CreatedByUser] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Documents] (
	[ItemID] [int] IDENTITY (0, 1) NOT NULL ,
	[ModuleID] [int] NOT NULL ,
	[CreatedByUser] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NULL ,
	[CreatedDate] [datetime] NULL ,
	[FileNameUrl] [nvarchar] (250) COLLATE Korean_Wansung_CI_AS NULL ,
	[FileFriendlyName] [nvarchar] (150) COLLATE Korean_Wansung_CI_AS NULL ,
	[Category] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[Content] [image] NULL ,
	[ContentType] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NULL ,
	[ContentSize] [int] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[Events] (
	[ItemID] [int] IDENTITY (0, 1) NOT NULL ,
	[ModuleID] [int] NOT NULL ,
	[CreatedByUser] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NULL ,
	[CreatedDate] [datetime] NULL ,
	[Title] [nvarchar] (150) COLLATE Korean_Wansung_CI_AS NULL ,
	[WhereWhen] [nvarchar] (150) COLLATE Korean_Wansung_CI_AS NULL ,
	[Description] [nvarchar] (2000) COLLATE Korean_Wansung_CI_AS NULL ,
	[ExpireDate] [datetime] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[FragBoardSetting] (
	[moduleId] [int] NOT NULL ,
	[bbsId] [int] NOT NULL ,
	[fragBoardType] [tinyint] NOT NULL ,
	[openWindowAtStart] [bit] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[HtmlText] (
	[ModuleID] [int] NOT NULL ,
	[DesktopHtml] [ntext] COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[MobileSummary] [ntext] COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[MobileDetails] [ntext] COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[Links] (
	[ItemID] [int] IDENTITY (0, 1) NOT NULL ,
	[ModuleID] [int] NOT NULL ,
	[CreatedByUser] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NULL ,
	[CreatedDate] [datetime] NULL ,
	[Title] [nvarchar] (100) COLLATE Korean_Wansung_CI_AS NULL ,
	[Url] [nvarchar] (250) COLLATE Korean_Wansung_CI_AS NULL ,
	[MobileUrl] [nvarchar] (250) COLLATE Korean_Wansung_CI_AS NULL ,
	[ViewOrder] [int] NULL ,
	[Description] [nvarchar] (2000) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[ModuleSettings] (
	[ModuleID] [int] NOT NULL ,
	[SettingName] [nvarchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[SettingValue] [nvarchar] (256) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_ProductOptList] (
	[ProdId] [int] NOT NULL ,
	[OptionId] [int] NOT NULL ,
	[Text] [varchar] (30) COLLATE Korean_Wansung_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[Shop_Reviews] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[ProductID] [int] NOT NULL ,
	[UserID] [char] (12) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[UserName] [nvarchar] (20) COLLATE Korean_Wansung_CI_AS NULL ,
	[Comments] [nvarchar] (3850) COLLATE Korean_Wansung_CI_AS NULL ,
	[RegDate] [smalldatetime] NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[AddressBook] WITH NOCHECK ADD 
	CONSTRAINT [PK_AddressBook] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[AvatarCategory] WITH NOCHECK ADD 
	CONSTRAINT [PK_AvatarCategory] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[AvatarPositionDef] WITH NOCHECK ADD 
	CONSTRAINT [PK_PositionDef] PRIMARY KEY  CLUSTERED 
	(
		[PositionID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[BBSInfo] WITH NOCHECK ADD 
	CONSTRAINT [PK__BBSSubject__1E05700A] PRIMARY KEY  CLUSTERED 
	(
		[BBSID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[BoardFree01] WITH NOCHECK ADD 
	 PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[BoardFree01Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_BoardFree01Files] PRIMARY KEY  CLUSTERED 
	(
		[bfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[BoardLacture01] WITH NOCHECK ADD 
	CONSTRAINT [PK__BoardLacture01__45DE573A] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[BoardLacture01Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_BoardLacture01Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[ChangedTriger] WITH NOCHECK ADD 
	CONSTRAINT [PK_ChangedTriger] PRIMARY KEY  CLUSTERED 
	(
		[ctTableName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[ClubClass] WITH NOCHECK ADD 
	CONSTRAINT [PK_ClubClass] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[ClubFreeBoard01] WITH NOCHECK ADD 
	CONSTRAINT [PK__ClubFreeBoard01] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[ClubMainAnnouncement01] WITH NOCHECK ADD 
	CONSTRAINT [PK__ClubMainAnnouncement01] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[DownloadBoard] WITH NOCHECK ADD 
	CONSTRAINT [PK_DownloadBoard] PRIMARY KEY  CLUSTERED 
	(
		[dnID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[DownloadBoardComment] WITH NOCHECK ADD 
	CONSTRAINT [PK_DownloadBoardComment] PRIMARY KEY  CLUSTERED 
	(
		[dncID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[DownloadBoardVote] WITH NOCHECK ADD 
	CONSTRAINT [PK_DownloadBoardVote] PRIMARY KEY  CLUSTERED 
	(
		[dnvID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[FreeBoard01] WITH NOCHECK ADD 
	CONSTRAINT [PK__FreeBoard01] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[FreeBoard01Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_FreeBoard01Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[GlobalSettings] WITH NOCHECK ADD 
	CONSTRAINT [PK_GlobalSettings] PRIMARY KEY  CLUSTERED 
	(
		[SettingName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[MainAnnouncement] WITH NOCHECK ADD 
	CONSTRAINT [PK__MainAnnouncement] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[MainAnnouncementFiles] WITH NOCHECK ADD 
	CONSTRAINT [PK_MainAnnouncementFiles] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Pages] WITH NOCHECK ADD 
	CONSTRAINT [PK_Pages] PRIMARY KEY  CLUSTERED 
	(
		[TabID],
		[TargetID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[QABoard01] WITH NOCHECK ADD 
	CONSTRAINT [PK__QABoard01] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[QABoard01Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_QABoard01Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[QABoard02] WITH NOCHECK ADD 
	CONSTRAINT [PK__QABoard02] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[QABoard02Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_QABoard02Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Shop_Brands] WITH NOCHECK ADD 
	CONSTRAINT [PK_Shop_Brands] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Shop_CategoryTop] WITH NOCHECK ADD 
	CONSTRAINT [PK_Shop_CategoryTop] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Shop_Orders] WITH NOCHECK ADD 
	CONSTRAINT [PK_Shop_Orders] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Shop_ProductOption] WITH NOCHECK ADD 
	CONSTRAINT [PK_Shop_ProductOption] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Shop_ShoppingCart] WITH NOCHECK ADD 
	CONSTRAINT [PK_Shop_ShoppingCart] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Shop_ShoppingCartOption] WITH NOCHECK ADD 
	CONSTRAINT [PK_Shop_ShoppingCartOption] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[UserMessage] WITH NOCHECK ADD 
	CONSTRAINT [PK_UserMessage] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[WebmailMailBox] WITH NOCHECK ADD 
	CONSTRAINT [PK_WebmailMailBox] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_10_01] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_10_01] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_10_02] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_10_02] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_10_02Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_10_02Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_10_03] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_10_03] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_10_03Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_10_03Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_10_04] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_10_04] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_10_04Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_10_04Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_10_05] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_10_05] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_10_05Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_10_05Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_14_01] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_14_01] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_14_01Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_14_01Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_14_02] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_14_02] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_14_02Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_14_02Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_14_03] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_14_03] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_14_03Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_14_03Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_14_04] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_14_04] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_14_04Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_14_04Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_14_05] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_14_05] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_14_05Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_14_05Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_17_01] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_17_01] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_17_01Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_17_01Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_17_02] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_17_02] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_17_02Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_17_02Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_17_03] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_17_03] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_17_03Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_17_03Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_17_04] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_17_04] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_17_04Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_17_04Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_17_05] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_17_05] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_17_05Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_17_05Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_22_01] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_22_01] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_22_01Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_22_01Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_22_02] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_22_02] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_22_02Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_22_02Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_22_03] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_22_03] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_22_03Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_22_03Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_22_04] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_22_04] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_22_04Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_22_04Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_22_05] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_22_05] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_22_05Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_22_05Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_23_01] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_23_01] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_23_01Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_23_01Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_23_02] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_23_02] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_23_02Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_23_02Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_23_03] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_23_03] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_23_03Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_23_03Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_23_04] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_23_04] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_23_04Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_23_04Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_23_05] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_23_05] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_23_05Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_23_05Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_24_01] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_24_01] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_24_01Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_24_01Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_24_02] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_24_02] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_24_02Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_24_02Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_24_03] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_24_03] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_24_03Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_24_03Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_24_04] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_24_04] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_24_04Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_24_04Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_24_05] WITH NOCHECK ADD 
	CONSTRAINT [PK__clubTable_24_05] PRIMARY KEY  CLUSTERED 
	(
		[PID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_24_05Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_24_05Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[AvatarItems] WITH NOCHECK ADD 
	CONSTRAINT [PK_AvatarItems] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[ClubFreeBoard01Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_ClubFreeBoard01Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[ClubMainAnnouncement01Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_ClubMainAnnouncement01Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Clubs] WITH NOCHECK ADD 
	CONSTRAINT [PK_Clubs] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Shop_CategoryIndex] WITH NOCHECK ADD 
	CONSTRAINT [PK_Shop_CategoryIndex] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Shop_ProductOptDef] WITH NOCHECK ADD 
	CONSTRAINT [PK_Shop_ProductOptDef] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[WebmailReceptionCheck] WITH NOCHECK ADD 
	CONSTRAINT [PK_WebmailReceptionCheck] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[clubTable_10_01Files] WITH NOCHECK ADD 
	CONSTRAINT [PK_clubTable_10_01Files] PRIMARY KEY  CLUSTERED 
	(
		[blfID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[AvatarExpression] WITH NOCHECK ADD 
	CONSTRAINT [PK_AvatarExpression] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[ClubsBoardInfo] WITH NOCHECK ADD 
	CONSTRAINT [PK_ClubsBoardInfo] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Shop_Products] WITH NOCHECK ADD 
	CONSTRAINT [PK_Shop_Products] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Shop_Reviews] WITH NOCHECK ADD 
	CONSTRAINT [PK_Shop_Reviews] PRIMARY KEY  CLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [IX_AddressBook_UserID] ON [dbo].[AddressBook]([UserID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[AvatarPositionDef] WITH NOCHECK ADD 
	CONSTRAINT [DF_AvatarPositionDef_ExclusiveCircumference] DEFAULT (0) FOR [ExclusiveCircumference]
GO

ALTER TABLE [dbo].[BBSInfo] WITH NOCHECK ADD 
	CONSTRAINT [DF_BBSInfo_BBSUseHtml] DEFAULT (0) FOR [BBSDisplayType],
	CONSTRAINT [DF__BBSSubjec__BBSMs__1EF99443] DEFAULT (0) FOR [BBSMsgDisplay],
	CONSTRAINT [DF_BBSInfo_BBSType] DEFAULT (0) FOR [BBSType]
GO

ALTER TABLE [dbo].[BoardFree01] WITH NOCHECK ADD 
	CONSTRAINT [DF__BoardFree__Visit__22CA2527] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__BoardFree__Recom__23BE4960] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__BoardFree__RegDa__24B26D99] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_BoardFree01_UseAvatar] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF_BoardFree01_AvatarExpression] DEFAULT (0) FOR [AvatarExpression]
GO

 CREATE  INDEX [IX_BoardFree_LinkID] ON [dbo].[BoardFree01]([Order]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[BoardLacture01] WITH NOCHECK ADD 
	CONSTRAINT [DF__BoardLact__Visit__46D27B73] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__BoardLact__Recom__47C69FAC] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__BoardLact__RegDa__48BAC3E5] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_BoardLacture01_FileCount] DEFAULT (0) FOR [FileCount],
	CONSTRAINT [DF_BoardLacture01_UseAvatar] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF_BoardLacture01_AvatarExpression] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[CategoryAspDotNet] WITH NOCHECK ADD 
	CONSTRAINT [IX_CategoryAspDotNet] UNIQUE  NONCLUSTERED 
	(
		[anID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[ChangedTriger] WITH NOCHECK ADD 
	CONSTRAINT [DF_ChangedTriger_ctChangedTime] DEFAULT (getdate()) FOR [ctChangedTime]
GO

ALTER TABLE [dbo].[ClubClass] WITH NOCHECK ADD 
	CONSTRAINT [DF_ClubClass_ccClubCount] DEFAULT (0) FOR [ClubCount]
GO

ALTER TABLE [dbo].[ClubFreeBoard01] WITH NOCHECK ADD 
	CONSTRAINT [DF__ClubFreeB__Visit__3B16B004] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__ClubFreeB__Recom__3C0AD43D] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__ClubFreeB__RegDa__3CFEF876] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_ClubFreeBoard01_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__ClubFreeB__UseAv__3EE740E8] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__ClubFreeB__Avata__3FDB6521] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[ClubMainAnnouncement01] WITH NOCHECK ADD 
	CONSTRAINT [DF__ClubMainA__Visit__52CE3E04] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__ClubMainA__Recom__53C2623D] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__ClubMainA__RegDa__54B68676] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_ClubMainAnnouncement01_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF_ClubMainAnnouncement01_UseAvatar] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF_ClubMainAnnouncement01_AvatarExpression] DEFAULT (0) FOR [AvatarExpression]
GO

 CREATE  INDEX [IX_DailyPlan_UserID_Date] ON [dbo].[DailyPlan]([rtUserID], [rtDate]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[DownloadBoard] WITH NOCHECK ADD 
	CONSTRAINT [DF_DownloadBoard_dnDownloadCount] DEFAULT (0) FOR [dnDownloadCount],
	CONSTRAINT [DF_DownloadBoard_dnRating] DEFAULT ((-1)) FOR [dnRating],
	CONSTRAINT [DF_DownloadBoard_dnVoteCount] DEFAULT ((-1)) FOR [dnVoteCount],
	CONSTRAINT [DF_DownloadBoard_dnCommentCount] DEFAULT (0) FOR [dnCommentCount],
	CONSTRAINT [DF_DownloadBoard_dnRegDate] DEFAULT (getdate()) FOR [dnRegDate],
	CONSTRAINT [DF_DownloadBoard_dnLanguage] DEFAULT (0) FOR [dnLanguage]
GO

 CREATE  INDEX [IX_DownloadBoard] ON [dbo].[DownloadBoard]([dnRating], [dnVoteCount]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_DownloadBoardComment] ON [dbo].[DownloadBoardComment]([dncDnID]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_DownloadBoardVote] ON [dbo].[DownloadBoardVote]([dnvDnID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[FreeBoard01] WITH NOCHECK ADD 
	CONSTRAINT [DF__FreeBoard__Visit__6EAB62A3] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__FreeBoard__Recom__6F9F86DC] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__FreeBoard__RegDa__7093AB15] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_FreeBoard01_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF_FreeBoard01_UseAvatar] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF_FreeBoard01_AvatarExpression] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[MainAnnouncement] WITH NOCHECK ADD 
	CONSTRAINT [DF__MainAnnou__Visit__54575F1A] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__MainAnnou__Recom__554B8353] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__MainAnnou__RegDa__563FA78C] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_MainAnnouncement_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__MainAnnou__UseAv__5827EFFE] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__MainAnnou__Avata__591C1437] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[ModuleDefinitions] WITH NOCHECK ADD 
	CONSTRAINT [PK_ModuleDefinitions] PRIMARY KEY  NONCLUSTERED 
	(
		[ModuleDefID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Pages] WITH NOCHECK ADD 
	CONSTRAINT [DF_Pages_PortalID] DEFAULT (0) FOR [PortalID],
	CONSTRAINT [IX_Pages] UNIQUE  NONCLUSTERED 
	(
		[PageName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Portals] WITH NOCHECK ADD 
	CONSTRAINT [PK_Portals] PRIMARY KEY  NONCLUSTERED 
	(
		[PortalID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[QABoard01] WITH NOCHECK ADD 
	CONSTRAINT [DF__QABoard01__Visit__764C846B] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__QABoard01__Recom__7740A8A4] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__QABoard01__RegDa__7834CCDD] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_QABoard01_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF_QABoard01_UseAvatar] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF_QABoard01_AvatarExpression] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[QABoard02] WITH NOCHECK ADD 
	CONSTRAINT [DF__QABoard02__Visit__7DEDA633] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__QABoard02__Recom__7EE1CA6C] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__QABoard02__RegDa__7FD5EEA5] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_QABoard02_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF_QABoard02_UseAvatar] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF_QABoard02_AvatarExpression] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[Shop_AltercastImageInfo] WITH NOCHECK ADD 
	CONSTRAINT [DF_Shop_AltercastImageInfo_percentStr] DEFAULT ('') FOR [appendString],
	CONSTRAINT [DF_Shop_AltercastImageInfo_stringPlace] DEFAULT ((-1)) FOR [stringPlace],
	CONSTRAINT [DF_Shop_AltercastImageInfo_stringColor] DEFAULT ('') FOR [stringColor],
	CONSTRAINT [DF_Shop_AltercastImageInfo_stringFont] DEFAULT ('') FOR [stringFont],
	CONSTRAINT [DF_Shop_AltercastImageInfo_stringSize] DEFAULT ((-1)) FOR [stringSize],
	CONSTRAINT [DF_Shop_AltercastImageInfo_overCoordX] DEFAULT ((-1)) FOR [overCoordX],
	CONSTRAINT [DF_Shop_AltercastImageInfo_overCoordY] DEFAULT ((-1)) FOR [overCoordY],
	CONSTRAINT [DF_Shop_AltercastImageInfo_overRotate] DEFAULT (0) FOR [overRotate],
	CONSTRAINT [DF_Shop_AltercastImageInfo_overAlpha] DEFAULT ((-1)) FOR [overAlpha],
	CONSTRAINT [DF_Shop_AltercastImageInfo_overPercent] DEFAULT ((-1)) FOR [overPercent],
	CONSTRAINT [DF_Shop_AltercastImageInfo_overStringPosX] DEFAULT ((-1)) FOR [overStringPosX],
	CONSTRAINT [DF_Shop_AltercastImageInfo_overStringPosY] DEFAULT ((-1)) FOR [overStringPosY],
	CONSTRAINT [DF_Shop_AltercastImageInfo_overStringHAuto] DEFAULT (0) FOR [overStringHAuto],
	CONSTRAINT [DF_Shop_AltercastImageInfo_overStringVAuto] DEFAULT (0) FOR [overStringVAuto]
GO

ALTER TABLE [dbo].[Shop_CategoryTop] WITH NOCHECK ADD 
	CONSTRAINT [DF_Shop_CadegoryTop_Order] DEFAULT (1) FOR [SortOrder]
GO

ALTER TABLE [dbo].[Shop_Orders] WITH NOCHECK ADD 
	CONSTRAINT [DF_Shop_Orders_OrderDate] DEFAULT (getdate()) FOR [OrderDate],
	CONSTRAINT [DF_Shop_Orders_Process] DEFAULT (0) FOR [Process],
	CONSTRAINT [DF_Shop_Orders_DeliveryCost] DEFAULT (0) FOR [DeliveryCost],
	CONSTRAINT [DF_Shop_Orders_UsedAccum] DEFAULT (0) FOR [UsedAccum]
GO

ALTER TABLE [dbo].[Shop_ProductOption] WITH NOCHECK ADD 
	CONSTRAINT [IX_Shop_ProductOption_Subject] UNIQUE  NONCLUSTERED 
	(
		[Subject]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Shop_ShoppingCart] WITH NOCHECK ADD 
	CONSTRAINT [DF_Shop_ShoppingCart_Quantity] DEFAULT (1) FOR [Quantity],
	CONSTRAINT [DF_Shop_ShoppingCart_DateCreated] DEFAULT (getdate()) FOR [DateCreated]
GO

ALTER TABLE [dbo].[UserMessage] WITH NOCHECK ADD 
	CONSTRAINT [DF_UserMessage_RecivedDate] DEFAULT (getdate()) FOR [RecivedDate],
	CONSTRAINT [DF_UserMessage_Viewed] DEFAULT (0) FOR [Viewed]
GO

 CREATE  INDEX [IX_UserMessage_UserID] ON [dbo].[UserMessage]([UserID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Users] WITH NOCHECK ADD 
	CONSTRAINT [DF_Users_ShopPoint] DEFAULT (0) FOR [ShopPoint],
	CONSTRAINT [PK_Users] PRIMARY KEY  NONCLUSTERED 
	(
		[UserID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[WebmailMailBox] WITH NOCHECK ADD 
	CONSTRAINT [DF_WebmailMailBox_Viewed] DEFAULT (0) FOR [Viewed],
	CONSTRAINT [DF_WebmailMailBox_RegDate] DEFAULT (getdate()) FOR [RegDate]
GO

 CREATE  INDEX [IX_WebmailMailBox_MailBoxType] ON [dbo].[WebmailMailBox]([MailBoxType]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_WebmailMailBox_UserID] ON [dbo].[WebmailMailBox]([UserID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[clubTable_10_01] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__6541F3FA] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__66361833] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__672A3C6C] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_10_01_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__691284DE] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__6A06A917] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_10_02] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__6ECB5E34] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__6FBF826D] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__70B3A6A6] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_10_02_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__729BEF18] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__73901351] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_10_03] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__7854C86E] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__7948ECA7] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__7A3D10E0] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_10_03_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__7C255952] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__7D197D8B] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_10_04] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__01DE32A8] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__02D256E1] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__03C67B1A] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_10_04_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__05AEC38C] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__06A2E7C5] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_10_05] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__0B679CE2] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__0C5BC11B] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__0D4FE554] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_10_05_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__0F382DC6] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__102C51FF] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_14_01] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__64D7DFA6] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__65CC03DF] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__66C02818] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_14_01_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__68A8708A] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__699C94C3] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_14_02] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__6E6149E0] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__6F556E19] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__70499252] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_14_02_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__7231DAC4] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__7325FEFD] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_14_03] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__77EAB41A] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__78DED853] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__79D2FC8C] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_14_03_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__7BBB44FE] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__7CAF6937] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_14_04] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__01741E54] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__0268428D] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__035C66C6] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_14_04_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__0544AF38] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__0638D371] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_14_05] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__0AFD888E] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__0BF1ACC7] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__0CE5D100] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_14_05_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__0ECE1972] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__0FC23DAB] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_17_01] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__4218B34E] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__430CD787] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__4400FBC0] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_17_01_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__45E94432] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__46DD686B] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_17_02] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__4BA21D88] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__4C9641C1] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__4D8A65FA] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_17_02_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__4F72AE6C] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__5066D2A5] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_17_03] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__552B87C2] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__561FABFB] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__5713D034] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_17_03_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__58FC18A6] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__59F03CDF] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_17_04] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__5EB4F1FC] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__5FA91635] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__609D3A6E] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_17_04_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__628582E0] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__6379A719] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_17_05] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__683E5C36] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__6932806F] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__6A26A4A8] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_17_05_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__6C0EED1A] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__6D031153] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_22_01] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__5B6E70FD] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__5C629536] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__5D56B96F] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_22_01_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__5F3F01E1] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__6033261A] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_22_02] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__64F7DB37] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__65EBFF70] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__66E023A9] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_22_02_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__68C86C1B] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__69BC9054] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_22_03] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__6E814571] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__6F7569AA] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__70698DE3] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_22_03_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__7251D655] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__7345FA8E] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_22_04] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__780AAFAB] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__78FED3E4] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__79F2F81D] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_22_04_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__7BDB408F] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__7CCF64C8] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_22_05] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__019419E5] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__02883E1E] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__037C6257] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_22_05_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__0564AAC9] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__0658CF02] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_23_01] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__0B1D841F] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__0C11A858] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__0D05CC91] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_23_01_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__0EEE1503] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__0FE2393C] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_23_02] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__14A6EE59] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__159B1292] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__168F36CB] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_23_02_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__18777F3D] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__196BA376] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_23_03] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__1E305893] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__1F247CCC] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__2018A105] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_23_03_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__2200E977] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__22F50DB0] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_23_04] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__27B9C2CD] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__28ADE706] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__29A20B3F] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_23_04_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__2B8A53B1] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__2C7E77EA] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_23_05] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__31432D07] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__32375140] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__332B7579] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_23_05_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__3513BDEB] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__3607E224] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_24_01] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__3BC0BB7A] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__3CB4DFB3] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__3DA903EC] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_24_01_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__3F914C5E] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__40857097] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_24_02] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__454A25B4] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__463E49ED] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__47326E26] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_24_02_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__491AB698] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__4A0EDAD1] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_24_03] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__4ED38FEE] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__4FC7B427] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__50BBD860] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_24_03_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__52A420D2] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__5398450B] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_24_04] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__585CFA28] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__59511E61] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__5A45429A] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_24_04_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__5C2D8B0C] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__5D21AF45] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[clubTable_24_05] WITH NOCHECK ADD 
	CONSTRAINT [DF__clubTable__Visit__61E66462] DEFAULT ('0') FOR [Visited],
	CONSTRAINT [DF__clubTable__Recom__62DA889B] DEFAULT ('0') FOR [Recom],
	CONSTRAINT [DF__clubTable__RegDa__63CEACD4] DEFAULT ('getdate()') FOR [RegDate],
	CONSTRAINT [DF_clubTable_24_05_FileCount] DEFAULT ('0') FOR [FileCount],
	CONSTRAINT [DF__clubTable__UseAv__65B6F546] DEFAULT (1) FOR [UseAvatar],
	CONSTRAINT [DF__clubTable__Avata__66AB197F] DEFAULT (0) FOR [AvatarExpression]
GO

ALTER TABLE [dbo].[AvatarItems] WITH NOCHECK ADD 
	CONSTRAINT [DF_AvatarItems_Cost] DEFAULT (0) FOR [Cost]
GO

 CREATE  INDEX [IX_AvatarItems_PositionID] ON [dbo].[AvatarItems]([PositionID]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_AvatarItems_CategoryID] ON [dbo].[AvatarItems]([CategoryID]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_AvatarPositionAction_PositionID] ON [dbo].[AvatarPositionAction]([PositionID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Clubs] WITH NOCHECK ADD 
	CONSTRAINT [DF_Clubs_clIsPublic] DEFAULT (0) FOR [PublicType],
	CONSTRAINT [DF_Clubs_ViceSysopIDs] DEFAULT ('') FOR [ViceSysopIDs],
	CONSTRAINT [DF_Clubs_clMemberCount] DEFAULT (0) FOR [MemberCount],
	CONSTRAINT [DF_Clubs_clCreatedDate] DEFAULT (getdate()) FOR [CreatedDate],
	CONSTRAINT [DF_Clubs_MainHtml] DEFAULT ('') FOR [MainHtml],
	CONSTRAINT [DF_Clubs_SkinType] DEFAULT (1) FOR [SkinType]
GO

ALTER TABLE [dbo].[Roles] WITH NOCHECK ADD 
	CONSTRAINT [PK_Roles] PRIMARY KEY  NONCLUSTERED 
	(
		[RoleID]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [IX_Shop_ProductOptDef_ID] ON [dbo].[Shop_ProductOptDef]([OptionID], [SortOrder]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Tabs] WITH NOCHECK ADD 
	CONSTRAINT [PK_Tabs] PRIMARY KEY  NONCLUSTERED 
	(
		[TabID]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [IX_WebmailAttachFiles_MailIndex] ON [dbo].[WebmailAttachFiles]([MailID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[WebmailReceptionCheck] WITH NOCHECK ADD 
	CONSTRAINT [DF_WebmailReceptionCheck_Checked] DEFAULT (0) FOR [Checked],
	CONSTRAINT [DF_WebmailReceptionCheck_SentDate] DEFAULT (getdate()) FOR [SentDate]
GO

 CREATE  INDEX [IX_WebmailReceptionCheck_UserID] ON [dbo].[WebmailReceptionCheck]([UserID]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_AvatarItemsImagesItemsID] ON [dbo].[AvatarItemImages]([ItemID]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_AvatarPositionMaps_PositionID] ON [dbo].[AvatarPositionMaps]([PositionID]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_AvatarPositionMaps_AccessoryID] ON [dbo].[AvatarPositionMaps]([AccessoryID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[ClubUsers] WITH NOCHECK ADD 
	CONSTRAINT [DF_ClubUsers_EntryDate] DEFAULT (getdate()) FOR [EntryDate],
	CONSTRAINT [DF_ClubUsers_VisitedCount] DEFAULT (0) FOR [VisitedCount],
	CONSTRAINT [DF_ClubUsers_Agreement] DEFAULT (1) FOR [Agreement]
GO

 CREATE  INDEX [IX_ClubUsers_CluvID] ON [dbo].[ClubUsers]([ClubID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[ClubsBoardInfo] WITH NOCHECK ADD 
	CONSTRAINT [DF_ClubsBoardInfo_DisplayType] DEFAULT (0) FOR [DisplayType],
	CONSTRAINT [DF_ClubsBoardInfo_Type] DEFAULT (0) FOR [Type]
GO

 CREATE  INDEX [IX_ClubsBoardInfo_ClubID] ON [dbo].[ClubsBoardInfo]([ClubID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Modules] WITH NOCHECK ADD 
	CONSTRAINT [DF_Modules_PortalID] DEFAULT (0) FOR [PortalID],
	CONSTRAINT [DF_Modules_TargetID] DEFAULT (0) FOR [TargetID],
	CONSTRAINT [DF_Modules_CacheMode] DEFAULT (0) FOR [CacheMode],
	CONSTRAINT [PK_Modules] PRIMARY KEY  NONCLUSTERED 
	(
		[ModuleID]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [IX_Modules] ON [dbo].[Modules]([TabID], [TargetID]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_Modules_1] ON [dbo].[Modules]([TabID], [TargetID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Shop_Products] WITH NOCHECK ADD 
	CONSTRAINT [DF_Shop_Products_PriceDiscount] DEFAULT (0) FOR [DiscountPercent],
	CONSTRAINT [DF_Shop_Products_Rcommendation] DEFAULT (0) FOR [Recommendation],
	CONSTRAINT [DF_Shop_Products_Absence] DEFAULT (0) FOR [Absence],
	CONSTRAINT [DF_Shop_Products_RegDate] DEFAULT (getdate()) FOR [RegDate],
	CONSTRAINT [DF_Shop_Products_SaleCount] DEFAULT (0) FOR [SaleCount],
	CONSTRAINT [DF_Shop_Products_BestImageGenerated] DEFAULT (0) FOR [BestImageGenerated],
	CONSTRAINT [DF_Shop_Products_SaleImageGenerated] DEFAULT (0) FOR [SaleImageGenerated],
	CONSTRAINT [DF_Shop_Products_RecomImageGenerated] DEFAULT (0) FOR [RecomImageGenerated]
GO

 CREATE  INDEX [IX_UserAvatar_UserID] ON [dbo].[UserAvatar]([UserID]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Announcements] WITH NOCHECK ADD 
	CONSTRAINT [PK_Announcements] PRIMARY KEY  NONCLUSTERED 
	(
		[ItemID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Contacts] WITH NOCHECK ADD 
	CONSTRAINT [PK_Contacts] PRIMARY KEY  NONCLUSTERED 
	(
		[ItemID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Discussion] WITH NOCHECK ADD 
	CONSTRAINT [PK_Discussion] PRIMARY KEY  NONCLUSTERED 
	(
		[ItemID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Documents] WITH NOCHECK ADD 
	CONSTRAINT [PK_Documents] PRIMARY KEY  NONCLUSTERED 
	(
		[ItemID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Events] WITH NOCHECK ADD 
	CONSTRAINT [PK_Events] PRIMARY KEY  NONCLUSTERED 
	(
		[ItemID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[FragBoardSetting] WITH NOCHECK ADD 
	CONSTRAINT [DF_FragBoardSetting_openWindowAtStart] DEFAULT (0) FOR [openWindowAtStart],
	CONSTRAINT [IX_FragBoardSetting] UNIQUE  NONCLUSTERED 
	(
		[moduleId]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[HtmlText] WITH NOCHECK ADD 
	CONSTRAINT [PK_HtmlText] PRIMARY KEY  NONCLUSTERED 
	(
		[ModuleID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Links] WITH NOCHECK ADD 
	CONSTRAINT [PK_Links] PRIMARY KEY  NONCLUSTERED 
	(
		[ItemID]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [IX_ModuleSettings] ON [dbo].[ModuleSettings]([ModuleID], [SettingName]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Shop_Reviews] WITH NOCHECK ADD 
	CONSTRAINT [DF_Shop_Reviews_RegDate] DEFAULT (getdate()) FOR [RegDate]
GO

ALTER TABLE [dbo].[AvatarItems] ADD 
	CONSTRAINT [FK_AvatarItems_AvatarCategory] FOREIGN KEY 
	(
		[CategoryID]
	) REFERENCES [dbo].[AvatarCategory] (
		[ID]
	)
GO

ALTER TABLE [dbo].[AvatarPositionAction] ADD 
	CONSTRAINT [FK_AvatarPositionAction_AvatarPositionDef] FOREIGN KEY 
	(
		[PositionID]
	) REFERENCES [dbo].[AvatarPositionDef] (
		[PositionID]
	)
GO

ALTER TABLE [dbo].[ClubFreeBoard01Files] ADD 
	CONSTRAINT [FK_ClubFreeBoard01Files_ClubFreeBoard01] FOREIGN KEY 
	(
		[blfID]
	) REFERENCES [dbo].[ClubFreeBoard01] (
		[ID]
	)
GO

ALTER TABLE [dbo].[ClubMainAnnouncement01Files] ADD 
	CONSTRAINT [FK_ClubMainAnnouncement01Files_ClubMainAnnouncement01] FOREIGN KEY 
	(
		[blfID]
	) REFERENCES [dbo].[ClubMainAnnouncement01] (
		[ID]
	)
GO

ALTER TABLE [dbo].[Clubs] ADD 
	CONSTRAINT [FK_Clubs_ClubClass] FOREIGN KEY 
	(
		[ClassID]
	) REFERENCES [dbo].[ClubClass] (
		[ID]
	)
GO

ALTER TABLE [dbo].[Roles] ADD 
	CONSTRAINT [FK_Roles_Portals] FOREIGN KEY 
	(
		[PortalID]
	) REFERENCES [dbo].[Portals] (
		[PortalID]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[Shop_CategoryIndex] ADD 
	CONSTRAINT [FK_Shop_CategoryIndex_Shop_CategoryTop] FOREIGN KEY 
	(
		[TopID]
	) REFERENCES [dbo].[Shop_CategoryTop] (
		[ID]
	)
GO

ALTER TABLE [dbo].[Shop_ProductOptDef] ADD 
	CONSTRAINT [FK_Shop_ProductOptDef_Shop_ProductOption] FOREIGN KEY 
	(
		[OptionID]
	) REFERENCES [dbo].[Shop_ProductOption] (
		[ID]
	)
GO

ALTER TABLE [dbo].[Tabs] ADD 
	CONSTRAINT [FK_Tabs_Portals] FOREIGN KEY 
	(
		[PortalID]
	) REFERENCES [dbo].[Portals] (
		[PortalID]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[WebmailAttachFiles] ADD 
	CONSTRAINT [FK_WebmailAttachFiles_WebmailMailBox] FOREIGN KEY 
	(
		[MailID]
	) REFERENCES [dbo].[WebmailMailBox] (
		[ID]
	)
GO

ALTER TABLE [dbo].[WebmailReceptionCheck] ADD 
	CONSTRAINT [FK_WebmailReceptionCheck_Users] FOREIGN KEY 
	(
		[UserID]
	) REFERENCES [dbo].[Users] (
		[UserID]
	)
GO

ALTER TABLE [dbo].[clubTable_10_01Files] ADD 
	CONSTRAINT [FK_clubTable_10_01Files_clubTable_10_01] FOREIGN KEY 
	(
		[blfPID]
	) REFERENCES [dbo].[clubTable_10_01] (
		[PID]
	)
GO

ALTER TABLE [dbo].[AvatarExpression] ADD 
	CONSTRAINT [FK_AvatarExpression_AvatarItems] FOREIGN KEY 
	(
		[ItemID]
	) REFERENCES [dbo].[AvatarItems] (
		[ID]
	)
GO

ALTER TABLE [dbo].[AvatarItemImages] ADD 
	CONSTRAINT [FK_AvatarItemsImages_AvatarItems] FOREIGN KEY 
	(
		[ItemID]
	) REFERENCES [dbo].[AvatarItems] (
		[ID]
	) ON DELETE CASCADE 
GO

ALTER TABLE [dbo].[AvatarPositionMaps] ADD 
	CONSTRAINT [FK_AvatarPositionMaps_AvatarItems] FOREIGN KEY 
	(
		[AccessoryID]
	) REFERENCES [dbo].[AvatarItems] (
		[ID]
	),
	CONSTRAINT [FK_PositionMaps_PositionDef] FOREIGN KEY 
	(
		[PositionID]
	) REFERENCES [dbo].[AvatarPositionDef] (
		[PositionID]
	)
GO

ALTER TABLE [dbo].[ClubUsers] ADD 
	CONSTRAINT [FK_ClubUsers_Clubs] FOREIGN KEY 
	(
		[ClubID]
	) REFERENCES [dbo].[Clubs] (
		[ID]
	)
GO

ALTER TABLE [dbo].[ClubsBoardInfo] ADD 
	CONSTRAINT [FK_ClubsBoardInfo_Clubs] FOREIGN KEY 
	(
		[ClubID]
	) REFERENCES [dbo].[Clubs] (
		[ID]
	)
GO

ALTER TABLE [dbo].[Modules] ADD 
	CONSTRAINT [FK_Modules_ModuleDefinitions] FOREIGN KEY 
	(
		[ModuleDefID]
	) REFERENCES [dbo].[ModuleDefinitions] (
		[ModuleDefID]
	),
	CONSTRAINT [FK_Modules_Pages] FOREIGN KEY 
	(
		[TabID],
		[TargetID]
	) REFERENCES [dbo].[Pages] (
		[TabID],
		[TargetID]
	),
	CONSTRAINT [FK_Modules_Tabs] FOREIGN KEY 
	(
		[TabID]
	) REFERENCES [dbo].[Tabs] (
		[TabID]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[Shop_Products] ADD 
	CONSTRAINT [FK_Shop_Products_Shop_CategoryIndex] FOREIGN KEY 
	(
		[IndexID]
	) REFERENCES [dbo].[Shop_CategoryIndex] (
		[ID]
	)
GO

ALTER TABLE [dbo].[UserAvatar] ADD 
	CONSTRAINT [FK_UserAvatar_AvatarItems] FOREIGN KEY 
	(
		[ItemID]
	) REFERENCES [dbo].[AvatarItems] (
		[ID]
	),
	CONSTRAINT [FK_UserAvatar_Users] FOREIGN KEY 
	(
		[UserID]
	) REFERENCES [dbo].[Users] (
		[UserID]
	)
GO

ALTER TABLE [dbo].[UserRoles] ADD 
	CONSTRAINT [FK_UserRoles_Roles] FOREIGN KEY 
	(
		[RoleID]
	) REFERENCES [dbo].[Roles] (
		[RoleID]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_UserRoles_Users] FOREIGN KEY 
	(
		[UserID]
	) REFERENCES [dbo].[Users] (
		[UserID]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[Announcements] ADD 
	CONSTRAINT [FK_Announcements_Modules] FOREIGN KEY 
	(
		[ModuleID]
	) REFERENCES [dbo].[Modules] (
		[ModuleID]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[Contacts] ADD 
	CONSTRAINT [FK_Contacts_Modules] FOREIGN KEY 
	(
		[ModuleID]
	) REFERENCES [dbo].[Modules] (
		[ModuleID]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[Discussion] ADD 
	CONSTRAINT [FK_Discussion_Modules] FOREIGN KEY 
	(
		[ModuleID]
	) REFERENCES [dbo].[Modules] (
		[ModuleID]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[Documents] ADD 
	CONSTRAINT [FK_Documents_Modules] FOREIGN KEY 
	(
		[ModuleID]
	) REFERENCES [dbo].[Modules] (
		[ModuleID]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[Events] ADD 
	CONSTRAINT [FK_Events_Modules] FOREIGN KEY 
	(
		[ModuleID]
	) REFERENCES [dbo].[Modules] (
		[ModuleID]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[FragBoardSetting] ADD 
	CONSTRAINT [FK_FragBoardSetting_BBSInfo] FOREIGN KEY 
	(
		[bbsId]
	) REFERENCES [dbo].[BBSInfo] (
		[BBSID]
	),
	CONSTRAINT [FK_FragBoardSetting_Modules] FOREIGN KEY 
	(
		[moduleId]
	) REFERENCES [dbo].[Modules] (
		[ModuleID]
	)
GO

ALTER TABLE [dbo].[HtmlText] ADD 
	CONSTRAINT [FK_HtmlText_Modules] FOREIGN KEY 
	(
		[ModuleID]
	) REFERENCES [dbo].[Modules] (
		[ModuleID]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[Links] ADD 
	CONSTRAINT [FK_Links_Modules] FOREIGN KEY 
	(
		[ModuleID]
	) REFERENCES [dbo].[Modules] (
		[ModuleID]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[ModuleSettings] ADD 
	CONSTRAINT [FK_ModuleSettings_Modules] FOREIGN KEY 
	(
		[ModuleID]
	) REFERENCES [dbo].[Modules] (
		[ModuleID]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[Shop_ProductOptList] ADD 
	CONSTRAINT [FK_Shop_ProdOptList_Shop_ProductOption] FOREIGN KEY 
	(
		[OptionId]
	) REFERENCES [dbo].[Shop_ProductOption] (
		[ID]
	),
	CONSTRAINT [FK_Shop_ProdOptList_Shop_Products] FOREIGN KEY 
	(
		[ProdId]
	) REFERENCES [dbo].[Shop_Products] (
		[ID]
	)
GO

ALTER TABLE [dbo].[Shop_Reviews] ADD 
	CONSTRAINT [FK_Shop_Reviews_Shop_Products] FOREIGN KEY 
	(
		[ProductID]
	) REFERENCES [dbo].[Shop_Products] (
		[ID]
	)
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE TRIGGER [CategoryAspDotNetChanged] ON [dbo].[CategoryAspDotNet] 
FOR INSERT, UPDATE, DELETE 
AS

DECLARE @curtime varchar(50)
DECLARE @cmd varchar(100)

SET @curtime = getdate()
SET @cmd = 'echo ' + @curtime + ' > c:\CategoryAspDotNet.cache'
EXEC master..xp_cmdshell @cmd

update ChangedTriger set ctChangedTime=getdate() where ctTableName='CategoryAspDotNet' 

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO

CREATE TRIGGER [DownloadBoardTriger] ON dbo.DownloadBoard 
FOR INSERT, UPDATE, DELETE 
AS

DECLARE @curtime varchar(50)
DECLARE @cmd varchar(100)

SET @curtime = getdate()
SET @cmd = 'echo ' + @curtime + ' > c:\DownloadBoard.cache'
EXEC master..xp_cmdshell @cmd

update ChangedTriger set ctChangedTime=getdate() where ctTableName='DownloadBoard'

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

