using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace Chapter08
{
	public class WebForm3 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button Button1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			string keys = String.Empty;
			foreach (string key in Request.Cookies.Keys)
				keys += key + ",";
			//string tt1 = Request.Cookies["cookie_a"].Value;

			HttpCookie cookieA = new HttpCookie("cookie_a");
			cookieA.Value = "cookie_a Value";
			cookieA.Expires = DateTime.Now.AddMinutes(10);
			Response.AppendCookie(cookieA);

			Response.Cookies["cookie_b"].Value = "cookie_b Value";
			Response.Cookies["cookie_b"].Expires = DateTime.Now.AddMinutes(10);

			HttpCookie multiCookieA = new HttpCookie("multi_cookie_a");
			multiCookieA.Values["mc_aa"] = "multi_cookie_a Sub a";
			multiCookieA.Values["mc_ab"] = "multi_cookie_a Sub b";
			multiCookieA.Expires = DateTime.Now.AddMinutes(10);
			Response.AppendCookie(multiCookieA);

			Response.Cookies["multi_cookie_b"]["mc_ba"] = "multi_cookie_b Sub a";
			Response.Cookies["multi_cookie_b"]["mc_bb"] = "multi_cookie_b Sub b";
			Response.Cookies["multi_cookie_b"].Expires = DateTime.Now.AddMinutes(10);

			HttpCookie cookie = Request.Cookies["multi_cookie_b"];

			string mcba = Request.Cookies["multi_cookie_b"]["mc_ba"];

			Response.Cookies["cookie_a"].Expires = DateTime.MinValue;
			//Request.Cookies["cookie_a"].Expires = DateTime.MinValue;

			Response.Cookies["cookie_a"].Value = null;
			//Request.Cookies.Remove("cookie_a");
			//Response.Cookies.Remove("cookie_a");

			//Response.AppendCookie(cookieA);

			TestClass tc = new TestClass("a", "b");
			Session["tc"] = tc;
			//ViewState["tc"] = tc;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}

	//[Serializable()]
	public class TestClass
	{
		public string _a;

		//[NonSerialized()]
		public string _b;
		
		public TestClass(string a, string b)
		{
			_a = a;
			_b = b;
		}
	}
}
