using System;

namespace Chapter10 
{
	public class Global : System.Web.HttpApplication
	{
		public override string GetVaryByCustomString(System.Web.HttpContext context, string custom)
		{
			switch (custom)
			{
				case "ClrVersion" : 
					return "ClrVersion=" + context.Request.Browser.ClrVersion;
				case "UserID" :
					return "UserID=" + context.Request.Cookies["UserID"].Value;
				case "Param" :
					return "Param=" + context.Request.QueryString["Param"];
				default :
					return null;
			}
		}

		protected void WindowsAuthentication_OnAuthenticate(Object sender, EventArgs e)
		{
			Response.Write("WindowsAuthentication_OnAuthenticate<br><br>");
		}
	}
}

