using System;
using System.IO;
using System.Data;
using System.Web.Security;
using System.Web.UI.WebControls;

namespace Chapter11.Ex06
{
	public class Chap11_Ex06 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox TextBox1;
		protected System.Web.UI.WebControls.TextBox TextBox2;
		protected System.Web.UI.WebControls.Button btnLogin;
		protected System.Web.UI.WebControls.Button btnLogout;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.PlaceHolder PlaceHolder1;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!Request.IsAuthenticated)
			{
				PlaceHolder1.Visible = true;
				btnLogin.Enabled = true;
				btnLogout.Enabled = false;
				Label1.Visible = false;
			}
			else
			{
				PlaceHolder1.Visible = false;
				btnLogin.Enabled = false;
				btnLogout.Enabled = true;
				Label1.Visible = true;
				Label1.Text = User.Identity.Name + " 湮 ȯմϴ.";
				Label2.Visible = false;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.btnLogin.Click += new System.EventHandler(this.btnLogin_Click);
			this.btnLogout.Click += new System.EventHandler(this.btnLogout_Click);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void btnLogin_Click(object sender, System.EventArgs e)
		{
			string id = TextBox1.Text;
			string password = TextBox2.Text;
			DataTable dt;
			DataRow[] found;
			DataSet ds = new DataSet();
			FileStream fs = new FileStream(MapPath("users.xml"), FileMode.Open);

			ds.ReadXml(new StreamReader(fs));
			fs.Close();

			dt = ds.Tables[0];
			found = dt.Select("id='" + id + "'");

			if (found.Length > 0)
			{
				string pw = found[0]["password"].ToString();
				if (pw == password)
				{
					FormsAuthentication.SetAuthCookie(id, false);
					Response.Redirect(Request.RawUrl);
				}
				else
				{
					Label2.Text = "Password Ʋϴ.";
					Label2.Visible = true;
				}
			}
			else
			{
				Label2.Text = "ԷϽ ID  ʽϴ.";
				Label2.Visible = true;
			}
		}

		private void btnLogout_Click(object sender, System.EventArgs e)
		{
			FormsAuthentication.SignOut();

			Response.Redirect(Request.RawUrl);
		}
	}
}
