using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Web.UI.WebControls;

namespace Chapter13
{
	public class WebForm1 : System.Web.UI.Page
	{
		private void Page_Load(object sender, System.EventArgs e)
		{
			Bitmap bitmap = new Bitmap(200, 100);
			Graphics graphics = Graphics.FromImage(bitmap);

			SolidBrush backBrush = new SolidBrush(Color.White);
			Rectangle rect = new Rectangle(0,0,200,100);
			graphics.FillRectangle(backBrush, rect);

			Font font = new Font("ü", 11.0F);
			SolidBrush strintBrush = new SolidBrush(Color.Blue);
			graphics.DrawString("  ̹", font, strintBrush, 15.0F, 20.0F);

			Pen pan = new Pen(Color.Aqua, 2);
			graphics.DrawRectangle(pan, 5, 10, 180, 40);

			//bitmap.Save(MapPath(Request.ApplicationPath) + "\\image.gif", ImageFormat.Gif);
			bitmap.Save(Response.OutputStream, ImageFormat.Gif);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
