using System;

namespace Chapter14.Ex01 
{
	public class Global : System.Web.HttpApplication
	{
		public Global()
		{
			InitializeComponent();
		}	
		
		protected void Application_Start(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_Start");
		}
 
		protected void Session_Start(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Session_Start");
		}

		protected void Application_BeginRequest(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_BeginRequest");
		}

		protected void Application_EndRequest(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_EndRequest");
		}

		protected void Application_AuthenticateRequest(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_AuthenticateRequest");
		}

		protected void Application_Error(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_Error : " + Context.Error.Message);
		}

		protected void Session_End(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Session_End");
		}

		protected void Application_End(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_End");
		}

		protected void Application_ResolveRequestCache(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_ResolveRequestCache");
		}

		protected void Application_AcquireRequestState(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_AcquireRequestState");
		}

		protected void Application_PreRequestHandlerExecute(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_PreRequestHandlerExecute");
		}

		protected void Application_PostRequestHandlerExecute(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_PostRequestHandlerExecute");
		}

		protected void Application_ReleaseRequestState(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_ReleaseRequestState");
		}

		protected void Application_UpdateRequestCache(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_UpdateRequestCache");
		}

		protected void Application_PreSendRequestHeaders(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_PreSendRequestHeaders");
		}

		protected void Application_PreSendRequestContent(Object sender, EventArgs e)
		{
			WriteMessage.WriteToFile("Application_PreSendRequestContent");
		}

		#region Web Form Designer generated code
		private void InitializeComponent()
		{    
			this.BeginRequest += new System.EventHandler(this.Global_BeginRequest);
		}
		#endregion

		private void Global_BeginRequest(object sender, System.EventArgs e)
		{
			WriteMessage.WriteToFile("Global_BeginRequest");
		}
	}
}

