using System;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.Configuration;

namespace Chapter16.BLOB
{
	public class GetImage : IHttpHandler
	{
		public void ProcessRequest(HttpContext context)
		{
			int id = Convert.ToInt32(context.Request.QueryString["id"]);

			string strSqlConn = 
				ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select size, type, image from tbBLOB ";
			strQuery += "where id=" + id;
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();

			try
			{
				SqlDataReader dr = cmdSql.ExecuteReader(CommandBehavior.SequentialAccess);
				dr.Read();

				long size = dr.GetInt64(0);
				string type = (string)dr.GetString(1);
				//byte[] aImage = (byte[])dr["Image"];
				int bufferSize = 2048;
				byte[] buff = new byte[bufferSize];
				long readTotal = 0;
				long readByte;

				context.Response.ContentType = type;
				
				do {
					readByte = dr.GetBytes(2, readTotal, buff, 0, bufferSize);
					if (readByte == 0) break;

					context.Response.OutputStream.Write(buff, 0, (int)readByte);
					readTotal += readByte;
				} while (bufferSize == readByte);
				
				//context.Response.OutputStream.Write(aImage, 0, (int)size);
			}
			catch (	Exception err)	
			{
				string s = err.Message;
			}
			finally
			{
				sqlConn.Close();
			}
		}

		public bool IsReusable
		{
			get { return true; }
		}

	}
}
