using System;
using System.Drawing;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter19.Ex06
{
	public class Chap19_Ex06 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Table Table1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			long totalPrice = 0;// հ
			int rowCount = 0;//  ټ
			TableRow row;
			TableCell cell;
			
			SqlDataReader dr = GetData();
			while (dr.Read())
			{
				row = new TableRow();

				//¦ °   
				if (rowCount++ % 2 == 0)
					row.BackColor = Color.Cornsilk;

				//ID 
				string id = dr["id"].ToString();
				cell = new TableCell();
				cell.Text = id;
				cell.BorderWidth = 1;
				row.Cells.Add(cell);

				//ǰ ̸
				string item = dr["item"].ToString();
				cell = new TableCell();
				HyperLink hyplnkItem = new HyperLink();
				hyplnkItem.NavigateUrl = "LinkPage.aspx?id=" + id;
				hyplnkItem.Text = item;
				cell.BorderWidth = 1;
				cell.Controls.Add(hyplnkItem);
				row.Cells.Add(cell);

				// 
				long price = Convert.ToInt64(dr["price"]);
				totalPrice += price;
				cell = new TableCell();
				cell.Text = price.ToString("c");
				cell.HorizontalAlign = HorizontalAlign.Right;
				cell.BorderWidth = 1;
				row.Cells.Add(cell);

				//ϼ  ̺ ߰
				Table1.Rows.Add(row);
			}
			//հ 
			row = new TableRow();
			row.BackColor = Color.Azure;

			cell = new TableCell();
			cell.HorizontalAlign = HorizontalAlign.Center;
			cell.ColumnSpan = 3;
			cell.Text = "հ : " + totalPrice.ToString("c");

			row.Cells.Add(cell);
			Table1.Rows.Add(row);
		}

		private SqlDataReader GetData()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select id, item, price from tbDataPresentation1";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = null;

			dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
