using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter19
{
	public class MultiSelect : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid DataGrid1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
				BindData();
		}

		private void BindData()
		{
			DataGrid1.DataSource = GetData();
			DataGrid1.DataBind();
		}

		private SqlDataReader GetData()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select * from tbDataPresentation2";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = null;

			dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.DataGrid1.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.DataGrid1_ItemCommand);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void DataGrid1_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			if (e.CommandName == "CheckSelected")
			{
				Response.Write("<h3>õ  </h3>");
				
				foreach(DataGridItem item in DataGrid1.Items)
				{
					CheckBox chkboxSelect = (CheckBox)item.Cells[0].FindControl("chkboxSelect");
					if (chkboxSelect.Checked)
					{
						string outputStr = "<b>ID:</b>" + item.Cells[1].Text;
						outputStr += "<br><b>:</b>" + item.Cells[2].Text;
						outputStr += "<br>" + ((DataBoundLiteralControl)item.Cells[3].Controls[0]).Text;
						Response.Write(outputStr + "<br>");
					}
				}
			}
		}
	}
}
