<%@ Page %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Data.Common" %>
<HTML>
	<script language="C#" runat="server">
	public ICollection GetData()
	{
		string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
		string strQuery = "select * from tbDataPresentation2";
		SqlConnection sqlConn = new SqlConnection(strSqlConn);
		SqlDataAdapter da = new SqlDataAdapter(strQuery, sqlConn);

		DataSet ds = new DataSet();
		da.Fill(ds, "DataPresentation2");
		return ds.Tables["DataPresentation2"].DefaultView;
	}

	void Page_Load(Object sender, EventArgs e) 
	{
		DataGrid1.DataSource = GetData();
		DataGrid1.DataBind();
	}

	void Item_Bound(Object sender, DataGridItemEventArgs e) 
	{
		Response.Write("ItemDataBound : " + e.Item.ItemIndex +  ", " + 
			e.Item.ItemType.ToString() + "<br>");
	}
	
	void Item_Created(Object sender, DataGridItemEventArgs e) 
	{
		Response.Write("ItemCreated : " +  e.Item.ItemIndex +  ", " + 
			e.Item.ItemType.ToString() + "<br>");
	}

	</script>
	<BODY>
		<form method="post" runat="server" ID="Form1">
			<asp:datagrid id="DataGrid1" runat="server" AutoGenerateColumns="False" OnItemDataBound="Item_Bound" OnItemCreated="Item_Created" AllowPaging="True" PageSize="5">
				<HeaderStyle BackColor="#00AAAA"></HeaderStyle>
				<PagerStyle BackColor="#00AAAA"></PagerStyle>
				<Columns>
					<asp:BoundColumn DataField="title" HeaderText=""></asp:BoundColumn>
					<asp:TemplateColumn HeaderText="">
						<HeaderTemplate>
							<FONT face=""></FONT>
						</HeaderTemplate>
						<ItemTemplate>
							:
							<%# DataBinder.Eval(Container.DataItem, "author" ) %>
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:datagrid>
		</form>
	</BODY>
</HTML>
