using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;

namespace Chapter20
{
	/// <summary>
	/// OverImageManager   Դϴ.
	/// </summary>
	public class OverImageManager : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataList datlstOverImages;
		protected System.Web.UI.WebControls.Button btnImageUpload;
		protected System.Web.UI.HtmlControls.HtmlInputFile fileOverImage;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
				OverImagesDataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnImageUpload.Click += new System.EventHandler(this.btnImageUpload_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnImageUpload_Click(object sender, System.EventArgs e)
		{
			string fileName = fileOverImage.PostedFile.FileName;
			if (fileName.Trim() != String.Empty)
			{
				fileName = fileName.Substring(fileName.LastIndexOf("\\") + 1);
				fileName = fileName.ToLower();
				if (fileName.Substring(fileName.Length-4) == ".jpg" || 
					fileName.Substring(fileName.Length-4) == ".gif")
				{
					fileOverImage.PostedFile.SaveAs(MapPath("./Image/Sale/") + fileName);
					OverImagesDataBind();
				}
				else
				{
					// ޼ 
				}
			}
		}

		private void OverImagesDataBind()
		{
			ArrayList overImages = new ArrayList();
			string[] aImages = Directory.GetFiles(MapPath("./Image/Sale/"), "*.gif");
			foreach (string image in aImages)
			{
				overImages.Add(image.Substring(image.LastIndexOf("\\") + 1));
			}

			aImages = Directory.GetFiles(MapPath("./Image/Sale/"), "*.jpg");
			foreach (string image in aImages)
			{
				overImages.Add(image.Substring(image.LastIndexOf("\\") + 1));
			}

			datlstOverImages.DataSource = overImages;
			datlstOverImages.DataBind();
		}
	}
}
