using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Text;
using System.Drawing.Drawing2D;
using System.Reflection;
using System.IO;

namespace Chapter20
{
	/// <summary>
	/// WebForm2   Դϴ.
	/// </summary>
	public class WebForm2 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstStringPlace;
		//protected System.Web.UI.WebControls.DropDownList drpdnlstStringColors;
		protected System.Web.UI.WebControls.DropDownList drpdnlstStringFonts;
		protected System.Web.UI.WebControls.DropDownList drpdnlstStringFontSize;
		protected System.Web.UI.WebControls.ImageButton ImageButton1;
		protected System.Web.UI.WebControls.DropDownList drpdnlstOverAlpha;
		protected System.Web.UI.WebControls.TextBox txtOverRotate;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RangeValidator RangeValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected System.Web.UI.WebControls.Table tablColors;
		protected System.Web.UI.WebControls.Label lblSelectedColor;
		protected System.Web.UI.WebControls.TextBox txtSelectedColor;
		protected System.Web.UI.WebControls.TextBox txtOverPercent;
		protected System.Web.UI.WebControls.RangeValidator RangeValidator2;
		protected System.Web.UI.WebControls.Button btnSubmit;
		protected System.Web.UI.WebControls.ImageButton imgbtnOver;
		protected System.Web.UI.WebControls.CheckBox chkboxOverHAuto;
		protected System.Web.UI.WebControls.CheckBox chkboxOverVAuto;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnOpenOverManagerWin;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hiddenOverImage;
		protected System.Web.UI.WebControls.LinkButton lnkbtnChangeOverImage;
		protected System.Web.UI.WebControls.Image Image1;
		protected System.Web.UI.WebControls.Image Image2;
		protected System.Web.UI.WebControls.TextBox txtAppendString;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				//ArrayList aColors = new ArrayList();
				Type colorType = typeof(Color);
				PropertyInfo[] aColorPropInfo = colorType.GetProperties();
				TableRow row = null;
				int count = 0;
				int length = aColorPropInfo.Length;
				foreach (PropertyInfo propInfo in aColorPropInfo)
				{
					if (propInfo.PropertyType.Name == "Color")
					{
						//aColors.Add(propInfo.Name);

						if (count % 15 == 0)
						{
							row = new TableRow();
							tablColors.Rows.Add(row);
						}

						TableCell cell = new TableCell();
						cell.Width = 7;
						cell.Height = 7;
						cell.BackColor = Color.FromName(propInfo.Name);
						cell.Attributes["onclick"] = "document.all['" + lblSelectedColor.ClientID + "']" + 
							".style.backgroundColor=this.style.backgroundColor;" +
							"document.all['" + txtSelectedColor.ClientID  + "']" + 
							".value='" + propInfo.Name + "'";
						
						//cell.Controls.Add(new LiteralControl(" "));
						if (count == length - 1)
							cell.ColumnSpan = count % 15;

						row.Cells.Add(cell);
						count++;
					}
				}
				//drpdnlstStringColors.DataSource = aColors;
				//drpdnlstStringColors.DataBind();

				InstalledFontCollection installedFontCollection = new InstalledFontCollection();
				FontFamily[] fontFamilies = installedFontCollection.Families;
				ArrayList aFonts = new ArrayList();

				foreach(FontFamily fontInfo in fontFamilies)
				{
					aFonts.Add(fontInfo.Name);
				}
				drpdnlstStringFonts.DataSource = aFonts;
				drpdnlstStringFonts.DataBind();

				for (int i=5;i<50; i++)
					drpdnlstStringFontSize.Items.Add(i.ToString());

				drpdnlstStringFontSize.SelectedIndex = 10;

				for (int i=1;i<=100; i++)
					drpdnlstOverAlpha.Items.Add(i.ToString());

				drpdnlstOverAlpha.SelectedIndex = 69;

				btnSubmit.Enabled = false;
				imgbtnOver.Attributes["disabled"] = "true";

				ViewState["overStringPosXY"] = new int[] {-1,-1};
				ViewState["overStringMethod"] = 1;

				//ViewState["overImage"] = "Over1.gif";
				hiddenOverImage.Value = "Over1.gif";

				btnOpenOverManagerWin.Disabled = true;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.imgbtnOver.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtnOver_Click);
			this.btnSubmit.Click += new System.EventHandler(this.btnSubmit_Click);
			this.ImageButton1.Click += new System.Web.UI.ImageClickEventHandler(this.ImageButton1_Click);
			this.lnkbtnChangeOverImage.Click += new System.EventHandler(this.lnkbtnChangeOverImage_Click);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);

		}
		#endregion


		private void ImageButton1_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			Apply(1);
			btnSubmit.Enabled = true;
			btnOpenOverManagerWin.Disabled = false;
			imgbtnOver.Attributes.Remove("disabled");
		}

		private void btnSubmit_Click(object sender, System.EventArgs e)
		{
			Apply(2);
		}

		private void imgbtnOver_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			Apply(3);
		}

		private void lnkbtnChangeOverImage_Click(object sender, System.EventArgs e)
		{
			imgbtnOver.ImageUrl = "./Image/Sale/" + hiddenOverImage.Value;
			Apply(2);
		}

		private void Apply(int buttonNum)
		{
			string percentStr = "25";
			string appendString = txtAppendString.Text; 
			int stringPlace = int.Parse(rdobtnlstStringPlace.SelectedItem.Value); 
			string stringColor = txtSelectedColor.Text; 
			string stringFont = drpdnlstStringFonts.SelectedItem.Value;
			string stringSize = drpdnlstStringFontSize.SelectedItem.Value;
			string overImage = hiddenOverImage.Value;
			int[] overXY = null;
			int[] overStringPosXY;
			bool overStringHAuto = chkboxOverHAuto.Checked;
			bool overStringVAuto = chkboxOverVAuto.Checked;
			int overRotate;
			int overAlpha;
			int overPercent;

			if (buttonNum == 1)
			{
				overXY = Request.MapImageCoordinates(ImageButton1.UniqueID);
				overStringPosXY = (int[])ViewState["overStringPosXY"];
			}
			else if (buttonNum == 2)
			{
				overXY = (int[])ViewState["overXY"];
				overStringPosXY = (int[])ViewState["overStringPosXY"];
			}
			else
			{
				overXY = (int[])ViewState["overXY"];
				overStringPosXY = Request.MapImageCoordinates(imgbtnOver.UniqueID);
			}

			try 
			{
				overRotate = int.Parse(txtOverRotate.Text);
			}
			catch 
			{
				overRotate = 0;
			}

			try 
			{
				overAlpha = int.Parse(drpdnlstOverAlpha.SelectedItem.Value);
			}
			catch 
			{
				overAlpha = 100;
			}

			try 
			{
				overPercent = int.Parse(txtOverPercent.Text);
			}
			catch 
			{
				overPercent = 100;
			}

			/*
			if (fileOverImage.PostedFile.FileName != String.Empty)
			{
				string fileName = fileOverImage.PostedFile.FileName;
				overImage = fileName.Substring(fileName.LastIndexOf("\\"));
				fileOverImage.PostedFile.SaveAs(MapPath("./Image/Sale/" + overImage));
			}
			*/

			// ̹ ĳϰֱ  ̹ 
			//̸ ٲ Ŭ̾Ʈ ĵ ̹ µȴ.
			string imgName = DateTime.Now.Ticks.ToString();
			ImageButton1.ImageUrl = "CompositionImage" + imgName + "_0.gif";
			Image1.ImageUrl = "CompositionImage" + imgName + "_1.gif";
			Image2.ImageUrl = "CompositionImage" + imgName + "_2.gif";

			GenerateImage(percentStr, appendString, stringPlace, 
				stringColor, stringFont, stringSize, overImage, 
				overXY, overRotate, overAlpha, overPercent, 
				overStringPosXY, overStringHAuto, overStringVAuto, imgName);

			ViewState["overStringHAuto"] = overStringHAuto;
			ViewState["overStringVAuto"] = overStringVAuto;
			ViewState["overStringPosXY"] = overStringPosXY;
			ViewState["overXY"] = overXY;
		}

		private void GenerateImage(string percentStr, string appendString, 
			int stringPlace, string stringColor, string stringFont, 
			string stringSize, string overImage, int[] overXY, 
			int overRotate, int overAlpha, int overPercent, 
			int[] overStringPosXY, bool overStringHAuto, bool overStringVAuto, 
			string resultImageName)
		{
			//Bitmap oBaseImage = new Bitmap(Page.MapPath("./Image/ProdImgL_00001.jpg"));
			Bitmap oBaseImage = new Bitmap(Page.MapPath("./Image/SampleBaseL.jpg"));

			Bitmap oOverImage = new Bitmap(Page.MapPath("./Image/Sale/" + overImage));

			//float overSizeRatio = (float)oOverImage.Width / (float)oBaseImage.Width * 100;
			int orgSize = oBaseImage.Width;


			string[] aBaseImages = new string[3];
			//aBaseImages[0] = "ProdImgL_00001.jpg";
			aBaseImages[0] = "SampleBaseL.jpg";
			aBaseImages[1] = "ProdImgM_00004.jpg";
			aBaseImages[2] = "ProdImgS_00010.jpg";
			for (int i=0; i<3; i++)
			{
				oBaseImage = new Bitmap(Page.MapPath("./Image/" + aBaseImages[i]));
				Graphics oGraphics = Graphics.FromImage( oBaseImage );

				//oGraphics.ResetTransform();

				//GraphicsContainer oGraphicsContainer = oGraphics.BeginContainer();

				//콺 ǥ  ̹  ó ̹
				// Ѵ.
				//̷ ؾ ̹ ũⰡ ٲ  µȴ.
				float scaleValue1 = (float)oBaseImage.Width / (float)orgSize;
				oGraphics.ScaleTransform(scaleValue1, scaleValue1, MatrixOrder.Append);

				float scaleValue2 = (float)overPercent / 100;
				oGraphics.ScaleTransform(scaleValue2, scaleValue2, MatrixOrder.Append);

				int coordinateX = (int)(overXY[0] * scaleValue1);
				int coordinateY = (int)(overXY[1] * scaleValue1);

				//oGraphics.TranslateTransform(overXY[0], overXY[1], MatrixOrder.Append);
				oGraphics.TranslateTransform(coordinateX, coordinateY, MatrixOrder.Append);

				ColorMatrix myColorMatrix = new ColorMatrix();
				myColorMatrix.Matrix00 = 1.00f; // Red
				myColorMatrix.Matrix11 = 1.00f; // Green
				myColorMatrix.Matrix22 = 1.00f; // Blue
				myColorMatrix.Matrix33 = ((float)overAlpha / 100); // alpha
				myColorMatrix.Matrix44 = 1.00f; // w

				// Create an ImageAttributes object and set the color matrix.
				ImageAttributes imageAttr = new ImageAttributes();
				imageAttr.SetColorMatrix(myColorMatrix);

				Color lowerColor = Color.FromArgb(255,255,255);
				Color upperColor = Color.FromArgb(255,255,255);
				imageAttr.SetColorKey(lowerColor, upperColor);

				//Bitmap oOverImage = new Bitmap(Page.MapPath("ProdImgS_00010.jpg"));
				//Bitmap oOverImage = new Bitmap(Page.MapPath("./Image/Sale/" + overImage));

				oGraphics.RotateTransform(overRotate, MatrixOrder.Append);

				oGraphics.CompositingMode = CompositingMode.SourceOver;
				Rectangle rectImg = new Rectangle(0, 0, oOverImage.Width, oOverImage.Height);
				oGraphics.DrawImage(oOverImage,         // Image
					rectImg,            // Dest. rect.
					0,               // srcX
					0,               // srcY
					oOverImage.Width,             // srcWidth
					oOverImage.Height,             // srcHeight
					GraphicsUnit.Pixel, // srcUnit
					imageAttr);      // ImageAttributes

				FontFamily fontFamily = new FontFamily(stringFont);
				Font font = new Font(
					fontFamily,
					int.Parse(stringSize), FontStyle.Bold,
					GraphicsUnit.Pixel);

				//overStringHAuto, overStringVAuto
				StringFormat stringFormat = new StringFormat();
				int rectStrX = 0;
				int rectStrY = 0;
				if (overStringPosXY[0] != -1 && !overStringHAuto)
					rectStrX = overStringPosXY[0];
				else // Center each line of text.
					stringFormat.Alignment = StringAlignment.Center;

				if (overStringPosXY[1] != -1 && !overStringVAuto)
					rectStrY = overStringPosXY[1];
				else // Center the block of text (top to bottom) in the rectangle.
					stringFormat.LineAlignment = StringAlignment.Center;

				//overStringPosXY, overStringMethod
				Rectangle rectStr = new Rectangle(rectStrX, rectStrY, oOverImage.Width, oOverImage.Height);
				SolidBrush solidBrush = new SolidBrush(Color.FromName(stringColor));

				string text = stringPlace == 1 ? appendString + percentStr : percentStr + appendString;
				oGraphics.DrawString(text, font, solidBrush, rectStr, stringFormat);

				//oGraphics.EndContainer(oGraphicsContainer);

				string [] files = Directory.GetFiles(MapPath("./"), "CompositionImage*" + "_" + i + ".gif");
				foreach (string file in files)
					File.Delete(file);
			
				oBaseImage.Save(Page.MapPath("CompositionImage" + resultImageName + "_" + i + ".gif"), ImageFormat.Gif);

				oGraphics.Dispose();
			}
			
			oOverImage.Dispose();
			oBaseImage.Dispose();
		}

		private void Page_PreRender(object sender, System.EventArgs e)
		{
			if (IsPostBack)
			{
				lblSelectedColor.BackColor = Color.FromName(txtSelectedColor.Text);

				Type colorType = typeof(Color);
				PropertyInfo[] aColorPropInfo = colorType.GetProperties();
				TableRow row = null;
				int count = 0;
				int length = aColorPropInfo.Length;
				foreach (PropertyInfo propInfo in aColorPropInfo)
				{
					if (propInfo.PropertyType.Name == "Color")
					{
						if (count % 15 == 0)
						{
							row = new TableRow();
							tablColors.Rows.Add(row);
						}

						TableCell cell = new TableCell();
						cell.Width = 7;
						cell.Height = 7;
						cell.BackColor = Color.FromName(propInfo.Name);
						cell.Attributes["onclick"] = "document.all['" + lblSelectedColor.ClientID + "']" + 
							".style.backgroundColor=this.style.backgroundColor;" +
							"document.all['" + txtSelectedColor.ClientID  + "']" + 
							".value='" + propInfo.Name + "'";
						
						if (count == length - 1)
							cell.ColumnSpan = count % 15;

						row.Cells.Add(cell);
						count++;
					}
				}
			}
		}



		/*
		private void GenerateImage()
		{
			string userName = "׽Ʈ ڿ";
			Bitmap oBaseImage = new Bitmap(Page.MapPath("ProdImgL_00001.jpg"));
			Graphics oGraphics = Graphics.FromImage( oBaseImage );

			//SolidBrush backBrush = new SolidBrush(Color.White);
			//oGraphics.FillRectangle(backBrush, 0, 0, 400, 400);

			oGraphics.TextRenderingHint = TextRenderingHint.AntiAlias;
			oGraphics.RotateTransform(-20);
			oGraphics.DrawString(userName,new Font("ü", 12.0F, FontStyle.Bold),new SolidBrush(Color.FromArgb(214,209,154)), 10F, 62.0F, new StringFormat());
			//oGraphics.ResetTransform();
			//oGraphics.ScaleTransform(0.5f,0.5f);
			oGraphics.TranslateTransform(50,0,MatrixOrder.Append);
			oGraphics.DrawString(userName,new Font("ü", 12.0F, FontStyle.Bold),new SolidBrush(Color.FromArgb(214,209,154)), 10F, 62.0F, new StringFormat());

		GraphicsContainer oGraphicsContainer = oGraphics.BeginContainer();

		oGraphics.TranslateTransform(160, 220, MatrixOrder.Append);

		ColorMatrix myColorMatrix = new ColorMatrix();
		myColorMatrix.Matrix00 = 1.00f; // Red
		myColorMatrix.Matrix11 = 1.00f; // Green
		myColorMatrix.Matrix22 = 1.00f; // Blue
		myColorMatrix.Matrix33 = 0.7f; // alpha
		myColorMatrix.Matrix44 = 1.00f; // w

		// Create an ImageAttributes object and set the color matrix.
		ImageAttributes imageAttr = new ImageAttributes();
		imageAttr.SetColorMatrix(myColorMatrix);

		Color lowerColor = Color.FromArgb(255,255,255);
		Color upperColor = Color.FromArgb(255,255,255);
		imageAttr.SetColorKey(lowerColor, upperColor);

		//Bitmap oOverImage = new Bitmap(Page.MapPath("ProdImgS_00010.jpg"));
		Bitmap oOverImage = new Bitmap(Page.MapPath("Over2.gif"));

		oGraphics.RotateTransform(-10);

		oGraphics.CompositingMode = CompositingMode.SourceOver;
		Rectangle rectImg = new Rectangle(0, 0, oOverImage.Width, oOverImage.Height);
		oGraphics.DrawImage(oOverImage,         // Image
		rectImg,            // Dest. rect.
		0,               // srcX
		0,               // srcY
		oOverImage.Width,             // srcWidth
		oOverImage.Height,             // srcHeight
		GraphicsUnit.Pixel, // srcUnit
		imageAttr);      // ImageAttributes

		string text = "30% Off";
		FontFamily fontFamily = new FontFamily("");
		Font font = new Font(
			fontFamily,
			14, FontStyle.Bold,
			GraphicsUnit.Point);

		Rectangle rectStr = new Rectangle(0, 18, oOverImage.Width, oOverImage.Height);
		StringFormat stringFormat = new StringFormat();
		SolidBrush solidBrush = new SolidBrush(Color.FromArgb(255, 0, 0, 255));

		// Center each line of text.
		stringFormat.Alignment = StringAlignment.Center;
		// Center the block of text (top to bottom) in the rectangle.
		stringFormat.LineAlignment = StringAlignment.Center;

		oGraphics.DrawString(text, font, solidBrush, rectStr, stringFormat);

		oGraphics.EndContainer(oGraphicsContainer);

			Pen myBlackPen = new Pen(Color.Blue, 1);

			// Draw an ellipse centered at (100, 100).
			oGraphics.TranslateTransform(100, 100);
			oGraphics.DrawEllipse(myBlackPen, -40, -60, 80, 120);

			// Draw the eye at the center of the ellipse.
			DrawEye(oGraphics);

			// Draw an ellipse centered at 200, 100.
			oGraphics.TranslateTransform(100, 0, MatrixOrder.Append);
			oGraphics.DrawEllipse(myBlackPen, -40, -60, 80, 120);

			// Rotate the eye 40 degrees, and draw it 30 units above
			// the center of the ellipse.
			oGraphicsContainer = oGraphics.BeginContainer();
			oGraphics.RotateTransform(-40);
			oGraphics.TranslateTransform(0, -30, MatrixOrder.Append);
			DrawEye(oGraphics);
			oGraphics.EndContainer(oGraphicsContainer);

			// Draw an ellipse centered at (300, 100).
			oGraphics.TranslateTransform(100, 0, MatrixOrder.Append);
			oGraphics.DrawEllipse(myBlackPen, -40, -60, 80, 120);

			// Stretch and rotate the eye, and draw it at the 
			// center of the ellipse.
			oGraphicsContainer = oGraphics.BeginContainer();
			oGraphics.ScaleTransform(2, 1.5f);
			oGraphics.RotateTransform(45, MatrixOrder.Append);
			DrawEye(oGraphics);
			oGraphics.EndContainer(oGraphicsContainer);


		//oBaseImage.Save( "C:\\Welcome.gif", ImageFormat.Gif );
		oBaseImage.Save( Response.OutputStream, ImageFormat.Jpeg);
		oBaseImage.Save( MapPath("Result.jpg"), ImageFormat.Jpeg);
			
		oGraphics.Dispose();
		oBaseImage.Dispose();
	}
	*/
		/*
		private void DrawEye(Graphics myGraphics)
		{
			GraphicsContainer eyeContainer;

			eyeContainer = myGraphics.BeginContainer();

			Pen myBlackPen = new Pen(Color.Black);
			SolidBrush myGreenBrush = new SolidBrush(Color.Green);
			SolidBrush myBlackBrush = new SolidBrush(Color.Black);

			GraphicsPath myTopPath = new GraphicsPath();
			myTopPath.AddEllipse(-30, -50, 60, 60);

			GraphicsPath myBottomPath = new GraphicsPath();
			myBottomPath.AddEllipse(-30, -10, 60, 60);

			Region myTopRegion = new Region(myTopPath);
			Region myBottomRegion = new Region(myBottomPath);

			// Draw the outline of the eye.
			// The outline of the eye consists of two ellipses.
			// The top ellipse is clipped by the bottom ellipse, and
			// the bottom ellipse is clipped by the top ellipse.
			myGraphics.Clip = myTopRegion;
			myGraphics.DrawPath(myBlackPen, myBottomPath);
			myGraphics.Clip = myBottomRegion;
			myGraphics.DrawPath(myBlackPen, myTopPath);

			// Fill the iris.
			// The iris is clipped by the bottom ellipse.
			myGraphics.FillEllipse(myGreenBrush, -10, -15, 20, 22);

			// Fill the pupil.
			myGraphics.FillEllipse(myBlackBrush, -3, -7, 6, 9);

			myGraphics.EndContainer(eyeContainer);
		}
		*/
	}
}
