using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Validators
{
	[ToolboxData("<{0}:SimpleCustomValidator1 runat=server ErrorMessage=\"SimpleCustomValidator1\"></{0}:SimpleCustomValidator1>")]
	public class SimpleCustomValidator1 : SimpleBaseValidator1
	{
		public event ServerValidateEventHandler ServerValidate;

		protected override bool EvaluateIsValid() 
		{
			string controlValue = GetControlValidationValue(ControlToValidate);
			if (controlValue == null)
				throw new Exception("ControlToValidate  Ʈѿ ȿ ˻縦   ϴ.");

			ServerValidateEventArgs eventArgs = new ServerValidateEventArgs(controlValue, this.IsValid);

			if (ServerValidate != null)	{
				ServerValidate(this, eventArgs);
				return eventArgs.IsValid;
			}
			else
				return true;
		} 
	}
}
