using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace PowerOfExam.CDO_Exam
{
	public class CdoSeneMail : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtTo;
		protected System.Web.UI.WebControls.TextBox txtFrom;
		protected System.Web.UI.WebControls.TextBox txtSubject;
		protected System.Web.UI.WebControls.Button btnSend;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstBodyCreationMethod;
		protected System.Web.UI.WebControls.TextBox txtBody;
	
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{
			this.btnSend.Click += new System.EventHandler(this.btnSend_Click);
		}
		#endregion

		private void btnSend_Click(object sender, System.EventArgs e)
		{
			CDO.IMessage iMsg = new CDO.MessageClass();
			CDO.IConfiguration iConfig = new CDO.ConfigurationClass();

			ADODB.Fields Flds = iConfig.Fields;

			Flds[CDO.CdoConfiguration.cdoSendUsingMethod].Value = CDO.CdoSendUsing.cdoSendUsingPickup;
			//Flds[CDO.CdoConfiguration.cdoSMTPServer].Value = "kornet.net";
			Flds[CDO.CdoConfiguration.cdoSMTPServer].Value = "";
			Flds.Update();

			iMsg.Configuration = (CDO.Configuration)iConfig;

			iMsg.To = txtTo.Text;
			iMsg.From = txtFrom.Text;
			iMsg.Subject = txtSubject.Text;

			if (rdobtnlstBodyCreationMethod.SelectedIndex == 0)
				iMsg.CreateMHTMLBody(txtBody.Text, CDO.CdoMHTMLFlags.cdoSuppressAll, "", "");
			else
				iMsg.HTMLBody = txtBody.Text;
			
			iMsg.Send();	
	
			Response.Write(" Ͽϴ.<br>");

		}
	}
}
