namespace PowerOfDotNet.Home
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		UserInfoView   Դϴ.
	/// </summary>
	public abstract class UserInfoView : PortalModuleControlEx
	{
		protected PowerOfDotNet.Avatar.AvatarPlugIn AvatarPlugIn1;
		protected System.Web.UI.WebControls.PlaceHolder PlaceHolder1;
		protected System.Web.UI.WebControls.PlaceHolder PlaceHolder2;

		protected string _recivedNewMailCount = "";
		protected string _newMessageCount = "";

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (Request.IsAuthenticated) 
			{
				string userId = Page.User.Identity.Name;
				AvatarPlugIn1.UserID = userId;
				AvatarPlugIn1.ViewFrame = false.ToString();
				AvatarPlugIn1.Position = "";
				AvatarPlugIn1.OnClick = "window.location.href='" + GetLink("ƹŸ") + "'";

				Components.WebmailDB dbWebmail = new Components.WebmailDB();
				_recivedNewMailCount = dbWebmail.GetUserNetYetReadMailCount(userId, 0).ToString();

				Components.MyPageDB dbMyPage = new Components.MyPageDB();
				_newMessageCount = dbMyPage.GetDateContent(userId).ToString();

				PlaceHolder1.Visible = false;
				PlaceHolder2.Visible = true;
			}
			else {
				PlaceHolder1.Visible = true;
				PlaceHolder2.Visible = false;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
