Imports System
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.OleDb
Imports System.Configuration

Namespace MyDalApp

	Public Class MyWebForm : Inherits Page

		Protected mySqlGrid As DataGrid
		Protected myOleDbGrid As DataGrid
		
		Protected Sub Page_Load(sender As object, e As EventArgs)
		
			'Create an instance of the DAL object
			Dim uDal As New UniversalDAL()

			'Create a SqlConnection
			Dim sqlCon As New SqlConnection(ConfigurationSettings.AppSettings("NorthwindProdConString"))
			'Call GetData() passing in a SqlConnection
			mySqlGrid.DataSource = uDal.GetData(sqlCon, "SELECT TOP 5 * FROM Customers")
			mySqlGrid.DataBind()
			sqlCon.Close()
			
			'Create an OleDbConnection
			Dim oledbCon As New OleDbConnection(ConfigurationSettings.AppSettings("NorthwindDevConString"))
			'Call GetData() passing in an OleDbConnection
			myOleDbGrid.DataSource = uDal.GetData(oledbCon, "SELECT TOP 5 * FROM Products")
			myOleDbGrid.DataBind()
			oledbCon.Close()
		End Sub
	End Class
End Namespace