namespace PowerOfDotNet.NewStudy.DownloadBoard
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using PowerOfDotNet.TypedDataSet;

	/// <summary>
	///		Content   Դϴ.
	/// </summary>
	public abstract class Content : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.HyperLink LinkToFile;

		protected string _ID;
		protected string _WriterID;
		protected string _WriterName;
		protected string _Subject;
		protected string _FilePath;
		protected string _Language;
		protected string _RatingImgPath;
		protected string _VoteCount;
		protected string _CommentCount;
		protected string _Description;
		protected System.Web.UI.WebControls.Label ContentID;
		protected string _RegDate;
		protected string _DownloadCount;
		protected string _Target;
		protected string _Page;

		private string[] languages = new string[] {"C#.NET", "VB.NET", "Managed C++", "Mixed"};
		private string[] targets = new string[] {"ʱ", "߱", ""};

		//private string _fileDir;
		protected System.Web.UI.WebControls.HyperLink hyplnkEdit;
		protected System.Web.UI.WebControls.LinkButton lnkbtnDelete;
		private string _returnParams;
		protected System.Web.UI.HtmlControls.HtmlAnchor anchorImitationDelete;

		private string DownloadDeleteConfirmScript = @"
<SCRIPT LANGUAGE=""JavaScript"">
<!--
function _PowerOf_DownloadDeleteConfirm(id)
{{
		if (window.confirm(""Խù  Ͻðڽϱ?""))
			__doPostBack(id,'');
}}
//-->
</SCRIPT>
";

		public ContentData content
		{
			set
			{
				_ID = value.ID;
				ViewState["ID"] = _ID;
				_WriterID = value.WriterID;
				_WriterName = value.WriterName;
				_Subject = Server.HtmlEncode(value.Subject);
				_FilePath = "GetDownloadFile.ashx?id=" + _ID + "&file=" + value.FilePath + "&bypass=true";
				_Language = languages[value.Language];
				_Target = targets[value.Target];
				_RatingImgPath = "Rate" + value.Rating + ".gif";
				_VoteCount = value.VoteCount;
				_CommentCount = value.CommentCount;
				//_Description = Server.HtmlEncode( value.Description.Replace("\n","<br>") );
				_Description = value.Description.Replace("\n","<br>");
				_RegDate = value.RegDate;
				_DownloadCount = value.DownloadCount;
			}
		}

		public string ReturnParams
		{
			set
			{
				_returnParams = value;
			}
			get
			{
				return _returnParams;
			}
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			//PreLander  ۾ Ѵ.
			//⼭ϸ 絥 ۵ ʴ´.
		}

		private void Page_PreLander(object sender, System.EventArgs e)
		{
			if (this.Page.User.Identity.Name == _WriterID.Trim())// || 
				//PowerOfDotNet.PortalSecurity.IsInRoles(_blInfo.BBSRoles))
			{
				if (!IsPostBack)
				{
					//DownloadList.ascx this.DataBind(); ȣϱ⶧ 
					//⼭ Ʒ  ʿ.
					//this.DataBind();
					hyplnkEdit.NavigateUrl = GetLink("ڷǱۼ") + "&id=" + _ID;
				}
				else
				{
					hyplnkEdit.NavigateUrl = GetLink("ڷǱۼ") ;
				}
				//ũƮ  lnkbtnDelete ̺Ʈ ȣϴ Լ 
				DownloadDeleteConfirmScript = String.Format(DownloadDeleteConfirmScript, this.Page.GetPostBackEventReference(lnkbtnDelete, ""));
				this.Page.RegisterClientScriptBlock("DownloadDeleteConfirmScript", DownloadDeleteConfirmScript);

				anchorImitationDelete.Attributes["href"] = "javascript:_PowerOf_DownloadDeleteConfirm('" + lnkbtnDelete.UniqueID + "')";
			}
			else
			{
				anchorImitationDelete.Disabled = true;
				hyplnkEdit.NavigateUrl = "";
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//

			//ٿε   ͸ Ѵ.
			//_fileDir = this.MapPath("/NewStudy/DownloadBoard/UploadFiles/");
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.lnkbtnDelete.Command += new System.Web.UI.WebControls.CommandEventHandler(this.lnkbtnDelete_Command);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreLander);

		}
		#endregion


		private void lnkbtnDelete_Command(object sender, System.Web.UI.WebControls.CommandEventArgs e)
		{
			//int id = Convert.ToInt32(e.CommandArgument);
			int id = Convert.ToInt32(ViewState["ID"]);

			PowerOfDotNet.Components.DownloadDB db = new PowerOfDotNet.Components.DownloadDB();
			DownloadDS od = (DownloadDS)this.GetObjectFromCache("DownloadDS");
			if (od == null)
			{
				od = db.CreateDownloadDS();
				this.SetObjectToCache("DownloadDS", od, 30);
			}

			int result = db.DeleteUpload(od, id);
			if (result == -1)
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" Ͱ־  ϴ.");
				return;
			}
		}

	}

	public class ContentData
	{
		public string ID;
		public string WriterID;
		public string WriterName;
		public string Subject;
		public string FilePath;
		public int Language;
		public int Target;
		public string Rating;
		public string VoteCount;
		public string CommentCount;
		public string Description;
		public string Catagory;
		public string RegDate;
		public string DownloadCount;
	}
}
