using System;
using System.Web;
using System.Data;
using System.Data.SqlClient;
using System.Collections;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Text;

namespace PowerOfDotNet.Components
{
	/// <summary>
	/// PortalUtil   Դϴ.
	/// </summary>
	public class PortalUtil
	{
		public static string GetLink(string pageName){
			Hashtable allPagesInfo = new Hashtable();

			AdminDB db = new AdminDB();
			SqlDataReader dr = db.GetPages();

			while (dr.Read()) 
			{
				int[] aPageInfo = new int[2] { dr.GetInt32(1), dr.GetInt32(2)};

				allPagesInfo[dr.GetString(0)] = aPageInfo;
			}
			dr.Close();

			object oTmp = allPagesInfo[pageName];
			if (oTmp == null)
				throw new ArgumentException(pageName + "  ϴ.");

			int[] aInfo = (int[])oTmp;
			string param = "psup=tabid=" + aInfo[0] + ":pageid=" + aInfo[1];

			return "/DesktopDefault.aspx?" + param;
		}

		public static void MakeWelcomeImage(string userName, string userDir)
		{
			try
			{
				Bitmap oBaseImage = new Bitmap(HttpContext.Current.Request.MapPath("/User/images/Welcome.gif") );
				Bitmap oResult = new Bitmap(oBaseImage.Size.Width, oBaseImage.Size.Height);
				Graphics oGraphics = Graphics.FromImage( oResult );
				oGraphics.DrawImageUnscaled(oBaseImage, 0, 0, oBaseImage.Size.Width, oBaseImage.Size.Height);
				
				oGraphics.TextRenderingHint = TextRenderingHint.AntiAlias;
				oGraphics.RotateTransform(-20);
				oGraphics.DrawString(userName,new Font("ü", 12.0F, FontStyle.Bold),new SolidBrush(Color.FromArgb(214,209,154)), 46.0F, 62.0F, new StringFormat());
				oGraphics.ResetTransform();
				oGraphics.RotateTransform(12);
				oGraphics.DrawString(userName,new Font("ü", 12.0F, FontStyle.Bold),new SolidBrush(Color.FromArgb(128,117,0)), 68.0F, 8.0F, new StringFormat());

				oResult.Save( userDir + "\\Welcome.gif", ImageFormat.Gif );
				oGraphics.Dispose();
				oBaseImage.Dispose();
				oResult.Dispose();
			}
			catch (	Exception err)
			{
				string s = err.Message;
			}
		}

		/*
		public static string GetModuleCacheKey()
		{
			return "Key:" + this.GetType().ToString() + this.ModuleId + PortalSecurity.IsInRoles(_moduleConfiguration.AuthorizedEditRoles);
		}
		*/
	}
}
