using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace PowerOfDotNet.Avatar.EditModules
{
	/// <summary>
	/// WriteItem   Դϴ.
	/// </summary>
	public class WriteItem : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox txtItemName;
		protected System.Web.UI.WebControls.LinkButton lnkbtnUpdate;
		protected System.Web.UI.WebControls.CheckBoxList chkboxlstDependPosition;
		protected System.Web.UI.WebControls.DropDownList drpdnlstCategory;
		protected System.Web.UI.WebControls.TextBox txtCost;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstSex;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstFrontLayerPos;
		protected System.Web.UI.WebControls.CheckBox chkboxBackImage;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator3;
		protected System.Web.UI.WebControls.RegularExpressionValidator RegularExpressionValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator4;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstBackLayerPos;
		protected System.Web.UI.HtmlControls.HtmlInputFile fileFrontImage;
		protected System.Web.UI.HtmlControls.HtmlInputFile fileBackImage;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator5;
		protected System.Web.UI.WebControls.TextBox txtThumbnailImage;
		protected System.Web.UI.WebControls.DropDownList drpdnlstPosition;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				MyWebLibs.Utilities.CommonMethods.GetForm(this).Enctype = "multipart/form-data";

				PowerOfDotNet.Components.AvatarDB db = new PowerOfDotNet.Components.AvatarDB();

				drpdnlstPosition.DataSource = db.GetPositions();;
				drpdnlstPosition.DataTextField = "Description";
				drpdnlstPosition.DataValueField = "PositionID";
				drpdnlstPosition.DataBind();

				chkboxlstDependPosition.DataSource = db.GetPositions();;
				chkboxlstDependPosition.DataTextField = "Description";
				chkboxlstDependPosition.DataValueField = "PositionID";
				chkboxlstDependPosition.DataBind();

				drpdnlstCategory.DataSource = db.GetCategory();
				drpdnlstCategory.DataTextField = "Subject";
				drpdnlstCategory.DataValueField = "ID";
				drpdnlstCategory.DataBind();

				ViewState["ReturnUri"] = Request.UrlReferrer.AbsolutePath;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.lnkbtnUpdate.Click += new System.EventHandler(this.lnkbtnUpdate_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void lnkbtnUpdate_Click(object sender, System.EventArgs e)
		{
			int positionID = int.Parse(drpdnlstPosition.SelectedItem.Value);
			int categoryID = int.Parse(drpdnlstCategory.SelectedItem.Value);

			if (txtCost.Text.Trim() == "")
				txtCost.Text = "0";
			//fileFrontImage.
			PowerOfDotNet.Components.AvatarDB db = new PowerOfDotNet.Components.AvatarDB();
			int result = db.AddItem(txtItemName.Text, Convert.ToInt32(drpdnlstPosition.SelectedItem.Value), 
				chkboxlstDependPosition.Items ,Convert.ToInt32(drpdnlstCategory.SelectedItem.Value),
				Convert.ToInt32(txtCost.Text), txtThumbnailImage.Text,rdobtnlstSex.SelectedIndex, fileFrontImage,
				rdobtnlstFrontLayerPos.SelectedIndex, fileBackImage, rdobtnlstBackLayerPos.SelectedIndex);

			//if (result == 1)

			Response.Redirect(ViewState["ReturnUri"].ToString());
		}
	}
}
