using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

namespace PowerOfDotNet.Components
{
	/// <summary>
	/// UserDB   Դϴ.
	/// </summary>
	public class UserDB
	{
		public UserDB()
		{
		}

		public string GetUserDir(string userId)
		{
			SqlConnection myConnection = new SqlConnection(ConfigurationSettings.AppSettings["connectionString"]);
			SqlCommand myCommand = new SqlCommand("GetUserDir", myConnection);
			
			myCommand.CommandType = CommandType.StoredProcedure;

			myCommand.Parameters.Add(new SqlParameter("@UserID", SqlDbType.VarChar, 12)).Value = userId;

			string userDir = String.Empty;
			myConnection.Open();
			SqlDataReader dr = myCommand.ExecuteReader();
			if (dr.Read())
				userDir = dr.GetString(0);
			dr.Close();
			myConnection.Close();

			return userDir;
		}
	}
}
