namespace PowerOfDotNet.WebMail
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.Mail;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Text;
	using System.IO;
	using System.Configuration;

	public abstract class WebmailWriteMail : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.TextBox txtSubject;
		protected System.Web.UI.WebControls.TextBox txtMessage;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstFromat;
		protected System.Web.UI.WebControls.CheckBox chkboxUseAvatar;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstAvatarExp;
		protected System.Web.UI.WebControls.ListBox lstboxAttached;
		protected System.Web.UI.HtmlControls.HtmlInputFile fileAttach;
		protected System.Web.UI.WebControls.CheckBox chkboxSaveSentBox;
		protected System.Web.UI.WebControls.Button btnFileAttach;
		protected System.Web.UI.WebControls.Button btnSend;
		protected System.Web.UI.WebControls.TextBox txtCC;
		protected System.Web.UI.WebControls.TextBox txtBcc;
		protected System.Web.UI.WebControls.Button btnFileDelete;
		protected System.Web.UI.WebControls.Label lblUploadedSize;
		protected System.Web.UI.WebControls.DropDownList drpdnlstAddrBookTo;
		protected System.Web.UI.WebControls.DropDownList drpdnlstAddrBookCc;
		protected System.Web.UI.WebControls.DropDownList drpdnlstAddrBookBcc;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator3;
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;
		protected System.Web.UI.WebControls.TextBox txtTo;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!this.IsPostBack)
			{
				string mode = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["mode"], String.Empty);
				if (mode != String.Empty)
					txtTo.Text = Server.HtmlDecode(Server.UrlDecode(MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["to"], String.Empty)));
				
				if (mode == "reply") //̸
				{
					txtSubject.Text = "[Re]" + Server.UrlDecode(MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["subject"], String.Empty));
				}

				PowerOfDotNet.Components.AvatarDB dbAvatar = new PowerOfDotNet.Components.AvatarDB();
				// ƹŸ ǥ  ´.
				SqlDataReader drAvatarExp = dbAvatar.GetAvatarExpression();
				rdobtnlstAvatarExp.DataSource = drAvatarExp;
				rdobtnlstAvatarExp.DataTextField = "Description";
				rdobtnlstAvatarExp.DataValueField = "ID";
				rdobtnlstAvatarExp.DataBind();

				PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
				// ּ  ´.
				DataSet ds = db.GetUserAddressBook(this.Page.User.Identity.Name, "Name");

				// ޴  ּ  
				drpdnlstAddrBookTo.DataSource = ds.Tables[0].DefaultView;
				drpdnlstAddrBookTo.DataTextField = "Name";
				drpdnlstAddrBookTo.DataValueField = "Email";
				drpdnlstAddrBookTo.DataBind();
				// ù ׸ 'ּҷ' 
				drpdnlstAddrBookTo.Items.Insert(0, new ListItem("ּҷ", ""));
				// ģ ̸ ϸ  ޴ ּҰ ȴ.
				drpdnlstAddrBookTo.Attributes["onchange"] = 
					"document.getElementById('" + txtTo.ClientID + "').value = " + 
					"document.getElementById('" + drpdnlstAddrBookTo.ClientID + "').options[" + 
					"document.getElementById('" + drpdnlstAddrBookTo.ClientID + "').selectedIndex].value";

				// (cc) ּ  
				drpdnlstAddrBookCc.DataSource = ds.Tables[0].DefaultView;
				drpdnlstAddrBookCc.DataTextField = "Name";
				drpdnlstAddrBookCc.DataValueField = "Email";
				drpdnlstAddrBookCc.DataBind();
				drpdnlstAddrBookCc.Items.Insert(0, new ListItem("ּҷ", ""));
				drpdnlstAddrBookCc.Attributes["onchange"] = 
					"document.getElementById('" + txtCC.ClientID + "').value = " + 
					"document.getElementById('" + drpdnlstAddrBookCc.ClientID + "').options[" + 
					"document.getElementById('" + drpdnlstAddrBookCc.ClientID + "').selectedIndex].value";

				//  (bcc) ּ  
				drpdnlstAddrBookBcc.DataSource = ds.Tables[0].DefaultView;
				drpdnlstAddrBookBcc.DataTextField = "Name";
				drpdnlstAddrBookBcc.DataValueField = "Email";
				drpdnlstAddrBookBcc.DataBind();
				drpdnlstAddrBookBcc.Items.Insert(0, new ListItem("ּҷ", ""));
				drpdnlstAddrBookBcc.Attributes["onchange"] = 
					"document.getElementById('" + txtBcc.ClientID + "').value = " + 
					"document.getElementById('" + drpdnlstAddrBookBcc.ClientID + "').options[" + 
					"document.getElementById('" + drpdnlstAddrBookBcc.ClientID + "').selectedIndex].value";
			}
			
			Form.Enctype = "multipart/form-data";

			btnFileAttach.Attributes["onclick"] = "AttachFileUploadCheck()";
			if (!this.Page.IsStartupScriptRegistered("_WriteMailAttachVarSetup"))
			{
				string writeMailAttachVarSetup = @"
<script language=javascript>
<!--
	fileAttach = document.getElementById('{0}');
	lstboxAttached = document.getElementById('{1}');
//-->
</script>
";
				writeMailAttachVarSetup = String.Format(writeMailAttachVarSetup, 
					fileAttach.ClientID, lstboxAttached.ClientID);
				this.Page.RegisterStartupScript("_WriteMailAttachVarSetup", writeMailAttachVarSetup);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnFileAttach.Click += new System.EventHandler(this.btnFileAttach_Click);
			this.btnFileDelete.Click += new System.EventHandler(this.btnFileDelete_Click);
			this.btnSend.Click += new System.EventHandler(this.btnSend_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		//  Ȯ  HTML ڵ带 Ѵ.
		private string MakeCheckLink(int id)
		{
			string receptionCheckHtml = "<img src=\"http://" + 
				ConfigurationSettings.AppSettings["DomainName"] + 
				"/Webmail/SetReceptionCheck.ashx?id=" + id + 
				"\" height=\"1\" width=\"1\" />";

			return receptionCheckHtml;
		}

		//  ߼Ѵ.
		private void btnSend_Click(object sender, System.EventArgs e)
		{
			string message;
			if (rdobtnlstFromat.SelectedIndex == 0)
				message = Server.HtmlEncode(txtMessage.Text).Replace("\n", "<br>");
			else
				message = txtMessage.Text;

			string userId = Page.User.Identity.Name;
			string myAddr = Request.Cookies["usersInfo"]["Name"].ToString() + " <" + userId + "@" + ConfigurationSettings.AppSettings["DomainName"] + ">";
			string userDir = Request.Cookies["usersInfo"]["UserDir"].ToString();

			PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
			// Ϸ Ͽ  Ȯ ڵ带 DB Ѵ.
			// ȯϴ   ߰ ڵ ID.
			int receptionId = db.AddReceptionCheck(userId, txtSubject.Text, txtTo.Text);

			// Ϸ   
			MailMessage mail = new MailMessage();
			mail.From = myAddr;
			mail.To = txtTo.Text;
			mail.Cc = txtCC.Text;
			mail.Bcc = txtBcc.Text;
			mail.Subject = txtSubject.Text;

			if (chkboxUseAvatar.Checked)
				// 뿡  ƹŸ ÷Ѵ.
				mail.Body = message + "<br>" + AddAvatarToMailBody(rdobtnlstAvatarExp.SelectedIndex) + MakeCheckLink(receptionId);
			else
				mail.Body = message + MakeCheckLink(receptionId);

			mail.BodyFormat = MailFormat.Html;

			//Ͽ ÷ε  
			string filePath = this.MapPath("/User/UserDir/" + 
				userDir + "/" + userId + "/temp_file/");
			string attachedFiles = String.Empty;
			//÷ ũⰡ Ե  ä 
			int mailSize = message.Length;
			 
			//Ͽ ڰ ε ϵ  ÷Ѵ.
			for (int i=1; i<lstboxAttached.Items.Count; i++)
			{
				string file = lstboxAttached.Items[i].Text;
				string fileSize = GetFileSize(lstboxAttached.Items[i].Value);

				//  ÷
				mail.Attachments.Add(new MailAttachment(filePath + file));
				//lstboxAttached  ׸ Value   ũ.
				if (attachedFiles == String.Empty)
					attachedFiles += file + "," + fileSize;
				else
					attachedFiles += ";" + file + "," + fileSize;

				//÷εǴ ϵ ũ⸦   ߰Ѵ.
				try {
					mailSize += Convert.ToInt32(fileSize);
				}
				catch {}
			}
			
			string smtpServer = ConfigurationSettings.AppSettings["SmtpServer"];
			SmtpMail.SmtpServer = smtpServer; 
			// 
			SmtpMail.Send(mail);

			// Կ 
			if (chkboxSaveSentBox.Checked)
			{
				//   ũⰡ Ե  ü  հ
				int totalUserMailSize = db.GetUserMailTotalSize(userId);
				totalUserMailSize += mailSize;

				//ڴ Ҵ  뷮 
				PowerOfDotNet.AdminDB dbAdmin = new PowerOfDotNet.AdminDB();
				int mailLimitSize = Convert.ToInt32(dbAdmin.GetGlobalSetting("MailLimitSize")) * 1024 * 1024;

				// 뷮 ʰǸ
				if (mailLimitSize < totalUserMailSize)
					MyWebLibs.Utilities.CommonMethods.PrintMsgAndRedir(
						" Ͽϴ. \\n\\n" +
						"׷  Ҵ緮 ʰϿ  Կ " + 
						" ߽ϴ.", GetLink("ϸ"));
				else {
					string destDir = this.MapPath("/User/UserDir/" + userDir 
						+ "/" + userId + "/mail_file/");

					//   
					db.AddMail(userId, txtSubject.Text, "", message, 
						txtTo.Text, myAddr, txtCC.Text, txtBcc.Text, 
						mailSize, DateTime.Now.ToString(), 1, 
						attachedFiles, filePath, destDir);
				}
			}

			MyWebLibs.Utilities.CommonMethods.PrintMsgAndRedir(
				" Ͽϴ.",	GetLink("ϸ"));
		}

		// 뿡 ߰ ƹŸ 
		private string AddAvatarToMailBody(int expression)
		{
			if (!Request.IsAuthenticated) 
				return String.Empty;

			string userId = Page.User.Identity.Name;

			string senderAddress = "http://" + ConfigurationSettings.AppSettings["DomainName"];
			string templateHead = @"
				<table cellSpacing=""0"" cellPadding=""0""  border=""0"" >
					<tr>
						<td align=""middle""  id=""cellInner"" runat=""server"">
							<DIV id=""character"" style=""OVERFLOW: hidden; WIDTH: 100%; HEIGHT: 100%""><IMG id=""blankImage"" src=""{0}/Avatar/images/blank.gif"" align=""absMiddle"" border=""0"">
					";

			string templateContent = @"
				<DIV STYLE='position:absolute; left:0; top:0; z-index:{1}'>
				<img id=layerimgl1 src='{0}{2}' border=0 align=absmiddle></DIV>
					";

			string templateTail = @"
							</DIV>
						</td>
					</tr>
				</table>
				";

			StringBuilder avatarBuilder = new StringBuilder();
			avatarBuilder.Append("\n\n"); 
			avatarBuilder.Append(String.Format(templateHead, senderAddress) + "\n");

			PowerOfDotNet.Components.AvatarDB db = new PowerOfDotNet.Components.AvatarDB();

			//ƹŸ   ´.
			SqlDataReader dr = db.GetUserAvater(userId);
			bool dataEmpty = true;

			//   ϴ HTML 
			while (dr.Read())
			{
				string content = String.Format(templateContent,senderAddress, 
					dr["LayerNum"].ToString(), dr["ImageName"].ToString());
				avatarBuilder.Append(content + "\n");
				dataEmpty = false;
			}
			dr.Close();

			//  ƹŸ  
			if (dataEmpty)
			{
				//⺻ ƹŸ 
				dr = db.GetDefaultAvatar();
				while (dr.Read()) {
					string content = String.Format(templateContent,senderAddress, 
						dr["LayerNum"].ToString(), dr["ImageName"].ToString());
					avatarBuilder.Append(content + "\n");
				}
				dr.Close();
			}

			if (expression != 0)
			{
				// ƹŸ ǥ ߰
				SqlDataReader drExp = db.GetAvatarExpressionItem(expression);
				if (drExp.Read()) {
					string content = String.Format(templateContent,senderAddress, 
						drExp["LayerNum"].ToString(), drExp["ImageName"].ToString());
					avatarBuilder.Append(content + "\n");
				}
				drExp.Close();
			}

			avatarBuilder.Append(templateTail + "\n");

			return avatarBuilder.ToString();
		}

		//Ͽ ÷  ̸ εѴ.
		private void btnFileAttach_Click(object sender, System.EventArgs e)
		{
			if (lstboxAttached.Items.Count >= 11) {
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ε ϼ 10  ϴ.");
				return;
			}

			string userId = Page.User.Identity.Name;
			string userDir = Request.Cookies["usersInfo"]["UserDir"].ToString();

			string strFileName = fileAttach.PostedFile.FileName;
			if (strFileName.Trim() == String.Empty)	{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ε  ϼ.");
				return;
			}

			int intFileNameStart = strFileName.LastIndexOf(@"\");
			if (intFileNameStart > 0)
				strFileName = strFileName.Substring(intFileNameStart+1);

			foreach (ListItem item in lstboxAttached.Items)	{
				if (strFileName.ToLower() == item.Text.ToLower()) {
					MyWebLibs.Utilities.CommonMethods.PrintMsgBack(" ̸   ΰ̻   ϴ.");
					return;
				}
			}

			//ڴ Ҵ  뷮 
			PowerOfDotNet.AdminDB dbAdmin = new PowerOfDotNet.AdminDB();
			int mailLimitSize;
			try {
				//mailLimitSize = Convert.ToInt32(ConfigurationSettings.AppSettings["MailLimitSize"]) * 1024 * 1024;
				mailLimitSize = Convert.ToInt32(dbAdmin.GetGlobalSetting("MailLimitSize")) * 1024 * 1024;
			}
			catch {
				mailLimitSize = 20 * 1024 * 1024;
			}

			int selectedFileTotalSize = 0;
			foreach (ListItem item in lstboxAttached.Items)
			{
				try {
					selectedFileTotalSize += Convert.ToInt32(item.Value);
				}
				catch {}
			}

			// Ҵ緮 ʰ˻.
			PowerOfDotNet.Components.WebmailDB dbWebmail = new PowerOfDotNet.Components.WebmailDB();
			int userMailSize = dbWebmail.GetUserMailTotalSize(userId);
			if (userMailSize+selectedFileTotalSize+fileAttach.PostedFile.ContentLength >= mailLimitSize)
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("Ҵ 뷮 ʰϿϴ.");
				return;
			}

			//ε   ͸ Ѵ.
			string filePath = this.MapPath("/User/UserDir/" + userDir 
				+ "/" + userId + "/temp_file/");
			if (!Directory.Exists(filePath))
				Directory.CreateDirectory(filePath);

			//ʿ ϵ Ѵ.
			string [] fileEntries = Directory.GetFiles(filePath);
			foreach(string fileName in fileEntries)
			{
				//ε Ϸ̻   Ѵ.
				if (DateTime.Now.AddDays(-1) > File.GetLastWriteTime(fileName))
					File.Delete(fileName);
			}

			lblUploadedSize.Text = ((fileAttach.PostedFile.ContentLength + selectedFileTotalSize) / 1024).ToString();
			fileAttach.PostedFile.SaveAs(filePath + strFileName);
			lstboxAttached.Items.Add(new ListItem(strFileName, GetNewValue(fileAttach.PostedFile.ContentLength.ToString())));
		}

		// ÷  Ͽ õ  Ѵ.
		private void btnFileDelete_Click(object sender, System.EventArgs e)
		{
			//0 ̸ ƴ϶ ̹Ƿ 
			if (lstboxAttached.SelectedIndex > 0)
			{
				string userId = Page.User.Identity.Name;
				string userDir = Request.Cookies["usersInfo"]["UserDir"].ToString();
				//÷  ӽ÷  ͸ 
				string filePath = MapPath("/User/UserDir/" + userDir 
					+ "/" + userId + "/temp_file/");

				// 
				File.Delete(filePath + lstboxAttached.SelectedItem.Text);
				// ÷  Ͽ õ ׸ 
				lstboxAttached.Items.RemoveAt(lstboxAttached.SelectedIndex);
			}
		}

		private string GetNewValue(string addBValue)
		{
			string val = lstboxAttached.Items[lstboxAttached.Items.Count-1].Value;
			int getlen = val.Length >= 2 ? 2 : 1;
			int index = Convert.ToInt32(val.Substring(0, getlen));
			index++;

			val = (index >= 10 ? "" : "0") + index.ToString();

			return val + addBValue;
		}

		private string GetFileSize(string strFileSize)
		{
			if (strFileSize.Length > 2)
				return strFileSize.Substring(2);
			else
				return String.Empty;
		}
	}
}
